package epe.agents.acquaintances;

	import epe.agents.Agent;
	import epe.agents.agentInterface.AgentInterface;

public class Acquaintance extends Object {
  
	  protected Agent agent;
	  protected BelievedCompetence believedCompetence;
	  protected TrustValue trustValue;  
	      // [0..100], indique la croyance en l'accointance
	      // <50 : l'accointance disparait de l'interface IN/OUT et est plac dans NEUTRAL
	      // <0 : l'agent ne connait plus cette accointance
	  
	  // position de l'agent rfrenc : IN, OUT ou NEUTRAL
	  protected AgentInterface agentInterface;
	  
	  // The multiplicity of the link that might be destroyed i.e the number of outputs
	  // UNIQUE : this agent is the only receiver for the sender
	  // MULTIPLE : this agents' sender has multiple receivers.
	  public static String MULTIPLE = "Multiple";
	  public static String UNIQUE = "Unique";
	  public static String UNKNOWN = "unknown";
	  protected String linkMultiplicity = UNKNOWN;
	  

  public Acquaintance(Agent agent) {
    this.agent = agent;
  }
  
  public void setDefaults() {
    this.believedCompetence = new BelievedCompetence();
    this.trustValue = new TrustValue(new AgentInterface("NEUTRAL"));
    this.agentInterface = new AgentInterface();
  }
  
  public void setBelievedCompetence(BelievedCompetence believedCompetence) {
    this.believedCompetence = believedCompetence;
  }
  
  public void setTrustValue(TrustValue trustValue) {
    this.trustValue = trustValue;
  }
  
  public void setFixedTrustValue(boolean fixedTrustValue) {
    trustValue.setFixedTrustValue(fixedTrustValue);
  }
  
  public void setAgentInterface(AgentInterface agentInterface) {
    this.agentInterface = agentInterface;
  }
  
  public void setAgentInterfaceToNeutral() {
    this.agentInterface = new AgentInterface("NEUTRAL");
  }

  public void setDataType(String dataType) {
    this.agentInterface.setDataType(dataType);
  }
  
  public void decreaseTrustValue(String decreaseType) {
    trustValue.decreaseTrustValue(decreaseType);
  }
  
  public void increaseTrustValue(String increaseType) {
    trustValue.increaseTrustValue(increaseType);
  }
  
  public Agent getAgent() {
    return agent;
  }
  
  public BelievedCompetence getBelievedCompetence() {
    return believedCompetence;
  }
  
  public TrustValue getTrustValue() {
    return trustValue;
  }
  
  public AgentInterface getAgentInterface() {
    return agentInterface;
  }
  
  public String getDataType() {
    return agentInterface.getDataType();
  }
  
  public String getInterfaceType() {
    return agentInterface.getType();
  }
  
  public int getInterfacePosition() {
    return agentInterface.getPosition();
  }
  
  public String getLinkMultiplicity() {
  	return linkMultiplicity;
  }

  public void setLinkMultiplicity(String linkMultiplicity) {
  	this.linkMultiplicity = linkMultiplicity;
  }
  
  public boolean trustingForCooperation() {
    return (trustValue.trustingForCooperation());
  }
  
  public boolean trustingAsAcquaintance() {
    return (trustValue.trustingAsAcquaintance());
  }
  
}