package epe.agents.acquaintances;

	import java.util.Vector;
	
	import epe.gui.GUI;
	import epe.agents.Agent;
	import epe.agents.agentInterface.AgentInterface;

public class Acquaintances extends Vector<Object> {
  
		
	private static final long serialVersionUID = 1L;
	protected GUI gui;
  
  public Acquaintances(GUI gui) {
    this.gui = gui;
    gui.println("Acquaintances created");
  }
  
  public void addAcquaintance(Acquaintance acquaintance) {
    addElement(acquaintance);
  }
  
  public void removeAcquaintance(Acquaintance acquaintance) {
    removeElement(acquaintance);
  }
  
  public Acquaintance getAcquaintance(int pos) {
    return (Acquaintance)elementAt(pos);
  }
  
  public int numberOfNeutralAcquaintances() {
    Vector<Object> pos = findAcquaintance("NEUTRAL");
    return pos.size();
  }
  
// The 6 following methods return a Vector<Object> containing the positions of the found acquaintances
  public Vector<Object> findAcquaintance(Agent agent) {
    Vector<Object> vector = new Vector<Object>();
    for (int i=0; i<size(); i++)
      if (((Acquaintance)elementAt(i)).getAgent().equals(agent)) 
        vector.addElement(new Integer(i));
    return vector;
  }
  
  public Vector<Object> findAcquaintance(Agent agent, String type) {
    Vector<Object> vector = new Vector<Object>();
    for (int i=0; i<size(); i++)
      if (((Acquaintance)elementAt(i)).getAgent().equals(agent)
          && ((Acquaintance)elementAt(i)).getInterfaceType().equals(type)) 
        vector.addElement(new Integer(i));
    return vector;
  }
  
  public Vector<Object> findAcquaintance(BelievedCompetence believedCompetence) {
    Vector<Object> vector = new Vector<Object>();
    for (int i=0; i<size(); i++)
      if (((Acquaintance)elementAt(i)).getBelievedCompetence().equals(believedCompetence))
        vector.addElement(new Integer(i));
    return vector;
  }
  
  public Vector<Object> findAcquaintance(TrustValue trustValue) {
    Vector<Object> vector = new Vector<Object>();
    for (int i=0; i<size(); i++)
      if (((Acquaintance)elementAt(i)).getTrustValue().equals(trustValue))
        vector.addElement(new Integer(i));
    return vector;
  }
  
  public Vector<Object> findAcquaintance(AgentInterface agentInterface) {
    Vector<Object> vector = new Vector<Object>();
    for (int i=0; i<size(); i++) 
      if (((Acquaintance)elementAt(i)).getAgentInterface().equals(agentInterface))
        vector.addElement(new Integer(i));
    return vector;
  }
  
  public Vector<Object> findAcquaintance(String type) {
    Vector<Object> vector = new Vector<Object>();
    for (int i=0; i<size(); i++)
      if (((Acquaintance)elementAt(i)).getAgentInterface().getType().equals(type))
        vector.addElement(new Integer(i));
    return vector;
  }
// End of methods returning Vector<Object>s

  public Acquaintance getAcquaintance(Agent agent, String type) {
    Vector<Object> pos = findAcquaintance(agent, type);
    if (pos.size() == 0)
      return null;
    else {
      int rang = ((Integer)pos.elementAt(0)).intValue();
      return getAcquaintance(rang);
    }
  }
  
  public Acquaintance getAcquaintance(String type, int position) {
    Vector<Object> pos = findAcquaintance(new AgentInterface(type, position));
    if (pos.size() == 0)
      return null;
    else {
      int rang = ((Integer)pos.elementAt(0)).intValue();
      return getAcquaintance(rang);
    }
  }
  
  public boolean isPresentAcquaintance(Acquaintance acquaintance) {
    Vector<Object> positions;
    positions = findAcquaintance(acquaintance.getAgent());
    for (int i=0; i<positions.size(); i++)
      if (((Acquaintance)elementAt(((Integer)positions.elementAt(i)).intValue()))
            .getAgentInterface().equals(acquaintance.getAgentInterface()))
        return true;
    return false;
  }
  
  public Vector<Object> getAllAcquaintances() {
    Vector<Object> vector = new Vector<Object>();
    for (int i=0; i<size(); i++)
      vector.addElement(new Integer(i));
    return vector;
  }
  
  public Vector<Object> getAllNeutralAcquaintances() {
    // get all acquaitances without doubles : IN/OUT acqs are also NEUTRAL
    return findAcquaintance("NEUTRAL");
  }
  
}