package epe.agents.acquaintances;

import epe.gui.SystemPrinter;
import epe.agents.agentInterface.AgentInterface;


public class TrustValue extends Object {

  /*  Valeur de la confiance [0..100]
      value = 0 : on oublie cet agent  */
  protected int value;
  protected int initialInOutValue = 85; // old = 75
  protected int initialNeutralValue = 25;
  protected int maxValue = 100;
  protected int cooperativeValue = 50;
  protected int minValue = 0;
  
  // Decrease Values
  protected int needInOutDecreaseValue = 1; // old = 1
  protected int inadequateDataDecreaseValue = 101; // old = 20
  protected int missingDataDecreaseValue = 20; // old = 20
  protected int uselessnessDecreaseValue = 20;
  protected int blockingSituationDecreaseValue = 25; // 5
  protected int neutralDecreaseValue = 1;
  protected int multipleOutDecreaseValue = 5;
  
  protected int computedFunctionIncreaseValue = 0; // old=1
  protected int maxComputedFunctionPositiveFeedbackThreshold = 75;
  protected boolean fixedTrustValue = false;
  public static boolean FIXEDTRUSTVALUE = true;


  public TrustValue(AgentInterface interfaceType) {
    if (interfaceType.equals(new AgentInterface("NEUTRAL")))
      value = initialNeutralValue;
    else 
      value = initialInOutValue;
  }
  
  public int getValue() {
    return value;
  }
  
  public void setFixedTrustValue(boolean truthValue) {
    fixedTrustValue = truthValue;
  }
  
  public boolean trustingForCooperation() {
    return (value >= cooperativeValue);
  }
  
  public boolean trustingAsAcquaintance() {
    return (value >= minValue);
  }
  
  public boolean equals(TrustValue trustValue) {
    return trustValue.getValue() == value;
  }
  
  public void decreaseTrustValue(String decreaseType) {
    if (!fixedTrustValue)
      if (decreaseType == "needInOut")
        value = value - needInOutDecreaseValue;
      else if (decreaseType == "inadequateData")
        value = value - inadequateDataDecreaseValue;
      else if (decreaseType == "missingData")
        value = value - missingDataDecreaseValue;
      else if (decreaseType == "uselessness")
        value = value - uselessnessDecreaseValue;
      else if (decreaseType == "blockingSituation")
        value = value - blockingSituationDecreaseValue;
			else if (decreaseType == "neutral")
				value = value - neutralDecreaseValue;
			else if (decreaseType == "multipleOut")
				value = value - multipleOutDecreaseValue;
      else
        SystemPrinter.printSystem("ERROR : wrong string for decreaseTrustValue");
  }
  
  public void decreaseTrustValue(int decreaseValue) {
    if (!fixedTrustValue)
      value = value - decreaseValue;
  }
  
  public void increaseTrustValue(String increaseType) {
    if (!fixedTrustValue)
      if (increaseType == "computedFunction") {
        if (value < maxComputedFunctionPositiveFeedbackThreshold)
          if (value < (maxValue - computedFunctionIncreaseValue))
            value = value + computedFunctionIncreaseValue;
      }
      else
        SystemPrinter.printSystem("ERROR : wrong string for decreaseTrustValue");
  }
  
}