package epe.agents.acquaintances.specificManagers;

	import epe.gui.SystemPrinter;
	import epe.gui.GUI;
	import epe.agents.Agent;
	import epe.agents.acquaintances.Acquaintance;
	import epe.agents.acquaintances.AcquaintancesManager;
	import epe.agents.agentInterface.AgentInterface;

import java.util.Vector;

 //How it works : 2 IN(mono, int), 1 OUT(mulit, int) : sends IN1+IN2 to OUT
public class AgentAdditionAcquaintancesManager extends AcquaintancesManager {

  public AgentAdditionAcquaintancesManager(Agent owner) {
    super(owner);
  }
  
  public void addAcquaintance(Acquaintance acquaintance) {
    //tester la validit? de l'ajout par rapport ? l'Agent
    
    // D?j? pr?sent
    if (acquaintances.isPresentAcquaintance(acquaintance)
    && acquaintance.getAgentInterface().getType() != "OUT") {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Addition : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : already present."
                 , GUI.red);
    }
    // Ajout : IN + n?
    else if (acquaintance.getAgentInterface().getType().equals("IN"))
      if ((acquaintance.getAgentInterface().getPosition() != 1) 
      && (acquaintance.getAgentInterface().getPosition() != 2)) {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent Addition : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + " Agent Addition has only IN1 and IN2.", GUI.red);
      }
      else if (acquaintances
                .findAcquaintance(
                  new AgentInterface("IN", 
                                     acquaintance
                                      .getAgentInterface()
                                      .getPosition())).size() == 0) {
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Addition : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", GUI.blue);
        notifyUpdatedListeners(acquaintance);
      }
      else {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent Addition : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : Agent Addition has only one "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   , GUI.red);
      }
    // Demande d'ajout : OUT + n?
    else if (acquaintance.getAgentInterface().getType().equals("OUT"))
      if (acquaintance.getAgentInterface().getPosition() != 1) { 
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent Addition : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + "Agent Addition has only OUT1.", GUI.red);
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Addition : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", GUI.blue);
        notifyUpdatedListeners(acquaintance);
      }
    // Demande d'ajout : NEUTRAL + n?
    else if (acquaintance.getAgentInterface().getType().equals("NEUTRAL"))
      if ((acquaintance.getAgentInterface().getPosition() != 0) 
      && (acquaintance.getAgentInterface().getPosition() != 1)) {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent Addition : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + "Agent Addition has only NEUTRAL1.", GUI.red);
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Addition : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", GUI.blue);
        notifyUpdatedListeners(acquaintance);
      }  
    // Autres cas
    else {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Addition AcquaintancesManager : "
                  + "ERROR : Unknown case.", GUI.red);
    }
  }
 
  public String addAcquaintanceWithReturn(Acquaintance acquaintance) {
    //tester la validit? de l'ajout par rapport ? l'Agent
    
    // D?j? pr?sent
    if (acquaintances.isPresentAcquaintance(acquaintance)
    && acquaintance.getAgentInterface().getType() != "OUT") {
      return "Agent Addition : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : already present.";
    }
    // Ajout : IN + n?
    else if (acquaintance.getAgentInterface().getType().equals("IN"))
      if ((acquaintance.getAgentInterface().getPosition() != 1) 
      && (acquaintance.getAgentInterface().getPosition() != 2)) {
        return "Agent Addition : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + " Agent Addition has only IN1 and IN2.";
      }
      else if (acquaintances
                .findAcquaintance(
                  new AgentInterface("IN", 
                                     acquaintance
                                      .getAgentInterface()
                                      .getPosition())).size() == 0) {
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Addition : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", GUI.blue);
        notifyUpdatedListeners(acquaintance);
        return "SUCCESS";
      }
      else {
        return "Agent Addition : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : Agent Addition has only one "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition();
      }
    // Demande d'ajout : OUT + n?
    else if (acquaintance.getAgentInterface().getType().equals("OUT"))
      if (acquaintance.getAgentInterface().getPosition() != 1) { 
        return "Agent Addition : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + "Agent Addition has only OUT1.";
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Addition : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", GUI.blue);
        notifyUpdatedListeners(acquaintance);
        return "SUCCESS";
      }
    // Demande d'ajout : NEUTRAL + n?
    else if (acquaintance.getAgentInterface().getType().equals("NEUTRAL"))
      if ((acquaintance.getAgentInterface().getPosition() != 0) 
      && (acquaintance.getAgentInterface().getPosition() != 1)) {
        return "Agent Addition : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + "Agent Addition has only NEUTRAL1.";
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Addition : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", GUI.blue);
        notifyUpdatedListeners(acquaintance);
        return "SUCCESS";
      }  
    // Autres cas
    else {
      return "Agent Addition AcquaintancesManager : "
                  + "ERROR : Unknown case.";
    }
  }
  
  public boolean possessingIN1() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("IN", 1));
    return (position.size()!=0);
  }
  
  public boolean possessingIN2() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("IN", 2));
    return (position.size()!=0);
  }
  
  public boolean possessingOUT() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("OUT", 1));
    return (position.size()!=0);
  }
  
  public boolean possessingMultipleOUT() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("OUT", 1));
    return (position.size() > 1);
  }
  
  public Agent getAgentIN1() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("IN", 1));
    if (position.size() == 0) {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Addition : ERROR : No IN acquaintance", GUI.red);
      return null;
    }
    else
      return acquaintances.getAcquaintance(((Integer)position.elementAt(0)).intValue()).getAgent();
  }
  
  public Agent getAgentIN2() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("IN", 2));
    if (position.size() == 0) {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Addition : ERROR : No IN acquaintance", GUI.red);
      return null;
    }
    else
      return acquaintances.getAcquaintance(((Integer)position.elementAt(0)).intValue()).getAgent();
  }
  
}