/*
 * AgentEqualsAcquaintanceManager.java
 *
 * Created on 23 avril 2000, 15:08
 */
 
package epe.agents.acquaintances.specificManagers;

import epe.gui.SystemPrinter;
import java.util.Vector;
import epe.agents.Agent;
import epe.agents.acquaintances.Acquaintance;
import epe.agents.acquaintances.AcquaintancesManager;
import epe.agents.agentInterface.AgentInterface;

/** 
 *
 * @author  Jean-Pierre Georg?
 * @version 
 * Fonctionnement : 2 entr?es mono, une sortie multiple renvoyant le boolean (IN1 == IN2).
 */
public class AgentEqualsAcquaintancesManager extends AcquaintancesManager {

  /** Creates new AgentEqualsAcquaintanceManager */
  public AgentEqualsAcquaintancesManager(Agent owner) {
    super(owner);
  }
  
  public void addAcquaintance(Acquaintance acquaintance) {
    //tester la validit? de l'ajout par rapport ? l'Agent
    
    // D?j? pr?sent
    if (acquaintances.isPresentAcquaintance(acquaintance)
    && acquaintance.getAgentInterface().getType() != "OUT") {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Equals : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : "
                 + "already present.", java.awt.Color.red);
    }
    // Ajout : IN + n?
    else if (acquaintance.getAgentInterface().getType().equals("IN"))
      if ((acquaintance.getAgentInterface().getPosition() != 1) 
      && (acquaintance.getAgentInterface().getPosition() != 2)) {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent Equals : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : " 
                   + "Agent Equals has only IN1 and IN2.", java.awt.Color.red);
      }
      else if (acquaintances.findAcquaintance(new AgentInterface("IN", acquaintance.getAgentInterface().getPosition())).size() == 0) {
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Equals : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
      }
      else {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent Equals : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : Agent Equals has only one "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   , java.awt.Color.red);
      }
    // Demande d'ajout : OUT + n?
    else if (acquaintance.getAgentInterface().getType().equals("OUT"))
      if (acquaintance.getAgentInterface().getPosition() != 1) {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent Equals : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + "Agent Equals has only OUT1.", java.awt.Color.red);
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Equals : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
      }
    // Demande d'ajout : NEUTRAL + n?
    else if (acquaintance.getAgentInterface().getType().equals("NEUTRAL"))
      if ((acquaintance.getAgentInterface().getPosition() != 0) 
      && (acquaintance.getAgentInterface().getPosition() != 1)) {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent Equals : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + "Agent Equals has only NEUTRAL1.", java.awt.Color.red);
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Equals : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
      }  
    // Autres cas
    else {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Equals AcquaintancesManager : "
                 + "ERROR : Unknown case.", java.awt.Color.red);
    }
  }
 
  public String addAcquaintanceWithReturn(Acquaintance acquaintance) {
    //tester la validit? de l'ajout par rapport ? l'Agent
    
    // D?j? pr?sent
    if (acquaintances.isPresentAcquaintance(acquaintance)
    && acquaintance.getAgentInterface().getType() != "OUT") {
      return "Agent Equals : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : "
                 + "already present.";
    }
    // Ajout : IN + n?
    else if (acquaintance.getAgentInterface().getType().equals("IN"))
      if ((acquaintance.getAgentInterface().getPosition() != 1) 
      && (acquaintance.getAgentInterface().getPosition() != 2)) {
        return "Agent Equals : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : " 
                   + "Agent Equals has only IN1 and IN2.";
      }
      else if (acquaintances.findAcquaintance(new AgentInterface("IN", acquaintance.getAgentInterface().getPosition())).size() == 0) {
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Equals : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
        return "SUCCESS";
      }
      else {
        return "Agent Equals : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : Agent Equals has only one "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition();
      }
    // Demande d'ajout : OUT + n?
    else if (acquaintance.getAgentInterface().getType().equals("OUT"))
      if (acquaintance.getAgentInterface().getPosition() != 1) {
        return "Agent Equals : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + "Agent Equals has only OUT1.";
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Equals : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
        return "SUCCESS";
      }
    // Demande d'ajout : NEUTRAL + n?
    else if (acquaintance.getAgentInterface().getType().equals("NEUTRAL"))
      if ((acquaintance.getAgentInterface().getPosition() != 0) 
      && (acquaintance.getAgentInterface().getPosition() != 1)) {
        return "Agent Equals : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + "Agent Equals has only NEUTRAL1.";
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Equals : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
        return "SUCCESS";
      }  
    // Autres cas
    else {
      return "Agent Equals AcquaintancesManager : "
                 + "ERROR : Unknown case.";
    }
  }
  
  public boolean possessingIN1() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("IN", 1));
    return (position.size()!=0);
  }
  
  public boolean possessingIN2() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("IN", 2));
    return (position.size()!=0);
  }
  
  public boolean possessingOUT() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("OUT", 1));
    return (position.size()!=0);
  }
 
  public Agent getAgentIN1() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("IN", 1));
    if (position.size() == 0) {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Equals : ERROR : No IN acquaintance", java.awt.Color.red);
      return null;
    }
    else
      return acquaintances.getAcquaintance(((Integer)position.elementAt(0)).intValue()).getAgent();
  }
  
  public Agent getAgentIN2() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("IN", 2));
    if (position.size() == 0) {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Equals : ERROR : No IN acquaintance", java.awt.Color.red);
      return null;
    }
    else
      return acquaintances.getAcquaintance(((Integer)position.elementAt(0)).intValue()).getAgent();
  }
  
}