/*
 * AgentEnvironmentAcquaintanceManager.java
 *
 * Created on 23 avril 2000, 15:08
 */
 
package epe.agents.acquaintances.specificManagers.environment;

import epe.gui.SystemPrinter;
import epe.agents.Agent;
import epe.agents.acquaintances.Acquaintance;
import epe.agents.acquaintances.AcquaintancesManager;
import epe.agents.agentInterface.AgentInterface;

import java.util.Vector;

/** 
 *
 * @author  Jean-Pierre Georg?
 * @version 
 * How it works : 1 IN, 1 OUT : the agentEnvironment gets a data from the inpoutTextField
 *                and gives it to the agentIn. When the system has finished computing,  
 *                it send the result, via the agentOut, to the agentEnvironment who judges 
 *                the adequacy and sends back a NCSinadequeteData if needed.
 */
public class AgentEnvironmentAcquaintancesManager extends AcquaintancesManager {

  /** Creates new AgentEnvironmentAcquaintanceManager */
  public AgentEnvironmentAcquaintancesManager(Agent owner) {
    super(owner);
  }
  
  public void addAcquaintance(Acquaintance acquaintance) {
    //tester la validit? de l'ajout par rapport ? l'Agent
    
    // D?j? pr?sent
    if (acquaintances.isPresentAcquaintance(acquaintance)
    && acquaintance.getAgentInterface().getType() != "OUT") {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Environment : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : already present."
                 , java.awt.Color.red);
    }
    // Ajout : IN + n?
    else if (acquaintance.getAgentInterface().getType().equals("IN"))
      if ((acquaintance.getAgentInterface().getPosition() != 1) ) {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        gui.println("Agent Environment : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + " Agent Environment has only IN (IN1).", java.awt.Color.red);
      }
      else if (acquaintances
                .findAcquaintance(
                  new AgentInterface("IN", 
                                     acquaintance
                                      .getAgentInterface()
                                      .getPosition())).size() == 0) {
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Environment : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
      }
      else {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent Environment : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : Agent Environment has only one "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   , java.awt.Color.red);
      }
    // Demande d'ajout : OUT + n?
    else if (acquaintance.getAgentInterface().getType().equals("OUT"))
      if (acquaintance.getAgentInterface().getPosition() != 1) { 
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent Environment : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + "Agent Environment has only OUT1.", java.awt.Color.red);
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Environment : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
      }
    // Demande d'ajout : NEUTRAL + n?
    else if (acquaintance.getAgentInterface().getType().equals("NEUTRAL"))
      if ((acquaintance.getAgentInterface().getPosition() != 0) 
      && (acquaintance.getAgentInterface().getPosition() != 1)) {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent Environment : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + "Agent Environment has only NEUTRAL1.", java.awt.Color.red);
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Environment : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
      }  
    // Autres cas
    else {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Environment AcquaintancesManager : "
                  + "ERROR : Unknown case.", java.awt.Color.red);
    }
  }
 
  public String addAcquaintanceWithReturn(Acquaintance acquaintance) {
    //tester la validit? de l'ajout par rapport ? l'Agent
    
    // D?j? pr?sent
    if (acquaintances.isPresentAcquaintance(acquaintance)
    && acquaintance.getAgentInterface().getType() != "OUT") {
      return "Agent Environment : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : already present.";
    }
    // Ajout : IN + n?
    else if (acquaintance.getAgentInterface().getType().equals("IN"))
      if ((acquaintance.getAgentInterface().getPosition() != 1) ) {
        return "Agent Environment : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + " Agent Environment has only IN (IN1).";
      }
      else if (acquaintances
                .findAcquaintance(
                  new AgentInterface("IN", 
                                     acquaintance
                                      .getAgentInterface()
                                      .getPosition())).size() == 0) {
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Environment : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
        return "SUCCESS";
      }
      else {
        return "Agent Environment : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : Agent Environment has only one "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition();
      }
    // Demande d'ajout : OUT + n?
    else if (acquaintance.getAgentInterface().getType().equals("OUT"))
      if (acquaintance.getAgentInterface().getPosition() != 1) { 
        return "Agent Environment : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + "Agent Environment has only OUT1.";
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Environment : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
        return "SUCCESS";
      }
    // Demande d'ajout : NEUTRAL + n?
    else if (acquaintance.getAgentInterface().getType().equals("NEUTRAL"))
      if ((acquaintance.getAgentInterface().getPosition() != 0) 
      && (acquaintance.getAgentInterface().getPosition() != 1)) {
        return "Agent Environment : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + "Agent Environment has only NEUTRAL1.";
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Environment : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
        return "SUCCESS";
      }  
    // Autres cas
    else {
      return "Agent Environment AcquaintancesManager : "
                  + "ERROR : Unknown case.";
    }
  }
  
  public boolean possessingIN() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("IN", 1));
    return (position.size()!=0);
  }
  
  public boolean possessingOUT() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("OUT", 1));
    return (position.size()!=0);
  }
  
  public boolean possessingMultipleOUT() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("OUT", 1));
    return (position.size() > 1);
  }
  
  public Agent getAgentIN() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("IN", 1));
    if (position.size() == 0) {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Environment : ERROR : No IN acquaintance", java.awt.Color.red);
      return null;
    }
    else
      return acquaintances.getAcquaintance(((Integer)position.elementAt(0)).intValue()).getAgent();
  }
  
}