/*
 * AgentInAcquaintanceManager.java
 *
 * Created on 23 avril 2000, 15:08
 */
 
package epe.agents.acquaintances.specificManagers.interfaceAgents;

import epe.gui.SystemPrinter;
import epe.agents.Agent;
import epe.agents.acquaintances.Acquaintance;
import epe.agents.acquaintances.AcquaintancesManager;
import epe.agents.agentInterface.AgentInterface;

import java.util.Vector;

/** 
 *
 * @author  Jean-Pierre Georg?
 * @version 
 * How it works : 1 IN(mono), 1 OUT(multi) : the IN is linked to the agentEnvironment,
 *                the OUT is linked to some agents in the system.
 */
public class AgentInAcquaintancesManager extends AcquaintancesManager {

  /** Creates new AgentInAcquaintanceManager */
  public AgentInAcquaintancesManager(Agent owner) {
    super(owner);
    maxNumberOfNeutralAcquaintances = 100;
  }
  
  public void addAcquaintance(Acquaintance acquaintance) {
    //tester la validit? de l'ajout par rapport ? l'Agent
    
    // D?j? pr?sent
    if (acquaintances.isPresentAcquaintance(acquaintance)
    && acquaintance.getAgentInterface().getType() != "OUT") {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println(owner.getAgentName() + " : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : "
                 + "already present.", java.awt.Color.red);
    }
    // Demande d'ajout : IN
    else if (acquaintance.getAgentInterface().getType().equals("IN"))
      if ((acquaintance.getAgentInterface().getPosition() != 1)) {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println(owner.getAgentName() + " : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + " Agent Addition has only one IN (IN1).", java.awt.Color.red);
      }
      else if (acquaintances
                .findAcquaintance(
                  new AgentInterface("IN", 
                                     acquaintance
                                      .getAgentInterface()
                                      .getPosition())).size() == 0) {
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println(owner.getAgentName() + " : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
      }
      else {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println(owner.getAgentName() + " : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : Agent Addition has only one "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   , java.awt.Color.red);
      }
    // Demande d'ajout : n? d'interface > 1
    else if ((acquaintance.getAgentInterface().getPosition() != 0)
    && (acquaintance.getAgentInterface().getPosition() != 1)) {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println(owner.getAgentName() + " : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : "
                 + "Agent In has only 1 IN, 1 OUT, 1 NEUTRAL."
                 , java.awt.Color.red);
    }
    // Ajout demand? correct
    else if ((acquaintance.getAgentInterface().getType().equals("OUT"))
            || (acquaintance.getAgentInterface().getType().equals("NEUTRAL"))) {
      //acquaintances.addAcquaintance(acquaintance);
      super.addAcquaintance(acquaintance);
      gui.println(owner.getAgentName() + " : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] added to Acquaintances [ "
                 + acquaintance.getAgentInterface().getType()
                 + acquaintance.getAgentInterface().getPosition()
                 + " ].", java.awt.Color.blue);
      notifyUpdatedListeners(acquaintance);
    }
    // Autres cas
    else {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println(owner.getAgentName() + " AcquaintancesManager : "
                  + "ERROR : Unknown case.", java.awt.Color.red);
    }
  }

  public String addAcquaintanceWithReturn(Acquaintance acquaintance) {
    //tester la validit? de l'ajout par rapport ? l'Agent
    
    // D?j? pr?sent
    if (acquaintances.isPresentAcquaintance(acquaintance)
    && acquaintance.getAgentInterface().getType() != "OUT") {
      return owner.getAgentName() + " : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : "
                 + "already present.";
    }
    // Demande d'ajout : IN
    else if (acquaintance.getAgentInterface().getType().equals("IN"))
      if ((acquaintance.getAgentInterface().getPosition() != 1)) {
        return owner.getAgentName() + " : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + " Agent Addition has only one IN (IN1).";
      }
      else if (acquaintances
                .findAcquaintance(
                  new AgentInterface("IN", 
                                     acquaintance
                                      .getAgentInterface()
                                      .getPosition())).size() == 0) {
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println(owner.getAgentName() + " : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
        return "SUCCESS";
      }
      else {
        return owner.getAgentName() + " : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : Agent Addition has only one "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition();
      }
    // Demande d'ajout : n? d'interface > 1
    else if ((acquaintance.getAgentInterface().getPosition() != 0)
    && (acquaintance.getAgentInterface().getPosition() != 1)) {
      return owner.getAgentName() + " : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : "
                 + "Agent In has only 1 IN, 1 OUT, 1 NEUTRAL.";
    }
    // Ajout demand? correct
    else if ((acquaintance.getAgentInterface().getType().equals("OUT"))
            || (acquaintance.getAgentInterface().getType().equals("NEUTRAL"))) {
      //acquaintances.addAcquaintance(acquaintance);
      super.addAcquaintance(acquaintance);
      gui.println(owner.getAgentName() + " : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] added to Acquaintances [ "
                 + acquaintance.getAgentInterface().getType()
                 + acquaintance.getAgentInterface().getPosition()
                 + " ].", java.awt.Color.blue);
      notifyUpdatedListeners(acquaintance);
      return "SUCCESS";
    }
    // Autres cas
    else {
      return owner.getAgentName() + " AcquaintancesManager : "
                  + "ERROR : Unknown case.";
    }
  }
  
  public boolean possessingIN() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("IN", 1));
    return (position.size()!=0);
  }
  
  public boolean possessingOUT() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("OUT", 1));
    return (position.size()!=0);
  }
  
  public boolean possessingMultipleOUT() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("OUT", 1));
    return (position.size() > 1);
  }
  
  public Agent getAgentIN() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("IN", 1));
    if (position.size() == 0) {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Addition : ERROR : No IN acquaintance", java.awt.Color.red);
      return null;
    }
    else
      return acquaintances.getAcquaintance(((Integer)position.elementAt(0)).intValue()).getAgent();
  }
   
}