package epe.agents.acquaintances.specificManagers.interfaceAgents;

	import epe.gui.SystemPrinter;
	import java.util.Vector;
	import epe.agents.Agent;
	import epe.agents.acquaintances.Acquaintance;
	import epe.agents.acquaintances.AcquaintancesManager;
	import epe.agents.agentInterface.AgentInterface;

 // How it works : 1 IN (mono, int), 1 OUT(mono) : sends IN1 to
 //                the agentEnvironment
public class AgentOutWithoutControlAcquaintancesManager extends AcquaintancesManager {

  public AgentOutWithoutControlAcquaintancesManager(Agent owner) {
    super(owner);
  }
  
  public void addAcquaintance(Acquaintance acquaintance) {
    //tester la validit? de l'ajout par rapport ? l'Agent
    
    // D?j? pr?sent
    if (acquaintances.isPresentAcquaintance(acquaintance)
    && acquaintance.getAgentInterface().getType() != "OUT") {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Out : ERROR : Acquaintance [ " 
                  + acquaintance.getAgent().getAgentName()
                  + " ] not added to Acquaintances : already present."
                  , java.awt.Color.red);
    }
    // Ajout : IN + n?
    else if (acquaintance.getAgentInterface().getType().equals("IN"))
      if (acquaintance.getAgentInterface().getPosition() != 1) {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent Out : ERROR : Acquaintance [ " 
                    + acquaintance.getAgent().getAgentName()
                    + " ] not added to Acquaintances : "
                    + "Agent Out has only IN1.", java.awt.Color.red);
      }
      else if (acquaintances
                 .findAcquaintance(
                    new AgentInterface("IN", 
                                       acquaintance
                                         .getAgentInterface()
                                         .getPosition())).size() == 0) {
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Out : Acquaintance [ " 
                    + acquaintance.getAgent().getAgentName()
                    + " ] added to Acquaintances [ "
                    + acquaintance.getAgentInterface().getType()
                    + acquaintance.getAgentInterface().getPosition()
                    + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
      }
      else {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent Out : ERROR : Acquaintance [ " 
                    + acquaintance.getAgent().getAgentName()
                    + " ] not added to Acquaintances : Agent Out has only one "
                    + acquaintance.getAgentInterface().getType()
                    + acquaintance.getAgentInterface().getPosition(), java.awt.Color.red);
      }
    // Demande d'ajout : NEUTRAL + n?
    else if (acquaintance.getAgentInterface().getType().equals("NEUTRAL"))
      if ((acquaintance.getAgentInterface().getPosition() != 0) 
      && (acquaintance.getAgentInterface().getPosition() != 1)) {
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent Out : ERROR : Acquaintance [ " 
                    + acquaintance.getAgent().getAgentName()
                    + " ] not added to Acquaintances : "
                    + "Agent Out has only NEUTRAL1.", java.awt.Color.red);
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Out : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
      }
    // Demande d'ajout : OUT + n?
    else if (acquaintance.getAgentInterface().getType().equals("OUT"))
      if (acquaintance.getAgentInterface().getPosition() != 1) { 
        SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
        owner.errorHappened();
        gui.println("Agent OutWithoutControl : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + "Agent OutWithoutControl has only OUT1.", java.awt.Color.red);
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent OutWithoutControl : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
      }
    // Autres cas
    else {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Out AcquaintancesManager : "
                 + "ERROR : Unknown case.", java.awt.Color.red);
    }
  }

  public String addAcquaintanceWithReturn(Acquaintance acquaintance) {
    //tester la validit? de l'ajout par rapport ? l'Agent
    
    // D?j? pr?sent
    if (acquaintances.isPresentAcquaintance(acquaintance)
    && acquaintance.getAgentInterface().getType() != "OUT") {
      return "Agent Out : ERROR : Acquaintance [ " 
                  + acquaintance.getAgent().getAgentName()
                  + " ] not added to Acquaintances : already present.";
    }
    // Ajout : IN + n?
    else if (acquaintance.getAgentInterface().getType().equals("IN"))
      if (acquaintance.getAgentInterface().getPosition() != 1) {
        return "Agent Out : ERROR : Acquaintance [ " 
                    + acquaintance.getAgent().getAgentName()
                    + " ] not added to Acquaintances : "
                    + "Agent Out has only IN1.";
      }
      else if (acquaintances
                 .findAcquaintance(
                    new AgentInterface("IN", 
                                       acquaintance
                                         .getAgentInterface()
                                         .getPosition())).size() == 0) {
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Out : Acquaintance [ " 
                    + acquaintance.getAgent().getAgentName()
                    + " ] added to Acquaintances [ "
                    + acquaintance.getAgentInterface().getType()
                    + acquaintance.getAgentInterface().getPosition()
                    + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
        return "SUCCESS";
      }
      else {
        return "Agent Out : ERROR : Acquaintance [ " 
                    + acquaintance.getAgent().getAgentName()
                    + " ] not added to Acquaintances : Agent Out has only one "
                    + acquaintance.getAgentInterface().getType()
                    + acquaintance.getAgentInterface().getPosition();
      }
    // Demande d'ajout : NEUTRAL + n?
    else if (acquaintance.getAgentInterface().getType().equals("NEUTRAL"))
      if ((acquaintance.getAgentInterface().getPosition() != 0) 
      && (acquaintance.getAgentInterface().getPosition() != 1)) {
        return "Agent Out : ERROR : Acquaintance [ " 
                    + acquaintance.getAgent().getAgentName()
                    + " ] not added to Acquaintances : "
                    + "Agent Out has only NEUTRAL1.";
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent Out : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
        return "SUCCESS";
      }
    // Demande d'ajout : OUT + n?
    else if (acquaintance.getAgentInterface().getType().equals("OUT"))
      if (acquaintance.getAgentInterface().getPosition() != 1) { 
        return "Agent OutWithoutControl : ERROR : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] not added to Acquaintances : "
                   + "Agent OutWithoutControl has only OUT1.";
      }
      else {                           
        //acquaintances.addAcquaintance(acquaintance);
        super.addAcquaintance(acquaintance);
        gui.println("Agent OutWithoutControl : Acquaintance [ " 
                   + acquaintance.getAgent().getAgentName()
                   + " ] added to Acquaintances [ "
                   + acquaintance.getAgentInterface().getType()
                   + acquaintance.getAgentInterface().getPosition()
                   + " ].", java.awt.Color.blue);
        notifyUpdatedListeners(acquaintance);
        return "SUCCESS";
      }
    // Autres cas
    else {
      return "Agent Out AcquaintancesManager : "
                 + "ERROR : Unknown case.";
    }
  }
  
  public boolean possessingIN1() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("IN", 1));
    return (position.size()!=0);
  }
  
  public Agent getAgentIN1() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("IN", 1));
    if (position.size() == 0) {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      gui.println("Agent Out : ERROR : No IN acquaintance", java.awt.Color.red);
      return null;
    }
    else
      return acquaintances.getAcquaintance(((Integer)position.elementAt(0)).intValue()).getAgent();
  }
  
  public void cancelOneOutAcquaintance() {
  	// Do nothing : agentOut never cancels its out acqs
  }
  
  public void cancelOutAcquaintances() {
  	// Do nothing : agentOut never cancels its out acqs
  }
  
}