/*
 * AgentZeroAcquaintanceManager.java
 *
 * Created on 23 avril 2000, 15:08
 */
 
package epe.agents.acquaintances.specificManagers.practicalAgents;

import epe.gui.SystemPrinter;
import epe.agents.Agent;
import epe.agents.acquaintances.Acquaintance;
import epe.agents.acquaintances.AcquaintancesManager;
import epe.agents.agentInterface.AgentInterface;

import java.util.Vector;

/** 
 *
 * @author  Jean-Pierre Georg?
 * @version 
 * Fonctionnement : pas d'entr?es, une sortie multiple renvoyant l'entier 1
 */
public class AgentZeroAcquaintancesManager extends AcquaintancesManager {

  /** Creates new AgentZeroAcquaintanceManager */
  public AgentZeroAcquaintancesManager(Agent owner) {
    super(owner);
  }
  
  public void addAcquaintance(Acquaintance acquaintance) {
    //tester la validit? de l'ajout par rapport ? l'Agent
    
    // D?j? pr?sent
    if (acquaintances.isPresentAcquaintance(acquaintance)
    && acquaintance.getAgentInterface().getType() != "OUT") {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Zero : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : already present."
                 , java.awt.Color.red);
    }
    // Demande d'ajout : IN
    else if (acquaintance.getAgentInterface().getType().equals("IN")) {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Zero : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : "
                 + "Agent Zero has no IN interface.", java.awt.Color.red);
    }
    // Demande d'ajout : n? d'interface > 1
    else if ((acquaintance.getAgentInterface().getPosition() != 0)
    && (acquaintance.getAgentInterface().getPosition() != 1)) {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Zero : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : "
                 + "Agent Zero has only 1 OUT and 1 NEUTRAL.", java.awt.Color.red);
    }
    // Ajout demand? correct
    else if ((acquaintance.getAgentInterface().getType().equals("OUT"))
            || (acquaintance.getAgentInterface().getType().equals("NEUTRAL"))) {
      //acquaintances.addAcquaintance(acquaintance);
      super.addAcquaintance(acquaintance);
      gui.println("Agent Zero : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] added to Acquaintances [ "
                 + acquaintance.getAgentInterface().getType()
                 + acquaintance.getAgentInterface().getPosition()
                 + " ].", java.awt.Color.blue);
      notifyUpdatedListeners(acquaintance);
    }
    // Autres cas
    else {
      SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
      owner.errorHappened();
      gui.println("Agent Zero AcquaintancesManager : "
                 + "ERROR : Unknown case.", java.awt.Color.red);
    }
  }
  
  public String addAcquaintanceWithReturn(Acquaintance acquaintance) {
    //tester la validit? de l'ajout par rapport ? l'Agent
    
    // D?j? pr?sent
    if (acquaintances.isPresentAcquaintance(acquaintance)
    && acquaintance.getAgentInterface().getType() != "OUT") {
      return "Agent Zero : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : already present.";
    }
    // Demande d'ajout : IN
    else if (acquaintance.getAgentInterface().getType().equals("IN")) {
      return "Agent Zero : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : "
                 + "Agent Zero has no IN interface.";
    }
    // Demande d'ajout : n? d'interface > 1
    else if ((acquaintance.getAgentInterface().getPosition() != 0)
    && (acquaintance.getAgentInterface().getPosition() != 1)) {
      return "Agent Zero : ERROR : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] not added to Acquaintances : "
                 + "Agent Zero has only 1 OUT and 1 NEUTRAL.";
    }
    // Ajout demand? correct
    else if ((acquaintance.getAgentInterface().getType().equals("OUT"))
            || (acquaintance.getAgentInterface().getType().equals("NEUTRAL"))) {
      //acquaintances.addAcquaintance(acquaintance);
      super.addAcquaintance(acquaintance);
      gui.println("Agent Zero : Acquaintance [ " 
                 + acquaintance.getAgent().getAgentName()
                 + " ] added to Acquaintances [ "
                 + acquaintance.getAgentInterface().getType()
                 + acquaintance.getAgentInterface().getPosition()
                 + " ].", java.awt.Color.blue);
      notifyUpdatedListeners(acquaintance);
      return "SUCCESS";
    }
    // Autres cas
    else {
      return "Agent Zero AcquaintancesManager : "
                 + "ERROR : Unknown case.";
    }
  }
  
   public boolean possessingOUT() {
    Vector<Object> position = acquaintances.findAcquaintance(new AgentInterface("OUT", 1));
    return (position.size()!=0);
  }
  
}