package epe.agents.agentInterface;

public class AgentInterface extends Object implements java.lang.Cloneable {

  protected String type = "NEUTRAL"; // IN , OUT or NEUTRAL.
  protected int position = 0; // 0 = generic.
  														//  1,2,... = IN/OUT number.
  protected String dataType = "UNKNOWN"; // UNKNOWN, INTEGER, BOOLEAN, GENERIC.
  

  public AgentInterface() {
  }
  
   public AgentInterface(String type) {
    this.type = type;
  }
  
  public AgentInterface(String type, int position) {
    this.type = type;
    this.position = position;
  }
  
  public AgentInterface(String type, String dataType ) {
    this.type = type;
    this.dataType = dataType;
  }
  
  public AgentInterface(String type, int position, String dataType) {
    this.type = type;
    this.position = position;
    this.dataType = dataType;
  }
  
  public void setIN(int position) {
    type = "IN";
    this.position = position;
  }
  
  public void setOUT(int position) {
    type = "OUT";
    this.position = position;
  }
  
  public void setNEUTRAL() {
    type = "NEUTRAL";
  }
  
  public String getType() {
    return type;
  }
  
  public int getPosition() {
    return position;
  }
  
  public String getDataType() {
    return dataType;
  }
  
  // Only changes the dataType if the new value is more spcific
  public boolean setDataType(String newDataType) {
    if ((dataType != "BOOLEAN")&&(dataType != "INTEGER")) {
      dataType = newDataType;
      return true;
    }
    else
      return false;
  }
  
  public void setPosition(int position) {
    this.position = position;
  }
  
  public boolean equals(AgentInterface agentInterface) {
    return ((agentInterface.getType().equals(type)) 
         && ((position == 0)
             |(agentInterface.getPosition() == 0)
             |(agentInterface.getPosition() == position))
         && ((dataType.equals("UNKNOWN"))
            |(agentInterface.getDataType().equals("UNKNOWN"))
            |(dataType.equals("GENERIC"))
            |(agentInterface.getDataType().equals("GENERIC"))
            |(agentInterface.getDataType().equals(dataType))));
  }
  
  public static String lessGenericDataType(String type1, String type2) {
    if (!type1.equals("GENERIC"))
      return type1;
    else
      return type2;
  }
  
  public AgentInterface copyAgentInterface() {
	 try {
		return ((AgentInterface)((Object)this.clone()));
	  } catch (java.lang.CloneNotSupportedException e) {
		return null;
	  } 
	}
  
}