package epe.agents.specificAgents.practicalAgents;

import epe.gui.SystemPrinter;
import epe.agents.Agent;
import epe.agents.acquaintances.Acquaintance;
import epe.agents.acquaintances.specificManagers.practicalAgents.AgentZeroAcquaintancesManager;
import epe.agents.agentInterface.AgentInterface;
import epe.communication.Message;
import epe.communication.messages.data.NumberMessage;
import epe.observationTools.graphLayoutTool.GraphLayoutToolInterface;
import epe.reorganization.specificManagers.practicalAgents.AgentZeroReorganizationManager;
import epe.synchronization.SynchronizationManager;

/** 
 * Fonctionnement : pas d'entr?es, une sortie multiple renvoyant l'entier 0
 */
public class AgentZero extends Agent {

  /** Creates new AgentZero */
  public AgentZero(String suffixe) {
    super("Zero" + suffixe);
    acquaintancesManager = new AgentZeroAcquaintancesManager(this);
    synchronizationManager = new SynchronizationManager(acquaintancesManager, this);
    reorganizationManager = new AgentZeroReorganizationManager(this);
    reorganizationManager.setLastOutputValue(0);
    //reorganizationManager.updatePotentialOuput();
    SystemPrinter.printSystem(getAgentName() +" created");
  }

  protected void graphLayoutToolAgentInitialisation() {
    getProgrammingEnvironment().getGraphLayoutTool()
                               .addAgent(getAgentName(),
                                         GraphLayoutToolInterface.NORMAL_AGENT,
                                         java.awt.Color.lightGray);
  }
  
  public void reInitializeAgent() {
    super.reInitializeAgent();
  }
  
  protected void acting() {
    setActed(false);
    if (synchronizationManager.waitersAreReady()) {
      gui.println("Agent Zero : Waiters are ready, Firing NumberMessage.");
      synchronizationManager.sendToOutDone();
      NumberMessage message = new NumberMessage(0, this);
      AgentInterface agentInterface = new AgentInterface("OUT", 1);
      fireMessage(message, agentInterface, this);
      setActed(true);
      agentHasComputedItsFunction();
      cancelLongTimeNotActed();
    }
    
    if ((!hasActed())&&(debug)) {
      if (!synchronizationManager.waitersAreReady()) {
        gui.println(getAgentName() + " : DEBUG : waiters are not ready.");
        synchronizationManager.tellWhoIsNotReady();
      }
    }
  }
  
   public synchronized void receiveMessage(Message message) {
    messageManager.receivedMessage(message);

    super.receiveMessage(message);
    
    setActed(true);
    startAgent();
  }
  
  public void cooperationWithInAcquaintanceMayHaveBeenCancelled(Acquaintance acq) {
  }
  
  public void retryCalculus() {
  }
  
}