/*
 * TesterPositionSaver.java
 *
 * Created on 17 dcembre 2002, 11:30
 */

package epe.annexTools.systematicOrganizationsStatisticTool.functionalOrganizationTester.testerPositionSaver;

/**
 *
 * @author  george
 */

import java.io.FileReader;
import java.io.FileWriter;
import java.net.URL;

public class TesterPositionSaver {
  
 protected int[] links;
  protected int[] subPath;
  protected String relativePath = "data/annexTools/functionalOrganizationTester/testerPositionSaver/saves";
  protected URL absoluteURL;
  protected String file = "";
  protected FileWriter writer;
  protected FileReader reader;
  protected String newline = System.getProperty("line.separator");
  
  protected int position;
  protected int savedPosition;
  
  /** Creates a new instance of OragnizationSaver */
  public TesterPositionSaver() {
    absoluteURL = getClass().getResource("/" + relativePath);
    //System.out.println(absoluteURL);
  }
  
  public void savePosition(int position, int organizationNumber, int savedPosition) {
    try {
      writer = openFile();
      writer.write(new Integer(position).toString());
      writer.write(" organizations tested (current n = ");
      writer.write(new Integer(organizationNumber).toString());
      writer.write(").");
      writer.write(newline);
      writer.write(new Integer(savedPosition).toString());
      writer.write(" functional organizations saved.");
      writer.flush();
      System.out.println("Position Saved : " + position
                         + "/path : " + file);
    } catch (Exception e) {
      System.out.println("ERROR : failled to write file : " + e);
    }
  }
    
  protected FileWriter openFile() {
    try {
      file = absoluteURL.getFile();
      file = file + "/" + "SavedPosition";
      writer = new FileWriter(file); 
      return writer;
    } catch (Exception e) {
      System.out.println("ERROR : failled to open file : " + e);
    }
    return null;
  }
  
  public void loadPosition() {
    String organizationNumber;
    String savedOrganizationNumber;
    try {
      file = absoluteURL.getFile();
      file = file + "/" + "SavedPosition";
      reader = new FileReader(file);
      
      String s = "";
      char c = (char)reader.read();
      while (c != ' ') {
        s = s + c;
        c = (char)reader.read();
      }
      organizationNumber = s;
      position = (new Integer(organizationNumber)).intValue();
      System.out.println("Loading organization number/position : " + organizationNumber
                        + "/" + position);
      
      while (c != '.') {
        c = (char)reader.read();
      }
      c = (char)reader.read();
      c = (char)reader.read();
      c = (char)reader.read();
      
      s = "";
      while (c != ' ') {
        s = s + c;
        c = (char)reader.read();
      }
      
      savedOrganizationNumber = s;
      savedPosition = (new Integer(savedOrganizationNumber)).intValue();
      System.out.println("Loading saved organization number/savedPosition : " + savedOrganizationNumber
                          +"/" + savedPosition);
      
    } catch (Exception e) {
      System.out.println("ERROR : failled to load file : " + e);
    }
  }
  
  public int getPosition() {
    return position;
  }
  
  public int getSavedPosition() {
    return savedPosition;
  }
  
}
