/*
 * OrganizationSaver.java
 *
 * Created on 16 dcembre 2002, 17:23
 */

package epe.annexTools.systematicOrganizationsStatisticTool.organizationalProximity.organizationalProximityFileManager;

/**
 *
 * @author  george
 */

import java.io.File;
import java.io.FileWriter;
import java.io.FileReader;

import java.net.URL;

public class OrganizationalProximityFileManager {

  protected int[] links;
  protected int[] subPath = {5,0,1,2};
  protected String relativePath = 
    "data/annexTools/organizationalProximity/organizationalProximityFileManager/saves";
  protected String loadRelativePath = 
    "data/annexTools/organizationalProximity/organizationalProximityFileManager/source";
  protected URL absoluteURL;
  protected URL loadAbsoluteURL;
  protected int saveOrganizationCounter = 0;
  protected int loadOrganizationCounter = 0;
  protected int functionalOrganizationNumber ;
  protected int testedOrganizationNumber;
  protected int filteredOrganizationNumber ;
  protected int originalOrganizationNumber;
  
  protected String readFile = "";
  protected String readFile2 = "";
  protected String writeFile = "";
  protected String writeFile2 = "";
  protected FileWriter writer;
  protected FileReader reader;
  String newline = System.getProperty("line.separator");
  
  /** Creates a new instance of CalculatingOrganizationSaver */
  public OrganizationalProximityFileManager() {
    absoluteURL = getClass().getResource("/" + relativePath);
    loadAbsoluteURL = getClass().getResource("/" + loadRelativePath);
    //System.out.println(absoluteURL);
  }
  
  public void saveOrganization(int[] links, 
                               int loadOrganizationNumber, 
                               int originalOrganizationNumber,
                               int proximity) {
    this.links = links;
    try {
      writer = openFileForWriting(links);
      
      writer.write(new Integer(proximity).toString());
      
//      writer.write(addZeros(saveOrganizationCounter));
//      writer.write(new Integer(saveOrganizationCounter).toString());
//      writer.write(" : ");
//      writer.write(addZeros(loadOrganizationNumber));
//      writer.write(new Integer(loadOrganizationNumber).toString());
//      writer.write(" : ");
//      writer.write(addZeros(originalOrganizationNumber));
//      writer.write(new Integer(originalOrganizationNumber).toString());
//      writer.write(" : ");
//      for (int i=0; i<links.length; i++)
//        writer.write(new Integer(links[i]).toString() + " ");
      writer.write(newline);
      writer.flush();
      //System.out.println("Written");
      saveOrganizationCounter++;
    } catch (Exception e) {
      System.out.println("ERROR : failled to write file : " + e);
    }
  }

  protected FileWriter openFileForWriting(int[] links) {
    try {
      writeFile2 = absoluteURL.getFile();
      //for (int i=0; i<4; i++) {
      //  writeFile2 = writeFile2 + "/" + links[i];
      //}
      File dirFile = new File(writeFile2);
      dirFile.mkdirs();
      writeFile2 = writeFile2 + "/" + "OrganizationalProximity";
      if (!writeFile2.equals(writeFile)) {
        writeFile = writeFile2;
        writer = new FileWriter(writeFile, true); 
      }
      return writer;
    } catch (Exception e) {
      System.out.println("ERROR : failled to open file for writing : " + e);
    }
    return null;
  }
  
  protected FileReader openFileForReading() {
    try {
      readFile2 = loadAbsoluteURL.getFile();
      //for (int i=0; i<subPath.length; i++) {
      //    readFile2 = readFile2 + "/" + subPath[i];
      //}
      readFile2 = readFile2 + "/" + "FunctionalOrganizations";
      if (!readFile2.equals(readFile)) {
        readFile = readFile2;
        reader = new FileReader(readFile); 
      }
      return reader;
    } catch (Exception e) {
      System.out.println("ERROR : failled to open file for reading : " + e);
    }
    return null;
  }
  
  public void positionTheReader(int position) {
    try {
      reader = openFileForReading();
      // Go to saved position
      for (int k=0; k<position; k++)
        for (int i=0; i<50; i++)
          reader.read();
        
    } catch (Exception e) {
      System.out.println("ERROR : failled to position the reader in the file : " + e);
    }
  }
  
  public int[] loadOrganization() {
    links = new int[12];
    String organizationNumber;
    
    try {
      reader = openFileForReading();
      // Get first number (functionalOrganisations)
      String s = "";
      for (int i=0; i<9; i++) {
        s = s + (char)reader.read();
      }
      organizationNumber = s;
      functionalOrganizationNumber = (new Integer(organizationNumber+"")).intValue();
      loadOrganizationCounter++;
      System.out.println("Loading fucntional organization number/counter : " + organizationNumber 
                         + "/" + loadOrganizationCounter);
      for (int i=0; i<3; i++) {
        reader.read();
      }
      
      // Get second number (calculatingOrganisations)
      s = "";
      for (int i=0; i<9; i++) {
        s = s + (char)reader.read();
      }
      organizationNumber = s;
      testedOrganizationNumber = (new Integer(organizationNumber+"")).intValue();
      System.out.println("Loading calculating organization number/counter : " + organizationNumber 
                         + "/" + loadOrganizationCounter);
      for (int i=0; i<3; i++) {
        reader.read();
      }
      
      // Get third number (filteredOrganisations)
      s = "";
      for (int i=0; i<9; i++) {
        s = s + (char)reader.read();
      }
      organizationNumber = s;
      filteredOrganizationNumber = (new Integer(organizationNumber+"")).intValue();
      System.out.println("Loading calculating organization number/counter : " + filteredOrganizationNumber 
                         + "/" + loadOrganizationCounter);
      for (int i=0; i<3; i++) {
        reader.read();
      }
      
      // Get fourth number (original number)
      s = "";
      for (int i=0; i<9; i++) {
        s = s + (char)reader.read();
      }
      organizationNumber = s;
      originalOrganizationNumber = (new Integer(organizationNumber+"")).intValue();
      System.out.println("Loading original organization number/counter : " + originalOrganizationNumber 
                         + "/" + loadOrganizationCounter);
      for (int i=0; i<3; i++) {
        reader.read();
      }
      
      char nb;
      //System.out.println("loading numbers");
      for (int i=0; i<12; i++) {
        nb = (char)reader.read();
        links[i] = (new Integer(nb+"")).intValue();
        reader.read();
      }
      reader.read();
      reader.read();
      
      if (links == null)
        System.out.println("ERROR : null");
      else {
        System.out.print("Links : ");
        for (int i=0; i<12; i++)
          System.out.print(links[i] + " ");
        System.out.println();
        return links;
      }
      
    } catch (Exception e) {
      System.out.println("ERROR : failled to load file : " + e);
    }
    return null;
  }
  
  public int getSaveOrganizationCounter() {
    return saveOrganizationCounter;
  }  
  
  public void setSaveOrganizationCounter(int saveOrganizationCounter) {
    this.saveOrganizationCounter = saveOrganizationCounter;
  }
  
  public int getLoadOrganizationCounter() {
    return loadOrganizationCounter;
  }
  
  public int getTestedOrganizationNumber() {
    return testedOrganizationNumber;
  }

  public int getOriginalOrganizationNumber() {
    return originalOrganizationNumber;
  }
  
  public void setLoadOrganizationCounter(int loadOrganizationCounter) {
    this.loadOrganizationCounter = loadOrganizationCounter;
  }
  
  protected String addZeros(int counter) {
    if (counter<10)
      return "00000000";
    else if (counter<100)
      return "0000000";
    else if (counter<1000)
      return "000000";
    else if (counter<10000)
      return "00000";
    else if (counter<100000)
      return "0000";
    else if (counter<1000000)
      return "000";
    else if (counter<10000000)
      return "00";
    else if (counter<100000000)
      return "0";
    else 
      return "";
  }
  
   protected String incrementSubPath() {
    int incResult = recursiveIncrementer(0);
    if (incResult!=0) {
      System.out.println("LAST ORGANIZATION REACHED");
      for (int i = 0 ; i<subPath.length ; i++)
        System.out.print(subPath[i] + "|");
      System.out.println();
      return "END";
    }
    else {
      for (int i = 0 ; i<subPath.length ; i++)
        System.out.print(subPath[i] + "|");
      System.out.println();
      return "DONE"; 
    }
  }
  
  
  protected int recursiveIncrementer(int depth) {
    if (depth == 3) {
      if (subPath[depth] == 8) {
        subPath[depth] = 0;
        return 1;
      }
      else {
        subPath[depth]++;
        return 0;
      }
    }
    else {
      int recIncr = recursiveIncrementer(depth+1);
      if (recIncr == 0) {
        return 0;
      }
      else {
        if (subPath[depth] == 8) {
          subPath[depth] = 0;
          return 1;
        }
        else {
          subPath[depth] = subPath[depth] + recIncr;
          return 0;
        }
      }
    }
  }
  
}

