/*
 * Regrouper.java
 *
 * Created on 16 d?cembre 2002, 18:05
 */

package epe.annexTools.systematicOrganizationsStatisticTool.regrouper;

/**
 *
 * @author  george
 */

import epe.gui.SystemPrinter;
import epe.annexTools.systematicOrganizationsStatisticTool.regrouper.regroupFileManager.RegroupFileManager;

public class Regrouper {
  
  protected int[] links;
  protected int[] factorialLinks = {5,4,1,3,2,4,3,8,0,6,3,7};
  
  protected boolean pauseSet = false;
  protected boolean pauseOnCooperationSet = false;
  protected boolean started = false;

  protected java.lang.Thread testerRunner;
  protected Tester tester;
  protected boolean newOrganizationHasToBeLoaded = true;
  
  protected boolean hasLoaded = false;
  protected boolean nextFileHasToBeLoaded = false;
  
  // For saving the Organizations & position
  protected RegroupFileManager organizationSaver;
  //protected TesterPositionSaver positionSaver;
  protected int testPosition = 0;
  protected int savedPosition = 0;
  
  /** Creates a new instance of SystematicOrganizationTester */
  public Regrouper() {
    organizationSaver = new RegroupFileManager();
    started = true;
    startTester();
  }

  public synchronized void startTester() {
    tester = new Tester();
    java.lang.Thread testRunner = new java.lang.Thread(tester);
    pauseSet = false;
    testRunner.start();
  }
  
  public void loadOrganization() {
    //clearOldOrganization();
    links = organizationSaver.loadOrganization();
    if (links != null) {
      if (links[0] == -1)
        pause();
      else {
        //testPosition = organizationSaver.getLoadOrganizationCounter();
        //buildNewOrganization(); 
        hasLoaded = true;
      }
    }
    else
      nextFileHasToBeLoaded = true;
    //links = factorialLinks;
  }
  
  protected void launchCalculus() {
    organizationSaver.saveOrganization(links, organizationSaver.getTestedOrganizationNumber(),
                                              organizationSaver.getOriginalOrganizationNumber());
    hasLoaded = false;
  }
  
  public void pause() {
    pauseSet = true;
  }
  
  public void unPause() {
    pauseSet = false;
    tester.notifyThread();
  }
  
  public void startTesting() {
    started = true;
    tester.notifyThread();
  }
  
  // Inner class to be run as a thread
  public class Tester implements java.lang.Runnable {
    
    public Tester() {
    }
    
    public void run() {
      testTheOrganizations();
    }
    
    protected void testTheOrganizations() {
      //waitForEvent();
      while (true) {
        if (started && newOrganizationHasToBeLoaded) {
          if (pauseSet)
              waitForEvent();
          SystemPrinter.printSystem("NEXT ORGANIZATION");
          loadOrganization();
          if (hasLoaded)
            launchCalculus();
            newOrganizationHasToBeLoaded = true;
        }
      }
    }
       
       
    protected void waitForEvent() {
      synchronized(this) {
      try {
        SystemPrinter.printSystem("Waiting");
        this.wait();
      } catch(InterruptedException e) {
      }
    }
    }
    
    protected synchronized void notifyThread() {
     notifyAll(); 
    }
    
  }
  // End of inner class
  
}

