/*
 * AgentPool.java
 *
 * Created on 4 d?cembre 2002, 14:20
 */

package epe.annexTools.systematicOrganizationsStatisticTool.systematicOrganizationBuilder.agentPool;

/**
 *
 * @author  george
 */

import java.util.Vector;

import epe.agents.specificAgents.AgentEquals;
import epe.agents.specificAgents.AgentAddition;
import epe.agents.specificAgents.AgentMultiplication;
import epe.agents.specificAgents.AgentFirstTime;
import epe.agents.specificAgents.environment.AgentEnvironment;
import epe.agents.specificAgents.interfaceAgents.AgentIn;
import epe.agents.specificAgents.interfaceAgents.AgentOut;
import epe.agents.specificAgents.practicalAgents.AgentOne;

import epe.gui.ProgrammingEnvironment;
import epe.agents.Agent;

public class AgentPool {
  
  protected Vector<Object> storage;
  
  protected AgentEnvironment agentEnvironment;
  protected AgentOne agentOne1, agentOne2, agentOne3;
  protected AgentOut agentOut;
  protected AgentIn agentIn;
  protected AgentEquals agentEquals;
  protected AgentAddition agentAddition;
  protected AgentMultiplication agentMultiplication;
  protected AgentFirstTime agentFirstTime1, agentFirstTime2;
  
  protected ProgrammingEnvironment programmingEnvironment;
  
  /** Creates a new instance of AgentPool */
  public AgentPool() {
    storage = new Vector<Object>();
  }
  
  public void initAgentPool(ProgrammingEnvironment programmingEnvironment) {
    agentEnvironment = new AgentEnvironment("", programmingEnvironment.getCommandPanel());
    agentOne1 = new AgentOne("1");        
    agentOne2 = new AgentOne("2");        
    agentOne3 = new AgentOne("3");
    agentAddition = new AgentAddition("");
    agentMultiplication = new AgentMultiplication("");
    agentEquals = new AgentEquals("");
    agentFirstTime1 = new AgentFirstTime("1");
    agentFirstTime2 = new AgentFirstTime("2");
    agentIn = new AgentIn("");
    agentOut = new AgentOut("", programmingEnvironment.getCommandPanel());
    
    storage.addElement(agentOne1);            // pos 0
    storage.addElement(agentOne2);            // pos 1
    storage.addElement(agentOne3);            // pos 2
    storage.addElement(agentAddition);        // pos 3
    storage.addElement(agentMultiplication);  // pos 4
    storage.addElement(agentEquals);          // pos 5
    storage.addElement(agentFirstTime1);      // pos 6
    storage.addElement(agentFirstTime2);      // pos 7
    storage.addElement(agentIn);              // pos 8
    storage.addElement(agentOut);             // pos 9
    storage.addElement(agentEnvironment);     // pos 10
  }
  
  public Agent getAgentAt(int index) {
   return (Agent)storage.elementAt(index);
  }

  public int getSize() {
    return storage.size();
  }
  
}
