/*
 * LoopStateSaver.java
 *
 * Created on 17 dcembre 2002, 11:30
 */

package epe.annexTools.systematicOrganizationsStatisticTool.systematicOrganizationBuilder.loopStateSaver;

/**
 *
 * @author  george
 */

import java.io.FileOutputStream;
import java.io.ObjectOutputStream;
import java.io.FileInputStream;
import java.io.ObjectInputStream;

import java.net.URL;

public class LoopStateSaver {
  
  protected int[] loopInit;
  protected double numberOfBuiltOrganizations;
  protected double numberOfSearchedOrganizations;
  protected double numberOfCooperativeOrganizations;
  protected int saveOrganizationCounter;
  protected int loadOrganizationCounter;
  
  protected String relativePath = "data/annexTools/systematicOrganizationBuilder/loopStateSaver/saves/";
  protected URL absoluteURL;
  protected String file;
  
  /** Creates a new instance of LoopStateSaver */
  public LoopStateSaver() {
    absoluteURL = getClass().getResource("/" + relativePath);
    System.out.println(absoluteURL);
  }
  
  public void saveLoopState(int[] loopInit, 
                            double numberOfBuiltOrganizations, 
                            double numberOfSearchedOrganizations, 
                            double numberOfCooperativeOrganizations,
                            int saveOrganizationCounter,
                            int loadOrganizationCounter) {
    this.loopInit = loopInit;
    /*
    System.out.println("LoopState : ");
    for (int i=0; i<12; i++)
      System.out.print(loopInit[i] + " ");
    System.out.println();
    */
    try {
      file = absoluteURL.getFile() + "SavedLoopState";
      FileOutputStream out = new FileOutputStream(file);
      ObjectOutputStream s = new ObjectOutputStream(out);
      s.writeObject("LoopState");
      s.writeObject(loopInit);
      s.writeDouble(numberOfBuiltOrganizations);
      s.writeDouble(numberOfSearchedOrganizations);
      s.writeDouble(numberOfCooperativeOrganizations);
      s.writeInt(saveOrganizationCounter);
      s.writeInt(loadOrganizationCounter);
      s.flush();
    } catch (Exception e) {}
    
  }

  public void loadLoopState() {
    try {
      file = absoluteURL.getFile() + "SavedLoopState";
      FileInputStream in = new FileInputStream(file);
      ObjectInputStream s = new ObjectInputStream(in);
      String name = (String)s.readObject();
      loopInit = (int[])s.readObject();
      numberOfBuiltOrganizations = s.readDouble();
      numberOfSearchedOrganizations = s.readDouble();
      numberOfCooperativeOrganizations = s.readDouble();
      saveOrganizationCounter = s.readInt();
      loadOrganizationCounter = s.readInt();
      
      
      System.out.println(name);
      if (loopInit == null)
        System.out.println("ERROR : null");
      else {
        System.out.println("LoopState : ");
        for (int i=0; i<12; i++)
          System.out.print(loopInit[i] + " ");
        System.out.println();
      }
    } catch (Exception e) {
      System.out.println("ERROR : " +e);
    }
  }
  
  public int[] getLoopInit() {
    return this.loopInit;
  }
  
  public double getNumberOfBuiltOrganizations() {
    return numberOfBuiltOrganizations;
  }
  
  public double getNumberOfSearchedOrganizations() {
    return numberOfSearchedOrganizations;
  }
   
  public double getNumberOfCooperativeOrganizations() {
    return numberOfCooperativeOrganizations;
  }
  
  public int getSaveOrganizationCounter() {
    return saveOrganizationCounter;
  }
 
  public int getLoadOrganizationCounter() {
    return loadOrganizationCounter;
  }
}
