/*
 * OragnizationSaver.java
 *
 * Created on 16 dcembre 2002, 17:23
 */

package epe.annexTools.systematicOrganizationsStatisticTool.systematicOrganizationBuilder.organizationSaver;

/**
 *
 * @author  george
 */

import java.io.File;
import java.io.FileWriter;
import java.io.FileReader;

import java.net.URL;

public class OrganizationSaver {

  protected int[] links;
  protected int[] subPath = {5,4,0,3};
  protected String relativePath = "data/annexTools/systematicOrganizationBuilder/organizationSaver/saves";
  protected String relativePath2 = "data/annexTools/systematicOrganizationBuilder/organizationSaver/";
  protected URL absoluteURL;
  protected URL absoluteURL2;
  protected int saveOrganizationCounter = 1;
  protected int loadOrganizationCounter = 0;
  protected int testedOrganizationNumber;
  protected String file = "";
  protected String file2 = "";
  protected FileWriter writer;
  protected FileReader reader;
  String newline = System.getProperty("line.separator");
  
  /** Creates a new instance of OragnizationSaver */
  public OrganizationSaver() {
    absoluteURL = getClass().getResource("/" + relativePath);
    //System.out.println(absoluteURL);
  }
  
  public void saveOrganization(int[] links) {
    this.links = links;
    try {
      writer = openFileForWriting(links);
      writer.write(addZeros(saveOrganizationCounter));
      writer.write(new Integer(saveOrganizationCounter).toString());
      writer.write(" : ");
      for (int i=0; i<links.length; i++)
        writer.write(new Integer(links[i]).toString() + " ");
      writer.write(newline);
      writer.flush();
      //System.out.println("Written");
      saveOrganizationCounter++;
    } catch (Exception e) {
      System.out.println("ERROR : failled to write file : " + e);
    }
  }

  protected FileWriter openFileForWriting(int[] links) {
    try {
      file2 = absoluteURL.getFile();
      for (int i=0; i<4; i++) {
        file2 = file2 + "/" + links[i];
      }
      File dirFile = new File(file2);
      dirFile.mkdirs();
      file2 = file2 + "/" + "SavedOrganizations";
      if (!file2.equals(file)) {
        file = file2;
        writer = new FileWriter(file, true); 
      }
      return writer;
    } catch (Exception e) {
      System.out.println("ERROR : failled to open file for writing : " + e);
    }
    return null;
  }
  
  protected FileReader openFileForReading() {
    try {
      file2 = absoluteURL.getFile();
      for (int i=0; i<subPath.length; i++) {
          file2 = file2 + "/" + subPath[i];
      }
      file2 = file2 + "/" + "SavedOrganizations";
      if (!file2.equals(file)) {
        file = file2;
        reader = new FileReader(file); 
      }
      return reader;
    } catch (Exception e) {
      System.out.println("ERROR : failled to open file for reading : " + e);
    }
    return null;
  }
  
  public void positionTheReader(int position) {
    try {
      reader = openFileForReading();
      // Go to saved position
      for (int k=0; k<position; k++)
        for (int i=0; i<38; i++)
          reader.read();
        
    } catch (Exception e) {
      System.out.println("ERROR : failled to position the reader in the file : " + e);
    }
  }
  
  public int[] loadOrganization() {
    links = new int[12];
    String organizationNumber;
    
    try {
      reader = openFileForReading();
      
      String s = "";
      for (int i=0; i<9; i++) {
        s = s + (char)reader.read();
      }
      organizationNumber = s;
      testedOrganizationNumber = (new Integer(organizationNumber+"")).intValue();
      loadOrganizationCounter++;
      System.out.println("Loading organization number/counter : " + organizationNumber 
                         + "/" + loadOrganizationCounter);
      for (int i=0; i<3; i++) {
        reader.read();
      }
      
      char nb;
      System.out.println("loading numbers");
      for (int i=0; i<12; i++) {
        nb = (char)reader.read();
        links[i] = (new Integer(nb+"")).intValue();
        reader.read();
      }
      reader.read();
      reader.read();
      
      if (links == null)
        System.out.println("ERROR : null");
      else {
        System.out.println("Links : ");
        for (int i=0; i<12; i++)
          System.out.print(links[i] + " ");
        System.out.println();
        return links;
      }
      
    } catch (Exception e) {
      System.out.println("ERROR : failled to load file : " + e);
    }
    return null;
  }
  
  /*
  public int[] loadOrganization() {
    boolean loadSucceeded = false;
    boolean ended = false;
    
    while ((!loadSucceeded)&&(!ended)) {
      try {
        file = absoluteURL.getFile();
        for (int i=0; i<subPath.length; i++) {
          file = file + "/" + subPath[i];
        }
        String result = incrementSubPath();
        if (result == "END")
          ended = true;

        file = file + "/" + "SavedOrganizations";
        FileReader reader = new FileReader(file);
        String organizationNumber;
        String s = "";
        
        for (int i=0; i<loadOrganizationCounter*37; i++) {
          reader.read();
        }
        for (int i=0; i<9; i++) {
          s = s + reader.read();
        }
        organizationNumber = s;
        System.out.println(organizationNumber);
        
        //loadFileCounter++;
        //FileInputStream in = new FileInputStream(file);
        //ObjectInputStream s = new ObjectInputStream(in);
        //String name = (String)s.readObject();
        //links = (int[])s.readObject();
        //System.out.println(name);
        if (links == null)
          System.out.println("ERROR : null");
        else {
          System.out.println("Links : ");
          for (int i=0; i<12; i++)
            System.out.print(links[i] + " ");
          System.out.println();
        }
        loadSucceeded = true;
      } catch (Exception e) {
        System.out.println("ERROR : failled to load file : " + e);
        
      }
      try {
        System.in.read();
        //System.in.read();
      } catch (Exception e) {}
    }
    
    if (loadSucceeded)
      return links;
    else
    return null;
  }
  */
    
  public int getSaveOrganizationCounter() {
    return saveOrganizationCounter;
  }  
  
  public void setSaveOrganizationCounter(int saveOrganizationCounter) {
    this.saveOrganizationCounter = saveOrganizationCounter;
  }
  
  public int getLoadOrganizationCounter() {
    return loadOrganizationCounter;
  }
  
  public int getTestedOrganizationNumber() {
    return testedOrganizationNumber;
  }
  
  public void setLoadOrganizationCounter(int loadOrganizationCounter) {
    this.loadOrganizationCounter = loadOrganizationCounter;
  }
  
  protected String addZeros(int counter) {
    if (counter<10)
      return "00000000";
    else if (counter<100)
      return "0000000";
    else if (counter<1000)
      return "000000";
    else if (counter<10000)
      return "00000";
    else if (counter<100000)
      return "0000";
    else if (counter<1000000)
      return "000";
    else if (counter<10000000)
      return "00";
    else if (counter<100000000)
      return "0";
    else 
      return "";
  }
  
  protected String incrementSubPath() {
    int incResult = recursiveIncrementer(0);
    if (incResult!=0) {
      System.out.println("LAST ORGANIZATION REACHED");
      for (int i = 0 ; i<subPath.length ; i++)
        System.out.print(subPath[i] + "|");
      System.out.println();
      return "END";
    }
    else {
      for (int i = 0 ; i<subPath.length ; i++)
        System.out.print(subPath[i] + "|");
      System.out.println();
      return "DONE"; 
    }
  }
  
  protected int recursiveIncrementer(int depth) {
    if (depth == 10) {
      if (subPath[depth] == 8) {
        subPath[depth] = 0;
        return 1;
      }
      else {
        subPath[depth]++;
        return 0;
      }
    }
    else {
      int recIncr = recursiveIncrementer(depth+1);
      if (recIncr == 0) {
        return 0;
      }
      else {
        if (subPath[depth] == 8) {
          subPath[depth] = 0;
          return 1;
        }
        else {
          subPath[depth] = subPath[depth] + recIncr;
          return 0;
        }
      }
    }
  }
  
}

