package epe.calculus;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import epe.gui.ProgrammingEnvironment;
import epe.gui.SystemPrinter;
import epe.agents.acquaintances.TrustValue;
import epe.agents.specificAgents.AgentAddition;
import epe.agents.specificAgents.AgentConstant;
import epe.agents.specificAgents.AgentMultiplication;
import epe.agents.specificAgents.environment.AgentEnvironmentReceiver;
import epe.agents.specificAgents.interfaceAgents.AgentOutWithoutControl;
import epe.observationTools.messageSendObserver.MessageSendObserver;
import epe.observationTools.ncsObserver.NcsObserver;


public class CalculusAddMult extends Test implements ActionListener, Runnable{
  
    protected Thread executingThread;
    protected boolean stopAllAgentsOrderSend = false;
    protected boolean startWorkingOrderSend = false;
    protected final static int ONE_SECOND = 1000;
    protected int delay = ONE_SECOND/2;

    protected AgentEnvironmentReceiver agentEnvironment;
    protected AgentConstant agentConstantA, agentConstantB, agentConstantC;
    protected AgentOutWithoutControl agentOut;
    protected AgentAddition agentAddition1;
    protected AgentAddition agentAddition2;
    protected AgentMultiplication agentMultiplication;
    
    protected ProgrammingEnvironment programmingEnvironment;
    protected NcsObserver ncsObserver;
    protected MessageSendObserver messageSendObserver;

    public CalculusAddMult() {
    executingThread = new Thread(this);
    executingThread.start();
    programmingEnvironment = new ProgrammingEnvironment();
    ncsObserver = new NcsObserver();
    messageSendObserver = new MessageSendObserver();
    programmingEnvironment.setVisible(true);
    programmingEnvironment.getCommandPanel().initTest(this);
    initTest();
  }
  
  public void initTest() {
    agentEnvironment = new AgentEnvironmentReceiver("", programmingEnvironment.getCommandPanel());
    agentEnvironment.setProgrammingEnvironment(programmingEnvironment);
    agentEnvironment.addNcsListener(ncsObserver);
    agentEnvironment.addMessageSendListener(messageSendObserver);
          
    agentConstantA = new AgentConstant("A", 2);
    agentConstantA.setProgrammingEnvironment(programmingEnvironment);
    agentConstantA.addNcsListener(ncsObserver);
    agentConstantA.addMessageSendListener(messageSendObserver);

    agentConstantB = new AgentConstant("B", 10);
    agentConstantB.setProgrammingEnvironment(programmingEnvironment);
    agentConstantB.addNcsListener(ncsObserver);
    agentConstantB.addMessageSendListener(messageSendObserver);
    
    agentConstantC = new AgentConstant("C", 100);
    agentConstantC.setProgrammingEnvironment(programmingEnvironment);
    agentConstantC.addNcsListener(ncsObserver);
    agentConstantC.addMessageSendListener(messageSendObserver);
        
    agentAddition1 = new AgentAddition("1");
    agentAddition1.setProgrammingEnvironment(programmingEnvironment);
    agentAddition1.addNcsListener(ncsObserver);
    agentAddition1.addMessageSendListener(messageSendObserver);

    agentAddition2 = new AgentAddition("2");
    agentAddition2.setProgrammingEnvironment(programmingEnvironment);
    agentAddition2.addNcsListener(ncsObserver);
    agentAddition2.addMessageSendListener(messageSendObserver);
    
    agentMultiplication = new AgentMultiplication("");
    agentMultiplication.setProgrammingEnvironment(programmingEnvironment);
    agentMultiplication.addNcsListener(ncsObserver);
    agentMultiplication.addMessageSendListener(messageSendObserver);
    
    agentOut = new AgentOutWithoutControl("", programmingEnvironment.getCommandPanel());
    agentOut.setProgrammingEnvironment(programmingEnvironment);
    agentOut.addNcsListener(ncsObserver);
    agentOut.addMessageSendListener(messageSendObserver);
    
    
    agentConstantA.setLocation(0,0);
    agentConstantB.setLocation(0,1);
    agentConstantC.setLocation(0,2);
    agentAddition1.setLocation(2,0);
    agentAddition2.setLocation(3,1);
    agentMultiplication.setLocation(2,2);
    agentOut.setLocation(4,4);
    agentEnvironment.setLocation(3,8);

    agentEnvironment.start();
    agentConstantA.start();
    agentConstantB.start();
    agentConstantC.start();
    agentAddition1.start();
    agentAddition2.start();
    agentMultiplication.start();
    agentOut.start();

    // Out, Environment
    agentOut.addAcquaintance(agentEnvironment, "OUT", 1, TrustValue.FIXEDTRUSTVALUE);
    agentEnvironment.addAcquaintance(agentOut, "IN", 1, TrustValue.FIXEDTRUSTVALUE);
  
    // All Agents <--> AgentOut  (NEUTRAL)
    agentConstantA.addAcquaintance(agentOut, "NEUTRAL", 0);
    agentConstantB.addAcquaintance(agentOut, "NEUTRAL", 0);
    agentConstantC.addAcquaintance(agentOut, "NEUTRAL", 0);
    agentAddition1.addAcquaintance(agentOut, "NEUTRAL", 0);
    agentAddition2.addAcquaintance(agentOut, "NEUTRAL", 0);
    agentMultiplication.addAcquaintance(agentOut, "NEUTRAL", 0);
    
    agentOut.addAcquaintance(agentConstantA, "NEUTRAL", 0);
    agentOut.addAcquaintance(agentConstantB, "NEUTRAL", 0);
    agentOut.addAcquaintance(agentConstantC, "NEUTRAL", 0);
    agentOut.addAcquaintance(agentAddition1, "NEUTRAL", 0);
    agentOut.addAcquaintance(agentAddition2, "NEUTRAL", 0);
    agentOut.addAcquaintance(agentMultiplication, "NEUTRAL", 0);
   
    programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentConstantA);
    programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentConstantB);
    programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentConstantC);
    programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentOut);
    programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentAddition1);
    programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentAddition2);
    programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentMultiplication);
  
  }
 
  protected synchronized void pause(int delay) {
    SystemPrinter.printSystem("Waiting a little.");
      try {
        wait(delay);
      } catch (InterruptedException e) {
      }
  }

  public synchronized void actionPerformed(ActionEvent ev) {
    if (ev.getActionCommand().equals("Stop all agents")) {
      SystemPrinter.printSystem("Received event : stop all agents.");
      stopAllAgentsOrderSend = true;
      notifyAll();
    }
    else if (ev.getActionCommand().equals("Start Working")) {
      SystemPrinter.printSystem("Received event : start working.");
      startWorkingOrderSend = true;
      notifyAll();
    }
    else if (ev.getActionCommand().equals("Feedback")) {
      SystemPrinter.printSystem("Received event : Feedback.");
      agentEnvironment.feedback();
    }
    else if (ev.getActionCommand().equals("Clear Logs & Feedback")) {
      SystemPrinter.printSystem("Received event : Clear logs & Feedback.");
      clearAgentLogs();
      agentEnvironment.feedback();
    }
    else SystemPrinter.printSystem("ERROR : Test : unknown event : " + ev.getActionCommand());
  }

  public void clearAgentLogs() {
  	agentConstantA.getGUI().clearLog();
    agentConstantB.getGUI().clearLog();
    agentConstantC.getGUI().clearLog();
    agentAddition1.getGUI().clearLog();
    agentAddition2.getGUI().clearLog();
    agentMultiplication.getGUI().clearLog();
    agentOut.getGUI().clearLog();
    agentEnvironment.getGUI().clearLog();
  }
  
  public void run() {
    while (true) {
      if (stopAllAgentsOrderSend) {
        agentEnvironment.disableAgent();
        agentConstantA.disableAgent();
        agentConstantB.disableAgent();
        agentConstantC.disableAgent();
        agentAddition1.disableAgent();
        agentAddition2.disableAgent();
        agentMultiplication.disableAgent();
        agentOut.disableAgent();
        
        stopAllAgentsOrderSend = false;
      }
      if (startWorkingOrderSend) {
        agentEnvironment.disableAgent();
        agentConstantA.disableAgent();
        agentConstantB.disableAgent();
        agentConstantC.disableAgent();
        agentAddition1.disableAgent();
        agentAddition2.disableAgent();
        agentMultiplication.disableAgent();
        agentOut.disableAgent();

        agentEnvironment.reInitializeOrder();
        agentConstantA.reInitializeOrder();
        agentConstantB.reInitializeOrder();
        agentConstantC.reInitializeOrder();
        agentAddition1.reInitializeOrder();
        agentAddition2.reInitializeOrder();
        agentMultiplication.reInitializeOrder();
        agentOut.reInitializeOrder();

        pause(delay);
        
        agentEnvironment.enableAgent();
        agentConstantA.enableAgent();
        agentConstantB.enableAgent();
        agentConstantC.enableAgent();
        agentAddition1.enableAgent();
        agentAddition2.enableAgent();
        agentMultiplication.enableAgent();
        agentOut.enableAgent();

        agentEnvironment.startAgent();
        agentConstantA.startAgent();
        agentConstantB.startAgent();
        agentConstantC.startAgent();
        agentAddition1.startAgent();
        agentAddition2.startAgent();
        agentMultiplication.startAgent();
        agentOut.startAgent();
        
        startWorkingOrderSend = false;
      }
      
      synchronized(this) {
          try {
            SystemPrinter.printSystem("Waiting for an event.");
              this.wait();
          } catch(InterruptedException e) {}
      }
    }
  }
  
}

