  /*
 * SelfOrganizingPseudoFactorielle.java
 *
 * Created on 23 avril 2000, 19:16
 */

package epe.calculus;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import epe.gui.ProgrammingEnvironment;
import epe.gui.SystemPrinter;
import epe.agents.specificAgents.AgentAddition;
import epe.agents.specificAgents.AgentEquals;
import epe.agents.specificAgents.AgentFirstTime;
import epe.agents.specificAgents.AgentMultiplication;
import epe.agents.specificAgents.environment.AgentEnvironment;
import epe.agents.specificAgents.interfaceAgents.AgentIn;
import epe.agents.specificAgents.interfaceAgents.AgentOut;
import epe.agents.specificAgents.practicalAgents.AgentOne;
import epe.observationTools.messageSendObserver.MessageSendObserver;
import epe.observationTools.ncsObserver.NcsObserver;


/**
 *
 * @author  Jean-Pierre Georg?
 * @version
 */
public class IncrementTest extends Test implements ActionListener, Runnable{
  
    protected Thread executingThread;
    protected boolean stopAllAgentsOrderSend = false;                                                        
    protected boolean startWorkingOrderSend = false;
    protected final static int ONE_SECOND = 1000;
    protected int delay = ONE_SECOND/2;
                                                        
    protected AgentEnvironment agentEnvironment;
    protected AgentOne agentOne1, agentOne2, agentOne3;
    protected AgentOut agentOut;
    protected AgentIn agentIn;
    protected AgentEquals agentEquals;
    protected AgentAddition agentAddition;
    protected AgentMultiplication agentMultiplication;
    protected AgentFirstTime agentFirstTime1, agentFirstTime2;
    
    protected ProgrammingEnvironment programmingEnvironment;
    protected NcsObserver ncsObserver;
    protected MessageSendObserver messageSendObserver;
                            
  /** Creates new SelfOrganizingPseudoFactorial */ 
    public IncrementTest() {
    executingThread = new Thread(this);
    executingThread.start();
    programmingEnvironment = new ProgrammingEnvironment();
    ncsObserver = new NcsObserver();
    messageSendObserver = new MessageSendObserver();
    programmingEnvironment.setVisible(true);
    programmingEnvironment.getCommandPanel().initTest(this);
  }
  
  public void initTest() {
    agentEnvironment = new AgentEnvironment("", programmingEnvironment.getCommandPanel());
    agentEnvironment.setProgrammingEnvironment(programmingEnvironment);
    agentEnvironment.addNcsListener(ncsObserver);
    agentEnvironment.addMessageSendListener(messageSendObserver);
    
    agentOne1 = new AgentOne("1");
    agentOne1.setProgrammingEnvironment(programmingEnvironment);
    agentOne1.addNcsListener(ncsObserver);
    agentOne1.addMessageSendListener(messageSendObserver);

    agentOne2 = new AgentOne("2");
    agentOne2.setProgrammingEnvironment(programmingEnvironment);
    agentOne2.addNcsListener(ncsObserver);
    agentOne2.addMessageSendListener(messageSendObserver);
    /*
    agentOne3 = new AgentOne("3");
    agentOne3.setProgrammingEnvironment(programmingEnvironment);
    agentOne3.addNcsListener(ncsObserver);
    agentOne3.addMessageSendListener(messageSendObserver);
    */
    agentFirstTime1 = new AgentFirstTime("1");
    agentFirstTime1.setProgrammingEnvironment(programmingEnvironment);
    agentFirstTime1.addNcsListener(ncsObserver);
    agentFirstTime1.addMessageSendListener(messageSendObserver);
    
    agentAddition = new AgentAddition("");
    agentAddition.setProgrammingEnvironment(programmingEnvironment);
    agentAddition.addNcsListener(ncsObserver);
    agentAddition.addMessageSendListener(messageSendObserver);

    agentOut = new AgentOut("", programmingEnvironment.getCommandPanel());
    agentOut.setProgrammingEnvironment(programmingEnvironment);
    agentOut.addNcsListener(ncsObserver);
    agentOut.addMessageSendListener(messageSendObserver);
    
    agentIn = new AgentIn("");
    agentIn.setProgrammingEnvironment(programmingEnvironment);
    agentIn.addNcsListener(ncsObserver);
    agentIn.addMessageSendListener(messageSendObserver);
    
    agentEquals = new AgentEquals("");
    agentEquals.setProgrammingEnvironment(programmingEnvironment);
    agentEquals.addNcsListener(ncsObserver);
    agentEquals.addMessageSendListener(messageSendObserver);
    
    agentOne1.setLocation(0,0);
    agentOne2.setLocation(0,1);
    //agentOne3.setLocation(0,2);
    agentAddition.setLocation(2,0);
    agentFirstTime1.setLocation(2,4);
    agentOut.setLocation(5,3);
    agentIn.setLocation(0,5);
    agentEquals.setLocation(4,4);
    agentEnvironment.setLocation(3,8);

    agentEnvironment.start();
    agentOne1.start();
    agentOne2.start();
    //agentOne3.start();
    agentFirstTime1.start();
    agentAddition.start();
    agentOut.start();
    agentIn.start();
    agentEquals.start();

    // Environment, In
    agentEnvironment.addAcquaintance(agentIn, "OUT", 1, true);
    agentIn.addAcquaintance(agentEnvironment, "IN", 1, true);
    // Out, Environment
    agentOut.addAcquaintance(agentEnvironment, "OUT", 1, true);
    agentEnvironment.addAcquaintance(agentOut, "IN", 1, true);
  
    // All Agents <--> AgentIn  (NEUTRAL)
    agentOne1.addAcquaintance(agentIn, "NEUTRAL", 0);
    agentOne2.addAcquaintance(agentIn, "NEUTRAL", 0);
    //agentOne3.addAcquaintance(agentIn, "NEUTRAL", 0);
    agentFirstTime1.addAcquaintance(agentIn, "NEUTRAL", 0);
    agentAddition.addAcquaintance(agentIn, "NEUTRAL", 0);
    agentEquals.addAcquaintance(agentIn, "NEUTRAL", 0);
    agentOut.addAcquaintance(agentIn, "NEUTRAL", 0);
    
    agentIn.addAcquaintance(agentOne1, "NEUTRAL", 0);
    agentIn.addAcquaintance(agentOne2, "NEUTRAL", 0);
    //agentIn.addAcquaintance(agentOne3, "NEUTRAL", 0);
    agentIn.addAcquaintance(agentFirstTime1, "NEUTRAL", 0);
    agentIn.addAcquaintance(agentAddition, "NEUTRAL", 0);
    agentIn.addAcquaintance(agentEquals, "NEUTRAL", 0);
    agentIn.addAcquaintance(agentOut, "NEUTRAL", 0);
   
    programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentOne1);
    programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentOne2);
    //programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentOne3);
    programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentFirstTime1);
    programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentOut);
    programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentIn);
    programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentEquals);
    programmingEnvironment.getEnvironmentBackground().getLinks().updateLink(agentAddition);
  
  }
 
  protected synchronized void pause(int delay) {
    SystemPrinter.printSystem("Waiting a little.");
      try {
        wait(delay);
      } catch (InterruptedException e) {
      }
  }

  public synchronized void actionPerformed(ActionEvent ev) {
    if (ev.getActionCommand().equals("Stop all agents")) {
      SystemPrinter.printSystem("Received event : stop all agents.");
      stopAllAgentsOrderSend = true;
      notifyAll();
    }
    else { //(ev.getActionCommand().equals("Start Working")) 
      SystemPrinter.printSystem("Received event : start working.");
      startWorkingOrderSend = true;
      notifyAll();
    }
    
    //else SystemPrinter.printSystem("ERROR : Test : unknown event : " + ev.getActionCommand());
  }

  public void run() {
    while (true) {
      if (stopAllAgentsOrderSend) {
        agentEnvironment.disableAgent();
        agentOne1.disableAgent();
        agentOne2.disableAgent();
        //agentOne3.disableAgent();
        agentFirstTime1.disableAgent();
        agentAddition.disableAgent();
        agentEquals.disableAgent();
        agentOut.disableAgent();
        agentIn.disableAgent();
        
        stopAllAgentsOrderSend = false;
      }
      if (startWorkingOrderSend) {
        agentEnvironment.disableAgent();
        agentOne1.disableAgent();
        agentOne2.disableAgent();
        //agentOne3.disableAgent();
        agentFirstTime1.disableAgent();
        agentAddition.disableAgent();
        agentEquals.disableAgent();
        agentOut.disableAgent();
        agentIn.disableAgent();

        agentEnvironment.reInitializeOrder();
        agentOne1.reInitializeOrder();
        agentOne2.reInitializeOrder();
        //agentOne3.reInitializeOrder();
        agentFirstTime1.reInitializeOrder();
        agentAddition.reInitializeOrder();
        agentEquals.reInitializeOrder();
        agentOut.reInitializeOrder();
        agentIn.reInitializeOrder();

        pause(delay);
        
        agentEnvironment.enableAgent();
        agentOne1.enableAgent();
        agentOne2.enableAgent();
        //agentOne3.enableAgent();
        agentFirstTime1.enableAgent();
        agentAddition.enableAgent();
        agentEquals.enableAgent();
        agentOut.enableAgent();
        agentIn.enableAgent();

        agentEnvironment.startAgent();
        agentOne1.startAgent();
        agentOne2.startAgent();
        //agentOne3.startAgent();
        agentFirstTime1.startAgent();
        agentAddition.startAgent();
        agentEquals.startAgent();
        agentOut.startAgent();
        agentIn.startAgent();
        
        startWorkingOrderSend = false;
      }
      
      synchronized(this) {
          try {
            SystemPrinter.printSystem("Waiting for an event.");
              this.wait();
          } catch(InterruptedException e) {}
      }
    }
  }
  
}

