package epe.communication;

import epe.agents.Agent;

public class Message extends Object implements java.lang.Cloneable {
  
		// Message IDs
		// Generic
		public static final String GENERIC_MESSAGE 
																 = "GenericMessage";
		
		// Contract Messages
		public static final String ACKNOWLEDGING_COOPERATION_MESSAGE 
																 = "AcknowledgingCooperationMessage";
		public static final String CANCELLING_COOPERATION_MESSAGE 
																 = "CancellingCooperationMessage";
		public static final String DATATYPE_CHANGED_MESSAGE 
																 = "DataTypeChangedMessage";
		public static final String PROPOSING_COOPERATION_IN_WITH_POTENTIAL_VALUE_MESSAGE 
																 = "ProposingCooperationInWithPotentialValueMessage";
		public static final String PROPOSING_COOPERATION_MESSAGE 
																 = "ProposingCooperationMessage";
		public static final String PROPOSING_COOPERATION_OUT_WITH_PREJUDICE_MESSAGE 
																 = "ProposingCooperationOutWithPrejudiceMessage";
		public static final String REFUSING_COOPERATION_MESSAGE 
																 = "RefusingCooperationMessage";
		public static final String REQUESTING_COOPERATION_MESSAGE 
																 = "RequestingCooperationMessage";
		public static final String POTENTIAL_OUTPUT_MESSAGE 
																 = "PotentialOutputMessage";
		public static final String GOAL_REACHED_MESSAGE 
																 = "GoalReachedMessage";
		public static final String LINK_MULTIPLICITY_CHANGED_MESSAGE 
																 = "LinkMultiplicityChangedMessage";
		public static final String CYCLE_PING_MESSAGE 
																 = "CyclePingMessage";
		
		//Data Messages
		public static final String BOOLEAN_MESSAGE 
																 = "BooleanMessage";
		public static final String NUMBER_MESSAGE 
																 = "NumberMessage";
		public static final String READY_TO_RECEIVE_MESSAGE 
																 = "ReadyToReceiveMessage";
		
		// NCS Messages
		public static final String NCS_INADEQUATE_DATA_MESSAGE 
																 = "NCSInadequateDataMessage";
		public static final String NCS_INFORMED_INADEQUATE_DATA_MESSAGE 
																 = "NCSInformedInadequateDataMessage";
		public static final String NCS_INFORMED_NEED_IN_MESSAGE 
																 = "NCSInformedNeedInMessage";
		public static final String NCS_MISSING_DATA_MESSAGE 
																 = "NCSMissingDataMessage";
		public static final String NCS_NEED_IN_MESSAGE 
																 = "NCSNeedInMessage";
		public static final String NCS_NEED_OUT_MESSAGE 
																 = "NCSNeedOutMessage";
		public static final String NCS_NO_POTENTIAL_OUTPUT_MESSAGE 
																 = "NCSNoPotentialOutputMessage";
		// End of Message IDs
	
		
		protected String id = Message.GENERIC_MESSAGE;  // Identification
		protected String stringValue = "Default Content";
		protected Agent sender;

	
		
	public Message() {
	}
	
	public Message(Agent sender) {
		this.sender = sender;
	}	
		
	public String getId() {
		return id;
	}
	
	public String getStringValue() {
		return stringValue;
	}
	
	public void setSender(Agent sender) {
		this.sender = sender;
	}
	
	public Agent getSender() {
		return sender;
	}
	
	public Message copyMessage() {
		Message returnMessage;
		try {
			returnMessage =  (Message)((Object)this.clone());
			return returnMessage;
		} catch (java.lang.CloneNotSupportedException e) {
			return null;
		}
	}
  
}