package epe.communication.messages.contract;

import epe.communication.Message;
import epe.agents.Agent;
import epe.agents.agentInterface.AgentInterface;

public class AcknowledgingCooperationMessage extends Message {
  
		// In case of an IN acknowledgment, the value the agent expects to be able to produce
		protected AgentInterface interfaceType;
	  protected int potentialValue;
  
  public AcknowledgingCooperationMessage(Agent sender, 
                                         AgentInterface interfaceType, 
                                         int potentialValue) {
  	this.id = Message.ACKNOWLEDGING_COOPERATION_MESSAGE;
    this.sender = sender;
    this.interfaceType = interfaceType;
    this.potentialValue = potentialValue;
  }
  
  public AgentInterface getInterfaceType() {
    return interfaceType;
  }
  
	public void setInterfaceType(AgentInterface interfaceType) {
		this.interfaceType = interfaceType;
	}

  public int getPotentialValue() {
    return potentialValue;
  }
 
  public Message copyMessage() {
  	AcknowledgingCooperationMessage returnMessage;
  	try {
  		returnMessage =  (AcknowledgingCooperationMessage)((Object)this.clone());
  		returnMessage.setInterfaceType(this.getInterfaceType().copyAgentInterface());
  		return returnMessage;
  	} catch (java.lang.CloneNotSupportedException e) {
  		return null;
  	}
  }

}