package epe.communication.messages.contract;

import epe.communication.Message;
import epe.agents.Agent;
import epe.agents.agentInterface.AgentInterface;

public class CancellingCooperationMessage extends Message {

  	protected AgentInterface interfaceType;

  public CancellingCooperationMessage(Agent sender,AgentInterface interfaceType) {
  	this.id = Message.CANCELLING_COOPERATION_MESSAGE;
    this.sender = sender;
    this.interfaceType = interfaceType;
  }

  public AgentInterface getInterfaceType() {
    return interfaceType;
  }

	public void setInterfaceType(AgentInterface interfaceType) {
		this.interfaceType = interfaceType;
	}
	
	public Message copyMessage() {
		CancellingCooperationMessage returnMessage;
		try {
			returnMessage =  (CancellingCooperationMessage)((Object)this.clone());
			returnMessage.setInterfaceType(this.getInterfaceType().copyAgentInterface());
			return returnMessage;
		} catch (java.lang.CloneNotSupportedException e) {
			return null;
		}
	}
}
