package epe.communication.messages.contract;

import epe.communication.Message;
import epe.gui.SystemPrinter;
import epe.agents.Agent;
import epe.agents.agentInterface.AgentInterface;

public class ProposingCooperationInWithPotentialValueMessage extends Message {

	  protected AgentInterface interfaceType;
	  protected int potentialValue;
	  // Tells what the agent tries to do, e.g. HIGHER = the agents tries to produce ? higher value
	  protected String personalGoal = "UNAFFECTED"; // UNKNOWN, HIGHER, LOWER
	  protected boolean inNeedInOutNcs;

  public ProposingCooperationInWithPotentialValueMessage(Agent sender, 
																												 AgentInterface interfaceType, 
																												 int potentialValue, 
																												 String personalGoal,
																												 boolean inNeedInOutNcs) {
  	this.id = Message.PROPOSING_COOPERATION_IN_WITH_POTENTIAL_VALUE_MESSAGE;
    this.sender = sender;
    this.interfaceType = interfaceType;
    this.potentialValue = potentialValue;
    if (personalGoal.equals("HIGHER") || 
        personalGoal.equals("LOWER") ||
        personalGoal.equals("UNKNOWN"))
      this.personalGoal = personalGoal;
    else {
      SystemPrinter.printSystem("ERROR : " + sender.getAgentName());
      sender.errorHappened();
      sender.getGUI().println(sender.getAgentName() 
                       + " : ERROR : wrong potentialGoal while creating " 
                       + " ProposingCooperationWithPotentialValueMessageContent "
                       + ".", java.awt.Color.red);
    }
    this.inNeedInOutNcs = inNeedInOutNcs;
  }

  public AgentInterface getInterfaceType() {
    return interfaceType;
  }

	public void setInterfaceType(AgentInterface interfaceType) {
		this.interfaceType = interfaceType;
	}
	
  public String getDataType() {
    return interfaceType.getDataType();
  }

  public int getPotentialValue() {
    return potentialValue;
  }
  
  public String getPersonalGoal() {
    return personalGoal;
  }
 
  public boolean isInNeedInOutNcs() {
		return inNeedInOutNcs;
	}
  
  public Message copyMessage() {
  	ProposingCooperationInWithPotentialValueMessage returnMessage;
  	try {
  		returnMessage =  (ProposingCooperationInWithPotentialValueMessage)((Object)this.clone());
  		returnMessage.setInterfaceType(this.getInterfaceType().copyAgentInterface());
  		return returnMessage;
  	} catch (java.lang.CloneNotSupportedException e) {
  		return null;
  	}
  }

}