package epe.communication.messages.contract;

import epe.communication.Message;
import epe.agents.Agent;
import epe.agents.agentInterface.AgentInterface;

public class ProposingCooperationMessage extends Message {

	  protected AgentInterface interfaceType;
		// proposedINnumber : When proposing for neddOUT, tells which IN is proposed
	  protected int proposedINnumber = -1;
	  protected boolean inNeedInOutNcs;

  public ProposingCooperationMessage(Agent sender, 
									 									 AgentInterface interfaceType,
									 									 boolean inNeedInOutNcs) {
  	this.id = Message.PROPOSING_COOPERATION_MESSAGE;
    this.sender = sender;
    this.interfaceType = interfaceType;
    this.inNeedInOutNcs = inNeedInOutNcs;
  }

  public ProposingCooperationMessage(Agent sender, 
  																	 AgentInterface interfaceType, 
  																	 int proposedINnumber,
																	 	 boolean inNeedInOutNcs) {
  	this.id = Message.PROPOSING_COOPERATION_MESSAGE;
	  this.sender = sender;
	  this.interfaceType = interfaceType;
	  this.proposedINnumber = proposedINnumber;
	  this.inNeedInOutNcs = inNeedInOutNcs;
	}
	
  public AgentInterface getInterfaceType() {
    return interfaceType;
  }

	public void setInterfaceType(AgentInterface interfaceType) {
		this.interfaceType = interfaceType;
	}
	
	public int getProposedINnumber() {
		return proposedINnumber;
	}
	
  public String getDataType() {
    return interfaceType.getDataType();
  }

  public boolean isInNeedInOutNcs() {
		return inNeedInOutNcs;
	}
  
  public Message copyMessage() {
  	ProposingCooperationMessage returnMessage;
  	try {
  		returnMessage =  (ProposingCooperationMessage)((Object)this.clone());
  		returnMessage.setInterfaceType(this.getInterfaceType().copyAgentInterface());
  		return returnMessage;
  	} catch (java.lang.CloneNotSupportedException e) {
  		return null;
  	}
  }

}