package epe.communication.messages.contract;

import epe.communication.Message;
import epe.agents.Agent;
import epe.agents.agentInterface.AgentInterface;

public class ProposingCooperationOutWithPrejudiceMessage extends Message {

	  protected AgentInterface interfaceType;
	  protected int proposedINnumber;
	  protected int sufferedPrejudice;
	  protected String multiplicity;
	  protected boolean inGoalReachedState;

  public ProposingCooperationOutWithPrejudiceMessage(Agent sender, 
																										 AgentInterface interfaceType,
																										 int proposedINnumber, 
																										 int sufferedPrejudice,
																										 String multiplicity,
																										 boolean inGoalReachedState) {
  	this.id = Message.PROPOSING_COOPERATION_OUT_WITH_PREJUDICE_MESSAGE;
    this.sender = sender;
    this.interfaceType = interfaceType;
    this.proposedINnumber = proposedINnumber;
    this.sufferedPrejudice = sufferedPrejudice;
    this.multiplicity = multiplicity;
    this.inGoalReachedState = inGoalReachedState;
  }

  public AgentInterface getInterfaceType() {
    return interfaceType;
  }

	public void setInterfaceType(AgentInterface interfaceType) {
		this.interfaceType = interfaceType;
	}
	
  public String getDataType() {
    return interfaceType.getDataType();
  }
  
	public int getProposedINnumber() {
		return proposedINnumber;
	}

  public int getSufferedPrejudice() {
    return sufferedPrejudice;
  }

  public String getMultiplicity() {
  	return multiplicity;
  }
  
  public boolean isInGoalReachedState() {
		return inGoalReachedState;
	}
  
  public Message copyMessage() {
  	ProposingCooperationOutWithPrejudiceMessage returnMessage;
  	try {
  		returnMessage =  (ProposingCooperationOutWithPrejudiceMessage)((Object)this.clone());
  		returnMessage.setInterfaceType(this.getInterfaceType().copyAgentInterface());
  		return returnMessage;
  	} catch (java.lang.CloneNotSupportedException e) {
  		return null;
  	}
  }

}