package epe.communication.messages.contract;

import epe.communication.Message;
import epe.agents.Agent;
import epe.agents.agentInterface.AgentInterface;

public class RefusingCooperationMessage extends Message {
  
  	protected AgentInterface interfaceType;

	public RefusingCooperationMessage(Agent sender, AgentInterface interfaceType) {
		this.id = Message.REFUSING_COOPERATION_MESSAGE;
	  this.sender = sender;
	  this.interfaceType = interfaceType;
	}
	
	public AgentInterface getInterfaceType() {
	  return interfaceType;
	}

	public void setInterfaceType(AgentInterface interfaceType) {
		this.interfaceType = interfaceType;
	}	
	
	public Message copyMessage() {
		RefusingCooperationMessage returnMessage;
		try {
			returnMessage =  (RefusingCooperationMessage)((Object)this.clone());
			returnMessage.setInterfaceType(this.getInterfaceType().copyAgentInterface());
			return returnMessage;
		} catch (java.lang.CloneNotSupportedException e) {
			return null;
		}
	}
	
	
}