package epe.communication.messages.information;

import epe.communication.Message;
import epe.agents.Agent;
import epe.agents.agentInterface.AgentInterface;

public class DataTypeChangedMessage extends Message {
  
  	protected AgentInterface interfaceType;

  public DataTypeChangedMessage(Agent sender, AgentInterface interfaceType) {
  	this.id = Message.DATATYPE_CHANGED_MESSAGE;
    this.sender = sender;
    this.interfaceType = interfaceType;
  }
  
  public AgentInterface getInterfaceType() {
    return interfaceType;
  }
  
	public void setInterfaceType(AgentInterface interfaceType) {
		this.interfaceType = interfaceType;
	}

	public Message copyMessage() {
		DataTypeChangedMessage returnMessage;
		try {
			returnMessage =  (DataTypeChangedMessage)((Object)this.clone());
			returnMessage.setInterfaceType(this.getInterfaceType().copyAgentInterface());
			return returnMessage;
		} catch (java.lang.CloneNotSupportedException e) {
			return null;
		}
	}
	
}
