package epe.communication.messages.information;

import epe.communication.Message;
import epe.agents.Agent;
import epe.agents.agentInterface.AgentInterface;

public class LinkMultiplicityChangedMessage extends Message {
  
  	protected AgentInterface interfaceType;
  	protected String linkMultiplicity;

  public LinkMultiplicityChangedMessage(Agent sender, 
																				AgentInterface interfaceType,
																				String linkMultiplicity) {
  	this.id = Message.LINK_MULTIPLICITY_CHANGED_MESSAGE;
    this.sender = sender;
    this.interfaceType = interfaceType;
    this.linkMultiplicity = linkMultiplicity;
  }
  
  public AgentInterface getInterfaceType() {
    return interfaceType;
  }
  
	public void setInterfaceType(AgentInterface interfaceType) {
		this.interfaceType = interfaceType;
	}

	public String getLinkMultiplicity() {
		return linkMultiplicity;
	}
	
	public Message copyMessage() {
		LinkMultiplicityChangedMessage returnMessage;
		try {
			returnMessage =  (LinkMultiplicityChangedMessage)((Object)this.clone());
			returnMessage.setInterfaceType(this.getInterfaceType().copyAgentInterface());
			return returnMessage;
		} catch (java.lang.CloneNotSupportedException e) {
			return null;
		}
	}

}
