package epe.communication.messages.ncs;

import epe.communication.Message;
import epe.agents.Agent;
import epe.agents.agentInterface.AgentInterface;


public class NCSNeedInMessage extends Message {
  
	  protected int effectValue;
	  protected int initialEffectValue = 40;
	  protected int decreaseValue = 20;
	  protected AgentInterface interfaceType;

  public NCSNeedInMessage(Agent sender, String dataType, int position) {
  	this.id = Message.NCS_NEED_IN_MESSAGE;
    effectValue = initialEffectValue;
    this.sender = sender;
    interfaceType = new AgentInterface("IN", position, dataType);
  }

  public void decreaseEffectValue() {
    effectValue = effectValue - decreaseValue;
  }

  public boolean isEffective() {
    return (effectValue > 0);
  }

  public String getDataType() {
    return interfaceType.getDataType();
  }

  public AgentInterface getInterfaceType() {
    return interfaceType;
  }
 
	public void setInterfaceType(AgentInterface interfaceType) {
		this.interfaceType = interfaceType;
	}
	
	public int getEffectValue() {
		return effectValue;
	}

	public Message copyMessage() {
		NCSNeedInMessage returnMessage;
		try {
			returnMessage =  (NCSNeedInMessage)((Object)this.clone());
			returnMessage.setInterfaceType(this.getInterfaceType().copyAgentInterface());
			return returnMessage;
		} catch (java.lang.CloneNotSupportedException e) {
			return null;
		}
	}

}