package epe.communication.messages.ncs;

import epe.communication.Message;
import epe.agents.Agent;
import epe.agents.agentInterface.AgentInterface;

public class NCSNeedOutMessage extends Message {

  protected int effectValue;
  protected int initialEffectValue = 40;
  protected int decreaseValue = 20;
  protected AgentInterface interfaceType;
  protected int potentialValue;

  public NCSNeedOutMessage(Agent sender, String dataType, int potentialValue) {
  	this.id = Message.NCS_NEED_OUT_MESSAGE;
    effectValue = initialEffectValue;
    this.sender = sender;
    interfaceType = new AgentInterface("OUT", dataType);
    this.potentialValue = potentialValue;
  }

  public NCSNeedOutMessage(Agent sender, AgentInterface agentInterface, int potentialValue) {
  	this.id = Message.NCS_NEED_OUT_MESSAGE;
    this.sender = sender;
    interfaceType = agentInterface;
    this.potentialValue = potentialValue;
    effectValue = initialEffectValue;
    
  }
  
  public void decreaseEffectValue() {
    effectValue = effectValue - decreaseValue;
  }

  public boolean isEffective() {
    return (effectValue > 0);
  }

  public String getDataType() {
    return interfaceType.getDataType();
  }

  public AgentInterface getInterfaceType() {
    return interfaceType;
  }

	public void setInterfaceType(AgentInterface interfaceType) {
		this.interfaceType = interfaceType;
	}
	
  public int getPotentialValue() {
    return potentialValue;
  }
  
	public int getEffectValue() {
		return effectValue;
	}

	public Message copyMessage() {
		NCSNeedOutMessage returnMessage;
		try {
			returnMessage =  (NCSNeedOutMessage)((Object)this.clone());
			returnMessage.setInterfaceType(this.getInterfaceType().copyAgentInterface());
			return returnMessage;
		} catch (java.lang.CloneNotSupportedException e) {
			return null;
		}
	}

}