package epe.gui;

	import java.awt.Graphics;
	import java.awt.Graphics2D;
	import java.awt.Image;
	import java.awt.Toolkit;
	import java.awt.geom.Ellipse2D;
	import java.awt.geom.Line2D;
	import java.net.URL;
	
	import epe.gui.agentsOnScreen.AgentsOnScreen;
	import epe.gui.links.Link;
	import epe.gui.links.Links;
	import epe.agents.Agent;

public class Background extends javax.swing.JPanel {
  
    private static final long serialVersionUID = 1L;
    //protected String absolutePath = "D:/george/programming/Java/MyPrograms/emergentProgramming4/emergentProgramming/gui/images/background.jpg";
	  protected String relativePath = "data/gui/images/background.gif";
	  protected String absolutePath;
	  protected URL absoluteURL;
	  protected Image image;
	  protected Links links;
	  protected AgentsOnScreen agentsOnScreen;
	  
	  // Graphic options
	  protected boolean showLinksEnabled = true;
	  
	  // For the maximal dimensions
	  protected java.awt.Dimension dimension;
	  protected int width;
	  protected int height;
  
  public Background() {
    //absolutePath = getClass().getResource("/" + relativePath).getFile();
    absoluteURL = getClass().getResource("/" + relativePath);
    System.out.println(absoluteURL);
    
    links = new Links();
    agentsOnScreen = new AgentsOnScreen();
    initComponents();

    // For the maximal dimensions
    dimension = getToolkit().getScreenSize();
    width = (int)dimension.getWidth();
    height = (int)dimension.getHeight()-25;
    
    repaint();
  }
  
  private void initComponents() {
    image = Toolkit.getDefaultToolkit().getImage(absoluteURL);
  }
 
  
  public boolean isShowLinksEnabled() {
    return showLinksEnabled;
  }
  
  public void setShowLinksEnabled(boolean truthValue) {
    showLinksEnabled = truthValue;
  }
  
  public void paintComponent(Graphics g) {
    //super.paintComponent(g);
    //g.drawImage(image, 0, 0, 2000, 1500, this);
    Graphics2D g2 = (Graphics2D) g;
    g2.drawImage(image, 0, 0, width, height, this);
    //g2.drawImage(image,0,0,this);
    drawLines(g2);
  }
 
  private void drawLines(Graphics2D g2) {
    if (isShowLinksEnabled()) {
      g2.setColor(java.awt.Color.red);
      for (int i=0; i<links.size(); i++) {
        Link link = links.getLink(i);
        int x1 = link.getInX() + link.getAgentIn().getGUI().getSizeX();
        int y1 = link.getInY() + (link.getAgentIn().getGUI().getSizeY())/2;
        int x2 = link.getOutX();
        int shift = ((link.getAgentOut().getGUI().getSizeY())/ (link.getNumnerOfINs() + 1))
                    * link.getInPosition();
        int y2 = link.getOutY() + shift;
        g2.draw(new Line2D.Double(x1, y1, x2, y2));
        g2.setPaint(java.awt.Color.red);
        g2.fill(new Ellipse2D.Double(x1-5, y1-5, 10, 10));
        g2.fill(new Ellipse2D.Double(x2-5, y2-5, 10, 10));
      }
    }
  }
 
  public void locationChanged() {
    repaint();
  }
  
  public void linksChanged() {
    repaint();
  }
  
  public Links getLinks() {
    return links;
  }
  
  public void addAgentOnScreen(Agent agent) {
    agentsOnScreen.addAgentOnScreen(agent);
  }
 
 /* public static void main(String[] arg) {
    javax.swing.JFrame f = new javax.swing.JFrame();
    f.getContentPane().add(new Background());
    f.setSize(800,600);
    f.show();
  }*/
  
}


