package epe.gui;

	import java.awt.Point;
	import java.awt.event.ActionListener;
	
	import javax.swing.SwingUtilities;
	import javax.swing.event.DocumentListener;
	
	import epe.calculus.Test;

public class CommandPanel extends javax.swing.JInternalFrame implements DocumentListener {
  
	private static final long serialVersionUID = 1L;
	protected String newline = "\n";
	protected int numberOfLines = 0;
	protected int maxNumberOfLines = 100;
	 
	protected int sizeX = 190; 
	protected int sizeY = 450;
	  
	   // Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JButton startWorkingButton;
	private javax.swing.JButton stopAllAgentsButton;
	private javax.swing.JButton feedbackButton;
	private javax.swing.JButton clearLogsAndFeedbackButton;
	private javax.swing.JPanel exchangePanel;
	private javax.swing.JScrollPane outputScrollPane;
	private javax.swing.JPanel commandPanel;
	private javax.swing.JTextArea outputTextArea;
	private javax.swing.JPanel outputPanel;
	private javax.swing.JTextField inputTextField;
	private javax.swing.JPanel inputPanel;
  // End of variables declaration//GEN-END:variables
  
  public CommandPanel() {
    initComponents();
    java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
    setLocation((screenSize.width - (getWidth()+30)),
    						(screenSize.height - (getHeight()+100)));
  }
  
  public void initTest(Test test) {
    initStartWorkingButton(test);
    initStopAllAgentsButton(test);
    initFeedbackButton(test);
    initClearLogsAndFeedbackButton(test);
    initTextField(test);
    pack();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
    commandPanel = new javax.swing.JPanel();
    startWorkingButton = new javax.swing.JButton();
    stopAllAgentsButton = new javax.swing.JButton();
    feedbackButton = new javax.swing.JButton();
    clearLogsAndFeedbackButton = new javax.swing.JButton();
    exchangePanel = new javax.swing.JPanel();
    inputPanel = new javax.swing.JPanel();
    inputTextField = new javax.swing.JTextField();
    outputPanel = new javax.swing.JPanel();
    outputScrollPane = new javax.swing.JScrollPane();
    outputTextArea = new javax.swing.JTextArea();

    setForeground(java.awt.Color.black);
    setIconifiable(true);
    setTitle("CommandPanel");
    setName("Command Panel");
    setPreferredSize(new java.awt.Dimension(sizeX, sizeY));
    setVisible(true);
    commandPanel.setLayout(new java.awt.GridLayout(4, 0));

    startWorkingButton.setText("Start Working");
    startWorkingButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        startWorkingButtonActionPerformed(evt);
      }
    });

    commandPanel.add(startWorkingButton);

    stopAllAgentsButton.setText("Stop all agents");
    stopAllAgentsButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        stopAllAgentsButtonActionPerformed(evt);
      }
    });

    commandPanel.add(stopAllAgentsButton);

    // Feedback button
    feedbackButton.setText("Feedback");
    feedbackButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        feedbackButtonActionPerformed(evt);
      }
    });
    commandPanel.add(feedbackButton);
    
    // ClearLogs&Feedback button
    clearLogsAndFeedbackButton.setText("Clear Logs & Feedback");
    clearLogsAndFeedbackButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        clearLogsAndFeedbackButtonActionPerformed(evt);
      }
    });
    commandPanel.add(clearLogsAndFeedbackButton);

    getContentPane().add(commandPanel, java.awt.BorderLayout.NORTH);

    exchangePanel.setLayout(new java.awt.BorderLayout());

    exchangePanel.setBorder(new javax.swing.border.TitledBorder("Input/Output"));
    inputPanel.setBorder(new javax.swing.border.TitledBorder("Input"));
    inputTextField.setColumns(5);
    inputTextField.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        inputTextFieldActionPerformed(evt);
      }
    });

    inputPanel.add(inputTextField);

    exchangePanel.add(inputPanel, java.awt.BorderLayout.NORTH);

    outputPanel.setBorder(new javax.swing.border.TitledBorder("Output"));
    //outputPanel.setPreferredSize(new java.awt.Dimension(133, 50));
    outputScrollPane.setPreferredSize(new java.awt.Dimension(154, 200));
    outputTextArea.setColumns(10);
    outputTextArea.setLineWrap(true);
    outputTextArea.setRows(10);
    outputTextArea.setWrapStyleWord(true);
    outputScrollPane.setViewportView(outputTextArea);

    outputPanel.add(outputScrollPane);

    exchangePanel.add(outputPanel, java.awt.BorderLayout.CENTER);

    getContentPane().add(exchangePanel, java.awt.BorderLayout.CENTER);

    pack();
  }//GEN-END:initComponents
  
  private void feedbackButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextStepButtonActionPerformed
    SystemPrinter.printSystem("FEEDBACK Button pressed");
    SystemPrinter.printSystem();
    // Note : the action is in fact executed in the "Test" class
    // (it is a listener of the button)
  }
  
  private void clearLogsAndFeedbackButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextStepButtonActionPerformed
    SystemPrinter.printSystem("FEEDBACK Button pressed");
    SystemPrinter.printSystem();
    // Note : the action is in fact executed in the "Test" class
    // (it is a listener of the button)
  }
  
  public void initStartWorkingButton(ActionListener test) {
    startWorkingButton.addActionListener(test);
  }
  
  public void initStopAllAgentsButton(ActionListener test) {
    stopAllAgentsButton.addActionListener(test);
  }
  
  public void initFeedbackButton(ActionListener test) {
    feedbackButton.addActionListener(test);
  }
  
  public void initClearLogsAndFeedbackButton(ActionListener test) {
    clearLogsAndFeedbackButton.addActionListener(test);
  }
  
  public void initTextField(ActionListener test) {
    inputTextField.addActionListener(test);
    outputTextArea.getDocument().addDocumentListener(this);
  }
  
    private void inputTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_inputTextFieldActionPerformed
      String text = inputTextField.getText();
      print("INPUT = " + text + newline);
      inputTextField.selectAll();
    }//GEN-LAST:event_inputTextFieldActionPerformed
    
    private void stopAllAgentsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stopAllAgentsButtonActionPerformed
      SystemPrinter.printSystem("Stop all agents Button pressed");
      SystemPrinter.printSystem();
      // Note : the action is in fact executed in the "Test" class
      // (it is a listener of the button)
    }//GEN-LAST:event_stopAllAgentsButtonActionPerformed
    
    private void startWorkingButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startWorkingButtonActionPerformed
      SystemPrinter.printSystem("Start Working Button pressed");
      SystemPrinter.printSystem();
      String text = inputTextField.getText();
      print("INPUT = " + text + newline);
      inputTextField.selectAll();
      // Note : the action is in fact also executed in the "Test" class
      // (it is a listener of the button)
    }//GEN-LAST:event_startWorkingButtonActionPerformed
    
    public synchronized void automaticButtonTrigger(String value) {
      inputTextField.setText(value);
      startWorkingButtonActionPerformed(new java.awt.event.ActionEvent(this,1,"automatic"));
    }
  
  // Relatif au DocumentListener
  // On surveille les changements de outputTextArea pour d?placer les scrollBars
  public void changedUpdate(final javax.swing.event.DocumentEvent p1) {
  }
  public void removeUpdate(final javax.swing.event.DocumentEvent p1) {
  }
  public void insertUpdate(final javax.swing.event.DocumentEvent p1) {
    //updateViewPort();
  }
  
  public synchronized void updateViewPort() {
    //SystemPrinter.printSystem("DEBUG 1");
    int height = (int)outputScrollPane.getViewport().getViewSize().getHeight();
    //SystemPrinter.printSystem("DEBUG 2 height : " + height);
    //int pos = height - outputTextArea.getRows() ;
    //SystemPrinter.printSystem("DEBUG 3 rows : " + outputTextArea.getRows());
    Point posPoint = new Point(0,height);
    //SystemPrinter.printSystem("DEBUG 4 : " + pos);
    outputScrollPane.getViewport().setViewPosition(posPoint);
    //SystemPrinter.printSystem("DEBUG 5");
  }
  
  public synchronized String getText() {
    return inputTextField.getText();
  }
  
  public synchronized void print(String text) {
    // Inner class cause Swing is kind of strange, isn't it ?
    class SwingPrinter implements Runnable {
      String text;
      public SwingPrinter(String text) {
        this.text = "  " + text;
        updateViewPort();
      }
      public void run() {
        outputTextArea.append(text);
        numberOfLines++;
        if (numberOfLines>maxNumberOfLines)
          try {
            outputTextArea.replaceRange("", 0, outputTextArea.getCaretPosition());
            numberOfLines = 0;
          } catch (Exception e) {System.out.println("ERROR  : deleting : " + e);}
      }
    }
    // prevents Swing thread from freezing when print called by another thread
    SwingUtilities.invokeLater(new SwingPrinter(text));
    //new Thread(new SwingPrinter(text)).start();
  }
  
}