package epe.gui;

	import javax.swing.JInternalFrame;
	import epe.observationTools.graphLayoutTool.GraphLayoutToolInterface;
	import epe.observationTools.linkObserver.LinkObserver;

public class ProgrammingEnvironment extends javax.swing.JFrame {
  
    private static final long serialVersionUID = 1L;
    public int mainSizeX = 2000;
	  protected int mainSizeY = 1500;
	  protected Background background;
	  protected CommandPanel commandPanel;
	  protected javax.swing.JPanel jPanel;
	  
	  //Tools
	  	// graphLayoutTool
	  protected GraphLayoutToolInterface graphLayoutTool;
	  protected int gltX = 10;
	  protected int gltY = 450;
	  protected int gltWidth = 500;
	  protected int gltHeight = 400;
	  	// LinkObserver
	  protected LinkObserver linkObserver;
	  
	  
	  // For the maximal dimensions
	  protected java.awt.Dimension dimension;
	  	  
  public ProgrammingEnvironment() {
  	// For the maximal dimensions of the background
  	dimension = getToolkit().getScreenSize();
  	mainSizeX = (int)dimension.getWidth() - 11;
  	mainSizeY = (int)dimension.getHeight() - 78;

  	// For the location of the graphLayoutTool
  	gltY = dimension.height - (gltHeight + 100);
  	
    initComponents();
    personalInitComponents(); // some more initialisation
    initBackground();
    initCommandPanel();
    initTools();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
    mainJScrollPane = new javax.swing.JScrollPane();
    mainJDesktopPane = new javax.swing.JDesktopPane();
    mainJMenuBar = new javax.swing.JMenuBar();
    mainjMenu = new javax.swing.JMenu();
    jMenuItem1 = new javax.swing.JMenuItem();
    toolsjMenu = new javax.swing.JMenu();
    graphLayoutToolMenu = new javax.swing.JMenu();
    showGraphjMenuItem = new javax.swing.JMenuItem();
    hideGraphjMenuItem = new javax.swing.JMenuItem();
    ncsListenerjMenu = new javax.swing.JMenu();
    helpJMenu = new javax.swing.JMenu();
    screamJMenuItem = new javax.swing.JMenuItem();

    setTitle("Emergent Programming Environment");
    setName("mainFrame");
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        exitForm(evt);
      }
    });

    mainJScrollPane.setDoubleBuffered(true);
    mainJScrollPane.setViewportView(mainJDesktopPane);

    getContentPane().add(mainJScrollPane, java.awt.BorderLayout.CENTER);

    mainjMenu.setText("Main");
    jMenuItem1.setText("Invoke Miracle");
    mainjMenu.add(jMenuItem1);

    mainJMenuBar.add(mainjMenu);

    toolsjMenu.setText("Tools");
    graphLayoutToolMenu.setText("GraphLayoutTool");
    showGraphjMenuItem.setText("Show");
    showGraphjMenuItem.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(java.awt.event.MouseEvent evt) {
        showGraphjMenuItemMouseReleased(evt);
      }
    });

    graphLayoutToolMenu.add(showGraphjMenuItem);

    hideGraphjMenuItem.setText("Hide");
    hideGraphjMenuItem.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(java.awt.event.MouseEvent evt) {
        hideGraphjMenuItemMouseReleased(evt);
      }
    });

    graphLayoutToolMenu.add(hideGraphjMenuItem);

    toolsjMenu.add(graphLayoutToolMenu);

    ncsListenerjMenu.setText("NcsListener");
    toolsjMenu.add(ncsListenerjMenu);

    mainJMenuBar.add(toolsjMenu);

    helpJMenu.setText("Help");
    screamJMenuItem.setText("Scream until someone comes");
    helpJMenu.add(screamJMenuItem);

    mainJMenuBar.add(helpJMenu);

    setJMenuBar(mainJMenuBar);

    setBounds(0, 0, 700, 500);
  }//GEN-END:initComponents

  private void hideGraphjMenuItemMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_hideGraphjMenuItemMouseReleased
    graphLayoutTool.hide();
  }//GEN-LAST:event_hideGraphjMenuItemMouseReleased

  private void showGraphjMenuItemMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_showGraphjMenuItemMouseReleased
    graphLayoutTool.show(gltX, gltY, gltWidth, gltHeight);
  }//GEN-LAST:event_showGraphjMenuItemMouseReleased

  private void personalInitComponents() {
    mainJDesktopPane.setPreferredSize(new java.awt.Dimension(mainSizeX, mainSizeY));
    
    // maximize the size of the main window
    java.awt.Dimension d = getToolkit().getScreenSize();
    setBounds(0, 0, (int)d.getWidth(), (int)d.getHeight()-25);
  }
  
  private void initBackground() {
    background = new Background();
    mainJDesktopPane.add(background, javax.swing.JLayeredPane.DEFAULT_LAYER);
    background.setBounds(0, 0, mainSizeX, mainSizeY);
    background.repaint();
  }
  
  public void initCommandPanel() {
    commandPanel = new CommandPanel();
    mainJDesktopPane.add(commandPanel, javax.swing.JLayeredPane.PALETTE_LAYER);
  }
  
  public void initTools() {
    graphLayoutTool = new GraphLayoutToolInterface(this);
    graphLayoutTool.pause();
    graphLayoutTool.initiallyShown(gltX, gltY, gltWidth, gltHeight);
    
    linkObserver = new LinkObserver();
  }
  
  public Background getEnvironmentBackground() {
    return background;
  }
  
  public CommandPanel getCommandPanel() {
    return commandPanel;
  }
  
  public GraphLayoutToolInterface getGraphLayoutTool() {
    return graphLayoutTool;
  }
  
  public LinkObserver getLinkObserver() {
  	return linkObserver;
	}
  
  public void addAgentGUI(JInternalFrame agentGUI) {
    mainJDesktopPane.add(agentGUI, javax.swing.JLayeredPane.PALETTE_LAYER);
  }
  
  public void locationChanged() {
    background.locationChanged();
  }
  
  public javax.swing.JDesktopPane getMainJDesktopPane() {
    return mainJDesktopPane;
  }
  
  /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
      System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
      new ProgrammingEnvironment().setVisible(true);
    }
    
    
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JMenu ncsListenerjMenu;
  private javax.swing.JMenu graphLayoutToolMenu;
  private javax.swing.JMenu mainjMenu;
  private javax.swing.JMenuItem showGraphjMenuItem;
  private javax.swing.JMenuItem hideGraphjMenuItem;
  private javax.swing.JMenuItem jMenuItem1;
  private javax.swing.JMenu helpJMenu;
  private javax.swing.JScrollPane mainJScrollPane;
  private javax.swing.JDesktopPane mainJDesktopPane;
  private javax.swing.JMenuItem screamJMenuItem;
  private javax.swing.JMenuBar mainJMenuBar;
  private javax.swing.JMenu toolsjMenu;
  // End of variables declaration//GEN-END:variables
}
