/*
 * Link.java
 *
 * Created on 30 janvier 2001, 12:49
 */

package epe.gui.links;

/**
 *
 * @author  Jean-Pierre Georg?
 * @version 
 */

import epe.gui.GUI;
import epe.agents.Agent;

public class Link extends Object {

  Agent in, out;
  GUI guiIn, guiOut;
  int inX, inY, outX, outY;
  int inPosition; // 0 -> OUT / 1 -> IN1 / 2 -> IN2 / ... / -1 -> undetermined
  int numberOfINs; // The total number of INs this link will be bundled with
  
    /** Creates new Link */
    public Link(Agent in, Agent out, int inPosition, int numberOfINs) {
      this.in = in;
      guiIn = in.getGUI();
      inX = guiIn.getLocationX();
      inY = guiIn.getLocationY();
      
      this.out = out;
      guiOut = out.getGUI();
      outX = guiOut.getLocationX();
      outY = guiOut.getLocationY();
      
      this.inPosition = inPosition;
      this.numberOfINs = numberOfINs;
      
      /*SystemPrinter.printSystem("Link Created : " 
                         + inX + "/" + inY + "/" + outX + "/" + outY + "/" 
                         + inPosition + "/" + numberOfINs);*/
    }

    public Link(Agent in, Agent out, int inPosition) {
      this(in, out, inPosition, 1);
    }
    
    public Link(Agent in, Agent out) {
      this(in, out, -1, 1);
    }
    
    public void setIn(Agent in) {
      this.in = in;
      guiIn = in.getGUI();
      inX = guiIn.getLocationX();
      inY = guiIn.getLocationY();
    }
    
    public void setOut(Agent out) {
      this.out = out; 
      guiOut = out.getGUI();
      outX = guiOut.getLocationX();
      outY = guiOut.getLocationY();
    }
    
    public Agent getAgentIn() {
     return in; 
    }
    
    public Agent getAgentOut() {
     return out; 
    }
    
    public int getInX() {
     return inX; 
    }
    
    public int getInY() {
     return inY; 
    }
    
    public int getOutX() {
     return outX; 
    }
    
    public int getOutY() {
     return outY; 
    }
    
    public int getInPosition() {
      return inPosition;
    }
    
    public int getNumnerOfINs() {
      return numberOfINs;
    }
    
    public boolean equals(Link link) {
     return ((getAgentIn().equals(link.getAgentIn()))
          && (getAgentOut().equals(link.getAgentOut()))
          &&((getInPosition()==(link.getInPosition()))
              || (getInPosition()==-1)
              || (link.getInPosition()==-1)));
    }
}