package epe.gui.links;

	import java.util.Vector;
	import epe.agents.Agent;

public class Links extends Vector<Object> {

  private static final long serialVersionUID = 1L;

  public Links() {
    }

  public void addLink(Link link) {
    Vector<Object> positions = new Vector<Object>();
    positions = findLinks(link);
    if (positions.size() == 0)
      addElement(link);
  }
  
  public synchronized void removeLink(Link link) {
    Vector<Object> positions = new Vector<Object>();
    positions = findLinks(link);
    for (int i=0; i<positions.size(); i++) {
      int rang = ((Integer)positions.elementAt(i)).intValue();
      removeElementAt(rang);
    }
  }
  
  public Link getLink(int pos) {
    return (Link)elementAt(pos);
  }
  
  public Vector<Object> findLinks(Link link) {
    Vector<Object> positions = new Vector<Object>();
    for (int i=0; i<size(); i++)
      if (((Link)elementAt(i)).equals(link))
        positions.addElement(new Integer(i));
    return positions;
  }
  
  public void updateLink(Agent agent) {
    for (int i=0; i<size(); i++) {
      Link link = getLink(i); 
      Agent in = link.getAgentIn();
      if (agent.equals(in)) {
        link.setIn(agent);
      }
      Agent out = getLink(i).getAgentOut();
      if (agent.equals(out)) {
        link.setOut(agent);
      } 
    }
    
    //if (! present)
      //SystemPrinter.printSystem("Links.update() : WARNING : agent not in Links");
  }
  
  public void setLinkedAgentsInFront() {
    for (int i=0; i<size(); i++) {
      Link link = getLink(i); 
      Agent in = link.getAgentIn();
      Agent out = getLink(i).getAgentOut();
      in.getGUI().show();
      out.getGUI().show();
    }
  }
  
}