/*
 * OrganizationTesterGUI.java
 *
 * Created on 18 d?cembre 2002, 09:48
 */

package epe.gui.systematicOrganizationGUI;

/**
 *
 * @author  george
 */

import epe.annexTools.systematicOrganizationsStatisticTool.organizationalProximity.ProximityTool;

public class ProximityToolGUI extends javax.swing.JFrame {
  
  private static final long serialVersionUID = 1L;
  protected ProximityTool proxTool;
  protected boolean pauseSet = false;
  
  /** Creates new form OrganizationTesterGUI */
  public ProximityToolGUI(ProximityTool proxTool) {
    this.proxTool = proxTool;
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
    jButtonLoadNextOrganization = new javax.swing.JButton();
    pauseJToggleButton = new javax.swing.JToggleButton();
    startJButton = new javax.swing.JButton();
    savePositionJButton = new javax.swing.JButton();
    loadPositionJButton = new javax.swing.JButton();
    jSeparator1 = new javax.swing.JSeparator();

    getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

    setTitle("ProximityTool");
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        exitForm(evt);
      }
    });

    jButtonLoadNextOrganization.setText("LoadNextOrganization");
    jButtonLoadNextOrganization.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButtonLoadNextOrganizationActionPerformed(evt);
      }
    });

    getContentPane().add(jButtonLoadNextOrganization, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 0, -1, -1));

    pauseJToggleButton.setText("Pause");
    pauseJToggleButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        pauseJToggleButtonActionPerformed(evt);
      }
    });

    getContentPane().add(pauseJToggleButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 40, 160, -1));

    startJButton.setText("Start");
    startJButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        startJButtonActionPerformed(evt);
      }
    });

    getContentPane().add(startJButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, -1, -1));

    savePositionJButton.setText("SavePosition");
    savePositionJButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        savePositionJButtonActionPerformed(evt);
      }
    });

    getContentPane().add(savePositionJButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 90, -1, -1));

    loadPositionJButton.setText("LoadPosition");
    loadPositionJButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        loadPositionJButtonActionPerformed(evt);
      }
    });

    getContentPane().add(loadPositionJButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 90, -1, -1));

    getContentPane().add(jSeparator1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 82, 350, -1));

    setBounds(680, 670, 280, 151);
  }//GEN-END:initComponents

  private void loadPositionJButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadPositionJButtonActionPerformed
    System.out.println("LoadPosition button pressed");
    //proxTool.loadPosition();
  }//GEN-LAST:event_loadPositionJButtonActionPerformed

  private void savePositionJButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_savePositionJButtonActionPerformed
    System.out.println("SavePosition button pressed");
    //proxTool.savePosition();
  }//GEN-LAST:event_savePositionJButtonActionPerformed

  private void startJButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startJButtonActionPerformed
    System.out.println("Start button pressed");
    proxTool.startTesting();
  }//GEN-LAST:event_startJButtonActionPerformed

  private void pauseJToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pauseJToggleButtonActionPerformed
    System.out.println("Pause button pressed");
    if (!pauseSet) {
      proxTool.pause();
      pauseSet = true;
    }
    else {
      proxTool.unPause();
      pauseSet = false;
    }
  }//GEN-LAST:event_pauseJToggleButtonActionPerformed

  private void jButtonLoadNextOrganizationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLoadNextOrganizationActionPerformed
    System.out.println("Load next organization button pressed");
    proxTool.nextTesting();
  }//GEN-LAST:event_jButtonLoadNextOrganizationActionPerformed
  
  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    System.exit(0);
  }//GEN-LAST:event_exitForm
  
  
  /**
   * @param args the command line arguments
   */
  /*
  public static void main(String args[]) {
    new OrganizationTesterGUI().show();
  }
  */
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton startJButton;
  private javax.swing.JButton jButtonLoadNextOrganization;
  private javax.swing.JButton loadPositionJButton;
  private javax.swing.JToggleButton pauseJToggleButton;
  private javax.swing.JSeparator jSeparator1;
  private javax.swing.JButton savePositionJButton;
  // End of variables declaration//GEN-END:variables
  
}
