package epe.gui.textOutput;

	import java.awt.Color;
	import epe.gui.SystemPrinter;

public class TextOutputPrinter implements Runnable {
  
  	private AgentTextOutputPanel owner;
  	private TextOutputDeleter textOutputDeleter;
  
  public TextOutputPrinter(AgentTextOutputPanel owner) {
    this.owner = owner;
  }
  
  public void run() {
    boolean running = true;
    BufferedText bufferedText;
    String text;
    Color color;
    
    while (true) {
      if (owner.textBuffer.isEmpty())
        running = false;
      else  {
        bufferedText = (BufferedText)owner.textBuffer.remove(0);
        text = bufferedText.getText();
        color = bufferedText.getColor();
        synchronized (owner.lock) {
          print(text, color);
        }
      }
      
      synchronized(this) {
        if (!running)
          try {
            this.wait();
          } catch(InterruptedException e) {}
      }
      running = true;
    }
  }
  
  private void print(String text, Color color) {
    if (color.equals(java.awt.Color.black))
      owner.style = owner.outputTextPane.getStyle("black");
    else if (color.equals(java.awt.Color.blue))
      owner.style = owner.outputTextPane.getStyle("blue");
    else if (color.equals(java.awt.Color.cyan))
      owner.style = owner.outputTextPane.getStyle("cyan");
    else if (color.equals(java.awt.Color.darkGray))
      owner.style = owner.outputTextPane.getStyle("darkGray");
    else if (color.equals(java.awt.Color.gray))
      owner.style = owner.outputTextPane.getStyle("gray");
    else if (color.equals(java.awt.Color.green))
      owner.style = owner.outputTextPane.getStyle("green");
    else if (color.equals(java.awt.Color.lightGray))
      owner.style = owner.outputTextPane.getStyle("lightGray");
    else if (color.equals(java.awt.Color.magenta))
      owner.style = owner.outputTextPane.getStyle("magenta");
    else if (color.equals(java.awt.Color.orange))
      owner.style = owner.outputTextPane.getStyle("orange");
    else if (color.equals(java.awt.Color.pink))
      owner.style = owner.outputTextPane.getStyle("pink");
    else if (color.equals(java.awt.Color.red))
      owner.style = owner.outputTextPane.getStyle("red");
    else if (color.equals(java.awt.Color.yellow))
      owner.style = owner.outputTextPane.getStyle("yellow");
    else
      owner.style = owner.outputTextPane.getStyle("black");

    try {
      owner.doc.insertString(owner.docEndPosition.getOffset()-1, text, owner.style);
    } catch (javax.swing.text.BadLocationException ble) {
      /*
      SystemPrinter.printSystem(owner.owner.getAgentName() + " : ERROR : Couldn't insert text.");
      SystemPrinter.printSystem("docEndPosition : " + owner.docEndPosition);
      SystemPrinter.printSystem("doc.getEndPosition() : " + owner.doc.getEndPosition().getOffset());
      SystemPrinter.printSystem("badPosition : " + ble.offsetRequested());
      owner.owner.errorHappened();
       **/
      try {
        owner.doc.insertString(owner.docEndPosition.getOffset()-2, text, owner.style);
        SystemPrinter.printSystem(owner.owner.getAgentName() + " : SECOND TRY : Success.");
      } catch (javax.swing.text.BadLocationException ble2) {
        SystemPrinter.printSystem(owner.owner.getAgentName() + " : ERROR2 : Couldn't insert text.");
        SystemPrinter.printSystem("docEndPosition : " + owner.docEndPosition);
        SystemPrinter.printSystem("doc.getEndPosition() : " + owner.doc.getEndPosition().getOffset());
        SystemPrinter.printSystem("badPosition : " + ble2.offsetRequested());
        owner.owner.errorHappened();

      } catch (java.lang.IndexOutOfBoundsException iobe) {
        SystemPrinter.printSystem(owner.owner.getAgentName() + "ERROR2 : Couldn't insert text.");
        SystemPrinter.printSystem("docEndPosition : " + owner.docEndPosition);
        SystemPrinter.printSystem("doc.getEndPosition() : " + owner.doc.getEndPosition().getOffset());
        SystemPrinter.printSystem("indexOutOfBoundsException : " + iobe.toString());
        owner.owner.errorHappened();
      }
    } catch (java.lang.IndexOutOfBoundsException iobe) {
      SystemPrinter.printSystem(owner.owner.getAgentName() + "ERROR : Couldn't insert text.");
      SystemPrinter.printSystem("docEndPosition : " + owner.docEndPosition);
      SystemPrinter.printSystem("doc.getEndPosition() : " + owner.doc.getEndPosition().getOffset());
      SystemPrinter.printSystem("indexOutOfBoundsException : " + iobe.toString());
      owner.owner.errorHappened();
    }

    // Ensures the document never exeeds a fixed size
    owner.currentHistorySize = owner.currentHistorySize + text.length();
    if ((owner.currentHistorySize > owner.maxHistorySize)
    	 &(!owner.positionned)){
      owner.currentHistorySize = owner.currentHistorySize - owner.deleteSize;
      textOutputDeleter = new TextOutputDeleter(owner);
      new Thread(textOutputDeleter).start();
    }
  }
  
  public synchronized void newDataAvailable() {
    this.notifyAll();
  }
  
}
