/*
 * LinkVector.java
 *
 * Created on May 16, 2002, 10:29 AM
 */

package epe.observationTools.graphLayoutTool.links;

import epe.observationTools.graphLayoutTool.agents.Agent;

/**
 *
 * @author  hofmann
 */
public class LinkVector extends java.util.Vector<Object> {
    
  private static final long serialVersionUID = 1L;

    /** Creates a new instance of LinkVector */
    public LinkVector() {
    }

    /** Returns the agent located at the specified index
     * @param index of the agent to return
     * @return An agent if found
     */
    public Link link(int param) {
        return((Link)this.get(param));
    }
    
    /** Finds the link bewteen the two agents given in parameter
     * and returns its index in the vector, -1 if not found
     * @param source of the link to search
     * @param target of the link to search
     * @return index of the link if found, -1 otherwise
     */
    public int indexOf(Agent source, Agent target) {
        Link lnk;
        // compares every link to the couple (source, target)
        for (int i = 0; i < this.size(); i++) {
            lnk = this.link(i);
            if (lnk.source == source && lnk.target == target) {
                return(i);
            }
        }
        // the link has not been found
        return(-1);
    }

     /** Finds the link bewteen the two agents labels given in parameter
     * and returns its index in the vector, -1 if not found
     * @param label of the source of the link to search
     * @param label of the target of the link to search
     * @return index of the link if found, -1 otherwise
     */
    public int indexOf(String source, String target) {
        Link lnk;
        // compares every link's labels to the couple (source, target)
        for (int i = 0; i < this.size(); i++) {
            lnk = this.link(i);
            if (lnk.source.label == source && lnk.target.label == target) {
                return(i);
            }
        }
        // the link has not been found
        return(-1);
    }

}
