/*
 * GridOrganizer.java
 *
 * Created on April 26, 2002, 1:48 PM
 */

package epe.observationTools.graphLayoutTool.organizers;

import epe.observationTools.graphLayoutTool.ToolManager;
import epe.observationTools.graphLayoutTool.agents.Agent;
import epe.observationTools.graphLayoutTool.agents.AgentVector;
import epe.observationTools.graphLayoutTool.ui.GraphLayoutToolLogOutput;

/**
 *
 * @author  hofmann
 */
public class InputsOrganizer extends GraphOrganizer {
    
    /* ToolManager */
    private final ToolManager toolManager;
    
    /* Input Agent */
    Agent inputAgent;
    
    private GraphLayoutToolLogOutput log;
    
    /** Creates a new instance of GridOrganizer
     * @param OrganizationManager to use
     */
    public InputsOrganizer(ToolManager tm, GraphLayoutToolLogOutput log) {
        this.toolManager = tm;
        this.log = log;
    }
    
    /** arrange the agents
     */
    public void arrangeAgents() {
        // moving them
        for (int i = 0; i < this.selectedAgents.size(); i++) {
            Agent ag = this.selectedAgents.agent(i);
            //ag.moveTo(this.inputAgent.getLeft() + this.inputAgent.getWidth() + GraphOrganizer.SPACE, ag.getTop());
            if ((ag.getTop() < this.inputAgent.getTop() - GraphOrganizer.SPACE) || (ag.getTop() > this.inputAgent.getTop())) {
                ag.moveTo(ag.getLeft(), this.inputAgent.getTop());
            }
                //i * this.outputAgent.getTop() / (this.selectedAgents.size() + 1));
        }
    }
    
    /** selects the agents that the organizer knows how to place
     * and returns the ones he can't
     * @param Vector<Object> of the agents it should organize
     * @return Vector<Object> of the agents he couldn't organize
     */
    public AgentVector selectAgents(AgentVector grp) {
        this.selectedAgents = new AgentVector();
        inputAgent = null;
        for (int i = 0; i < this.toolManager.agentManager.agents.size(); i++) {
            if (this.toolManager.agentManager.get(i).type == Agent.INPUT) {
                inputAgent = this.toolManager.agentManager.get(i);
                break;
            }
        }
        if (inputAgent != null) {
            for (int i = 0; i < grp.size(); i++) {
                Agent ag = grp.agent(i);
                // selects the agents having a link with the output agent
                if (this.toolManager.linkManager.links.indexOf(inputAgent.label, ag.label) > -1) {
                   this.selectedAgents.add(ag);
                   grp.remove(ag);
                   i--;
                    // prints the name of the selected agent on the standard output
                    log.println("InputsOrganizer : S?lection de " + ag.label);
                }
            }
        }
        return(grp);
    }
    
    /** Return true if the agent given in parameter is well placed
     * @param Agent to check the position
     * @return True if the agent is in good place, false otherwise
     */
    protected boolean isWellPlaced(Agent ag) {
        if ((ag.getTop() <= this.inputAgent.getTop() - GraphOrganizer.SPACE) || (ag.getTop() >= this.inputAgent.getTop())) {
            return(false);
        }
        return(true);
    }
    
    /** Arrange the agent given in parameter
     * @param Agent to arrange
     */
    protected void arrangeAgent(Agent ag) {
    }
    
    /** Returns the bouding rect in wich the agent must contain
     */
    protected Rect getBoundRect(Agent ag) {
        return(null);
    }
    
}
