/*
 * GridOrganizer.java
 *
 * Created on April 26, 2002, 1:48 PM
 */

package epe.observationTools.graphLayoutTool.organizers;

import epe.observationTools.graphLayoutTool.ToolManager;
import epe.observationTools.graphLayoutTool.agents.Agent;
import epe.observationTools.graphLayoutTool.agents.AgentVector;
import epe.observationTools.graphLayoutTool.ui.GraphLayoutToolLogOutput;

/**
 *
 * @author  hofmann
 */
public class ReclusesOrganizer extends GraphOrganizer {
    
    /* toolManager to use */
    private ToolManager toolManager;
    
    private GraphLayoutToolLogOutput log;
    
    /** Creates a new instance of GridOrganizer
     * @param OrganizationManager to use
     */
    public ReclusesOrganizer(ToolManager tm, GraphLayoutToolLogOutput log) {
        this.toolManager = tm;
        this.log = log;
    }
    
    /** arrange the agents
     */
    public void arrangeAgents() {
        // placing the recluses to the top of the graph
        /*int curC = g.getColumnCount(), curR = -1;
        for (int i = 0; i < this.selectedAgents.size(); i++) {
            Agent ag = this.selectedAgents.getAgent(i);
            if (curC == g.getColumnCount()) {
                curC = 0;
                curR++;
                g.insertRow(curR);
            }
            g.add(ag, curC, curR);
            curC++;
        }*/
    }
    
    /** selects the agents that the organizer knows how to place
     * and returns the ones he can't
     * @param Vector<Object> of the agents it should organize
     * @return Vector<Object> of the agents he couldn't organize
     */
    public AgentVector selectAgents(AgentVector grp) {
        this.selectedAgents = new AgentVector();
        for (int i = 0; i < grp.size(); i++) {
            Agent ag = grp.agent(i);
            // selects the agents having no links
            if (!this.toolManager.linkManager.isSource(ag) && !this.toolManager.linkManager.isTarget(ag)) {
                this.selectedAgents.add(ag);
                // prints the name of the agent selected on the standard output
                log.println("ReclusesOrganizer : Selection of " + ag.label);
                grp.remove(ag);
                i--;
            }
        }
        return(grp);
    }
    
    /** Return true if the agent given in parameter is well placed
     * @param Agent to check the position
     * @return True if the agent is in good place, false otherwise
     */
    protected boolean isWellPlaced(Agent ag) {
        return(true);
    }
    
    /** Arrange the agent given in parameter
     * @param Agent to arrange
     */
    protected void arrangeAgent(Agent ag) {
    }
    
    /** Returns the bouding rect in wich the agent must contain
     */
    protected Rect getBoundRect(Agent ag) {
        return(null);
    }
    
}
