/*
 * GridOrganizer.java
 *
 * Created on April 26, 2002, 1:48 PM
 */

package epe.observationTools.graphLayoutTool.organizers;

import epe.observationTools.graphLayoutTool.ToolManager;
import epe.observationTools.graphLayoutTool.agents.Agent;

/**
 *
 * @author  hofmann
 */
public class SpacingManager {
    
    /* toolManager to use */
    private ToolManager toolManager;
    
    /** Creates a new instance of GridOrganizer
     * @param OrganizationManager to use
     */
    public SpacingManager(ToolManager tm) {
        this.toolManager = tm;
    }
    
    /** Returns 1 if the given int is 0, else returns the int
     * @param Integer to return
     * @return 1 if the given integer is 0, the interger otherwise
     */
    private static int nonZero(int v) {
        if (v == 0) {
            return(1);
        }
        return(v);
    }

    /** Returns -1 if the given int is 0, else returns the int
     * @param Integer to return
     * @return -1 if the given integer is 0, the interger otherwise
     */
    private static int nonZeroNeg(int v) {
        if (v == 0) {
            return(-1);
        }
        return(v);
    }
   
    /** arrange the agents
     * @param Level of the arrangement, the first one has level1, then 2 etc...
     * @return number of contacts which have occured
     */
    public int arrangeAgents() {
        int l1, t1, r1, b1, w1, h1, l2, t2, r2, b2, w2, h2, contacts = 0;
        
        // for every agent
        for (int i = 0; i < this.toolManager.agentManager.agents.size(); i++) {
            Agent ag1 = this.toolManager.agentManager.get(i);
            l1 = ag1.getLeft();
            t1 = ag1.getTop();
            w1 = ag1.getWidth();
            r1 = l1 + w1;
            h1 = ag1.getHeight();
            b1 = t1 + h1;
            for (int j = i; j < this.toolManager.agentManager.agents.size(); j++) {
                Agent ag2 = this.toolManager.agentManager.get(j);
                if (ag1 == ag2) {
                    continue;
                }
                l2 = ag2.getLeft();
                t2 = ag2.getTop();
                w2 = ag2.getWidth();
                r2 = l2 + w2;
                h2 = ag2.getHeight();
                b2 = t2 + h2;
                if ((((l2 > l1 - GraphOrganizer.MIN_SPACE) && (l2 < r1 + GraphOrganizer.MIN_SPACE))
                            || ((r2 > l1 - GraphOrganizer.MIN_SPACE) && (r2 < r1 + GraphOrganizer.MIN_SPACE)))
                        && (((t2 > t1 - GraphOrganizer.MIN_SPACE) && (t2 < b1 + GraphOrganizer.MIN_SPACE))
                            || ((b2 > t1 - GraphOrganizer.MIN_SPACE) && (b2 < b1 + GraphOrganizer.MIN_SPACE)))) {
                                if (((Math.abs(l1 - l2) < w1/2) && (t1 < t2)
                                        && ((ag1.offsetY >= 0 && ag2.offsetY < 0) || (ag1.offsetY > 0 && ag2.offsetY <= 0)))
                                    || ((Math.abs(l1 - l2) < w1/2) && (t1 > t2)
                                        && ((ag1.offsetY <= 0 && ag2.offsetY > 0) || (ag1.offsetY < 0 && ag2.offsetY >= 0)))
                                    || ((Math.abs(t1 - t2) < h1/2) && (l1 > l2)
                                        && ((ag1.offsetX <= 0 && ag2.offsetX > 0) || (ag1.offsetX < 0 && ag2.offsetX >= 0)))
                                    || ((Math.abs(t1 - t2) < h1/2) && (l1 < l2)
                                        && ((ag1.offsetX >= 0 && ag2.offsetX < 0) || (ag1.offsetX > 0 && ag2.offsetX <= 0)))) {
                                    int rc = 4;
                                    ag1.moveTo(ag1.getLeft() + GraphOrganizer.MIN_SPACE * rc, ag1.getTop() + GraphOrganizer.MIN_SPACE * rc);
                                    ag2.moveTo(ag2.getLeft() - GraphOrganizer.MIN_SPACE * rc, ag2.getTop() - GraphOrganizer.MIN_SPACE * rc);
                                } else {
                                    ag1.moveTo(ag1.getLeft() + (int)(nonZero(l1 - l2) * GraphOrganizer.MIN_SPACE * Math.random()),
                                            ag1.getTop() + (int)(nonZero(t1 - t2) * GraphOrganizer.MIN_SPACE * Math.random()));
                                    ag2.moveTo(ag2.getLeft() + (int)(nonZeroNeg(l2 - l1) * GraphOrganizer.MIN_SPACE * Math.random()),
                                            ag2.getTop() + (int)(nonZeroNeg(t2 - t1) * GraphOrganizer.MIN_SPACE * Math.random()));
                                }
                               contacts++;
                }
            }
        }
        return(contacts);
    }
    
}
