/*
 * GraphLayoutPanel.java
 *
 * Created on April 26, 2002, 11:33 AM
 */

package epe.observationTools.graphLayoutTool.ui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;

import epe.observationTools.graphLayoutTool.ToolManager;

/**
 *
 * @author  hofmann
 */
public class GraphLayoutPanel extends javax.swing.JPanel {
        
    private static final long serialVersionUID = 1L;
    /* buffer image to draw on */
    public Image buffer;
    /* graphics of the buffer image */
    public Graphics bufferGraphics;
    /* size of the buffer */
    public Dimension bufferSize;

    /* interface initiating this panel */
    private final ToolManager toolManager;

    /** Creates a new GraphLayoutPanel
     * @param ToolManager creating this panel
     */
    public GraphLayoutPanel(ToolManager tm, GraphLayoutToolLogOutput log) {
        this.toolManager = tm;
    }
    
     public synchronized void paintComponent(Graphics g) {
      // paint everything on the buffer
      this.bufferGraphics.setColor(Color.white);
      this.bufferGraphics.fillRect(0,0,this.bufferSize.width,this.bufferSize.height);
      this.bufferGraphics.setColor(Color.black);
      // if needed the percentage of well placed agents if shown
      if (toolManager.showWellPlacedPercentage) {
          this.bufferGraphics.drawString("" + toolManager.lastProportion, 0, 10);
      }
      //this.linkManager.paint(buffer);
      toolManager.linkManager.paint(this.bufferGraphics, toolManager.animating);
      toolManager.agentManager.paint(this.bufferGraphics);
      //this.grid.paint(bufferGraphics);
      // draw the buffer on the panel
      g.drawImage(this.buffer,0,0,null);        
    }
    

    /* Starts the animation */
    public void run() {
        /*double lastProportion = 0;
        Thread me = Thread.currentThread();
        while (this.animating || this.organizing) {
            if (this.organizing) {
                //this.toolInterface.update();
                log.println("OrganizationManager : Organisation (derni?re proportion : " + lastProportion + ")");
                this.agentManager.moveAgents();
                this.toolInterface.repaint();

            }
            repaint();
            try {
                this.thread.sleep(100);
            } catch (InterruptedException e) {
                this.animating = false;
            }
        }*/
    }
 
}
