package epe.reorganization;

	import epe.gui.GUI;
	import epe.agents.Agent;
	import epe.agents.agentInterface.AgentInterface;
	import epe.agents.acquaintances.Acquaintance;
	import epe.agents.acquaintances.Acquaintances;
	import java.util.Vector;

import epe.communication.messages.information.LinkMultiplicityChangedMessage;

public class LinkMultiplicityManager extends java.lang.Object {

	  protected ReorganizationManager owner;
	  protected GUI gui;
	  protected Agent ownerAgent;

  public LinkMultiplicityManager(ReorganizationManager owner, 
								 								 Agent ownerAgent,	
								 								 GUI gui) {
    this.owner = owner;
    this.gui = gui;
    this.ownerAgent = ownerAgent;
  }


  public void manageLinkMultiplicityUpdate(AgentInterface myAcqType) {
  	if ((ownerAgent.getAcquaintancesManager().possessingOUT()) 
  			&& (myAcqType.getType().equals("OUT"))) {
  		LinkMultiplicityChangedMessage message;
  		String linkMultiplicity;
  		if (ownerAgent.getAcquaintancesManager().possessingMultipleOUT())
  			linkMultiplicity = Acquaintance.MULTIPLE;
  		else
  			linkMultiplicity = Acquaintance.UNIQUE;
  		message = new LinkMultiplicityChangedMessage(ownerAgent, 
  																								 new AgentInterface("OUT"), 
  																								 linkMultiplicity);
  		ownerAgent.fireMessage(message, new AgentInterface("OUT"), ownerAgent);
  		
  		// Change own linkMultiplicity
  		Acquaintance acq;
  		Vector positions;
  		Acquaintances acquaintances = ownerAgent.getAcquaintancesManager().getAcquaintances();
  		positions = acquaintances .findAcquaintance("OUT");
  		for (int i = 0; i < positions.size(); i++) {
  			int rang = ((Integer)positions.elementAt(i)).intValue();
  			acq = acquaintances.getAcquaintance(rang);
  			acq.setLinkMultiplicity(linkMultiplicity);
  			gui.println("Acquaintance ["
  					+ acq.getAgent().getAgentName() + ":"
  					+ acq.getInterfaceType() + ":"
  					+ acq.getInterfacePosition() + ":"
  					+ acq.getDataType() + ":"
  					+ acq.getLinkMultiplicity()+ "]"
  					+ " has changed its LinkMultiplicity : "
  					+ " changed accepted and modification were done", java.awt.Color.blue);
  		}
  	}
  }
  
  
}
