package epe.reorganization;

	import epe.gui.GUI;

public class RequestManager extends java.lang.Object {

	  protected ReorganizationManager owner;
	  int[] inRequests ;
	  protected int numberOfOutRequests = 0;
	  protected GUI gui;

  public RequestManager(ReorganizationManager owner, GUI gui) {
    this.owner = owner;
    this.gui = gui;
    inRequests = new int[owner.numberOfINs() + 1];
    for (int i=1; i<=owner.numberOfINs(); i++)
      inRequests[i] = 0;
  }

  public boolean hasRequestedIN(int position) {
    return (inRequests[position] == 1);
  }
  
  protected boolean hasAlreadyRequestedOUT() {
    return (numberOfOutRequests == 1);
  }
  
  public boolean hasRequestedInOut() {
  	for (int i=1; i<=owner.numberOfINs(); i++)
      if (hasRequestedIN(i))
      	return true;
    if (hasAlreadyRequestedOUT())
    	return true;
    return false;
  }
  
  protected boolean hasAlreadyRequestedAnIN() {
    for (int i=1; i<=owner.numberOfINs(); i++)
      if (inRequests[i] == 1)
        return true;
    return false;
  }
  
  public void setRequestedIN(int position) {
    if (inRequests[position] == 0)
      inRequests[position] = 1;
    else
      gui.println(owner.ownerAgent.getAgentName() 
                  + " : WARNING : RequestManager : already set requested IN"
                  + position
                  , java.awt.Color.red);
  }
  
  public void setRequestedOUT() {
    if (numberOfOutRequests == 0)
      numberOfOutRequests = 1;
    else
      gui.println(owner.ownerAgent.getAgentName() 
                  + " : WARNING : RequestManager : already set requested OUT."
                  , java.awt.Color.red);
  }
    
  public void requestedInAgentAnswered(int position) {
    if (inRequests[position] == 1)
      inRequests[position] = 0;
    else
      gui.println(owner.ownerAgent.getAgentName() 
                  + " : WARNING : RequestManager : requested agent IN"
                  + position + " already answered."
                  , java.awt.Color.red);
  }
  
  public void requestedOutAgentAnswered() {
    if (numberOfOutRequests == 1)
      numberOfOutRequests = 0;
    else
      gui.println(owner.ownerAgent.getAgentName() 
                  + " : WARNING : RequestManager : requested agent OUT already answered."
                  , java.awt.Color.red);
  }
  
}
