package epe.reorganization.bestOfWorseManagement;

	import epe.agents.agentListeners.reorganization.ReorganizationListener;
	import epe.gui.GUI;

public class ReorganizationLimiter implements ReorganizationListener {
	
		protected GUI gui;
		protected WaitForProposalsTimerManager waitForProposalsTimerManager;
		
		// For the link observer
		protected int linkRemovedCounter = 0;
		protected int linkRemovedthreshold = 10;
		
	public ReorganizationLimiter(
							  						GUI gui,
														WaitForProposalsTimerManager waitForProposalsTimerManager) {
		this.gui = gui;
		this.waitForProposalsTimerManager = waitForProposalsTimerManager;
	}

	public void reinitialize() {
		linkRemovedCounter = 0;
	}
	
	// Link observer section
	public void linkAdded(String type, String source, String target) {
	}

	public void linkRemoved(String type, String source, String target) {
		if (type.equals("IN")) {
			linkRemovedCounter++;
			// ###DEBUG test linkRemoved++
			gui.println("DEBUG linkRemoved++ : " + linkRemovedCounter, GUI.red);
	
			if (linkRemovedCounter > linkRemovedthreshold) {
				reinitialize();
				waitForProposalsTimerManager.driveTimersToZero();
			}
		}
	}
	
}
