package epe.reorganization.bestOfWorseManagement;

	import epe.agents.Agent;
	import epe.reorganization.ReorganizationManager;
	import epe.reorganization.bestOfWorseManagement.BestOfWorseManager;
	import epe.gui.GUI;
	import epe.gui.SystemPrinter;
	
	import javax.swing.Timer;
	import java.awt.event.ActionEvent;
	import java.awt.event.ActionListener;

public class WaitForProposalsTimerManager extends java.lang.Object
																					implements ActionListener {

		protected Agent ownerAgent;
		protected ReorganizationManager owner;
		protected BestOfWorseManager bestOfWorseManager;
	  protected GUI gui;
	  
	  // Timer to wait for some answer
	  protected final static int ONE_SECOND = 1000;
	  protected Timer[] waitForProposalsTimer;
	  protected Timer waitForProposalsTimerIN1; 
	  protected Timer waitForProposalsTimerIN2;
	  // ###DEBUG waitForProposalsTimerDelay  : find the adequate time
	  protected int waitForProposalsTimerDelay = 5 * ONE_SECOND; // 100 = nearly deactivated
	  protected boolean[] waitForProposalsTimerRanOut = {false, false};
	  protected boolean[] managedToChooseProposal = {false, false};

  public WaitForProposalsTimerManager(Agent ownerAgent, ReorganizationManager owner, 
									  									BestOfWorseManager bestOfWorseManager, GUI gui) {
    this.ownerAgent = ownerAgent;
  	this.owner = owner;
  	this.bestOfWorseManager = bestOfWorseManager;
    this.gui = gui;
    
    waitForProposalsTimerIN1 = new Timer(waitForProposalsTimerDelay, this);
    waitForProposalsTimerIN1.setRepeats(false);
    waitForProposalsTimerIN2 = new Timer(waitForProposalsTimerDelay, this);
    waitForProposalsTimerIN2.setRepeats(false);
    waitForProposalsTimer = new Timer[2];
    waitForProposalsTimer[0] = waitForProposalsTimerIN1;
    waitForProposalsTimer[1] = waitForProposalsTimerIN2;
    
  }

  public void waitForProposals(int pos) {
  	gui.println("BestOfWorseTimer Launched[" + pos + "]", java.awt.Color.red);
  	waitForProposalsTimerRanOut[pos-1] = false;
  	setManagedToChooseProposal(pos, false);
  	waitForProposalsTimer[pos-1].start();
  }
  
  public boolean mustChooseProposal(int pos) {
  	return waitForProposalsTimerRanOut[pos-1];
  }
  
  public boolean managedToChooseProposal(int pos) {
  	return managedToChooseProposal[pos-1];
  }
  
  public void setManagedToChooseProposal(int pos, boolean truthValue) {
  	managedToChooseProposal[pos-1] = truthValue;
  }
  
  // waitForProposalsTimers call this method when they get to zero
  public void actionPerformed(ActionEvent e) {
  	//###DEBUG : test the bestOfWorse timer
  	gui.timerNotification();
  	
  	if ((e.getSource()).equals(waitForProposalsTimerIN1)) {
  		waitForProposalsTimerRanOut[0] = true;
  		gui.println("BestOfWorseTimerIN1 ran out.", GUI.red);
  	}
  	else if ((e.getSource()).equals(waitForProposalsTimerIN2)) {
  			waitForProposalsTimerRanOut[1] = true;
  			gui.println("BestOfWorseTimerIN2 ran out.", GUI.red);
  		}
  	else {
  		SystemPrinter.printSystem("ERROR : wrong action event received from timers");
  		ownerAgent.errorHappened();
  	}
  }
  
  public void chooseBestOfWorseProposal(int pos) {
  	gui.println("WaitingForProposalsTimerRanOut : must choose best of worse proposal",
  							java.awt.Color.red);
  	waitForProposalsTimerRanOut[pos-1] = false;
  	bestOfWorseManager.linkWithBestOfWorse(pos);
  }
  
  public void stopWaiting(int pos) {
  	// ###DEBUG : test stopping of bestOfWorse timers
  	gui.println("BestOfWorseTimer stopped[" + pos + "]", GUI.red);
  	
  	waitForProposalsTimer[pos-1].stop();
  	waitForProposalsTimerRanOut[pos-1] = false;
  }
  
  public void driveTimersToZero() {
  	gui.println("BestOfWorseTimers driven to zero.", GUI.red);
  	gui.timerNotification();
  	
  	waitForProposalsTimerRanOut[0] = true;
  	waitForProposalsTimerRanOut[1] = true;
  }
  
}
