package epe.reorganization.messageProcessors.contract;

	import epe.gui.GUI;
	import epe.agents.Agent;
	import epe.agents.agentInterface.AgentInterface;
	import epe.communication.Message;
	import epe.communication.messages.contract.ProposingCooperationOutWithPrejudiceMessage;
	import epe.reorganization.ReorganizationManager;
	import epe.reorganization.potentialInOutAcquaintances.PotentialInOutAcquaintance;
	import epe.reorganization.potentialInOutAcquaintances.PotentialInOutAcquaintances;

public class ProposingCooperationOutWithPrejudiceMessageProcessor {
  
	  protected Agent ownerAgent;
	  protected ReorganizationManager reorganizationManager;
	  protected GUI gui;
	  protected PotentialInOutAcquaintances potentialInOutAcquaintances;
	  protected PotentialInOutAcquaintance rejectedAcq = null;

  public ProposingCooperationOutWithPrejudiceMessageProcessor(
           ReorganizationManager reorganizationManager, 
           Agent ownerAgent,
           GUI gui, 
           PotentialInOutAcquaintances potentialInOutAcquaintances) {
    this.reorganizationManager = reorganizationManager;
    this.ownerAgent = ownerAgent;
    this.gui = gui;
    this.potentialInOutAcquaintances = potentialInOutAcquaintances;
  }

  public void processProposingCooperationOutWithPrejudiceMessage(Message receivedMessage) {
    ProposingCooperationOutWithPrejudiceMessage castMessage 
      = (ProposingCooperationOutWithPrejudiceMessage)receivedMessage;
    
    Agent sender = receivedMessage.getSender();
    AgentInterface type = castMessage.getInterfaceType();
    String dataTypeProposed = castMessage.getDataType();
    int proposedINnumber = castMessage.getProposedINnumber();
    int senderPrejudice = castMessage.getSufferedPrejudice();
    int currentPrejudice = reorganizationManager.getImposingPrejudice();
    String multiplicity = castMessage.getMultiplicity();
    boolean inGoalReachedState = castMessage.isInGoalReachedState();
    
    gui.println("HIGHER/LOWER Reorganization : proposingOUTWithPrejudiceMessage[" +
                "Sender Prejudice = " + senderPrejudice + "]" +
                " vs [oldPrejudice = " + currentPrejudice, java.awt.Color.orange);
    if (reorganizationManager.isDataRelevant("OUT", 1, type.getDataType())) {
//    		&& (!reorganizationManager.receivedPropositionOutFromAgentInNeed())) {
      String dataType = reorganizationManager
                         .synchronizeDataTypes(dataTypeProposed,
                                               reorganizationManager.dataTypeNeeded("OUT",1));
      AgentInterface interfaceType = new AgentInterface("OUT", 1, dataType);
      PotentialInOutAcquaintance acq;
      acq = new PotentialInOutAcquaintance(
      						sender, proposedINnumber, interfaceType,
									senderPrejudice, multiplicity, inGoalReachedState,
									reorganizationManager.isAThresholdAcq(sender, type));
      potentialInOutAcquaintances.addPotentialInOutAcquaintance(acq);
      gui.println("Adding potentialAcq", java.awt.Color.orange);
      reorganizationManager.getReorganizationEngine().checkCycle("OUT", sender);
    }
  }
  
}
