package epe.reorganization.messageProcessors.contract;

	import epe.gui.GUI;
	import epe.agents.Agent;
	import epe.agents.agentInterface.AgentInterface;
	import epe.communication.Message;
	import epe.communication.messages.contract.RefusingCooperationMessage;
	import epe.reorganization.ReorganizationManager;
	import epe.reorganization.potentialInOutAcquaintances.PotentialInOutAcquaintances;

public class RefusingCooperationMessageProcessor {
  
	  protected ReorganizationManager reorganizationManager;
	  protected GUI gui;
	  protected PotentialInOutAcquaintances potentialInOutAcquaintances;
  
  public RefusingCooperationMessageProcessor(ReorganizationManager reorganizationManager,
                                             GUI gui, 
                                             PotentialInOutAcquaintances potentialInOutAcquaintances) {
    this.reorganizationManager = reorganizationManager;                                               
    this.gui = gui;
    this.potentialInOutAcquaintances = potentialInOutAcquaintances;
  }

  public void processRefusingCooperationMessage(Message receivedMessage) {
    Agent sender = receivedMessage.getSender();
    RefusingCooperationMessage castMessage = (RefusingCooperationMessage)receivedMessage;
    AgentInterface interfaceType = castMessage.getInterfaceType();
    int position = interfaceType.getPosition();
    gui.println("Processing message RefusingCooperation : ["
                + interfaceType.getType() + ":"
                + position + ":"
                + interfaceType.getDataType() + "] from ["
                + castMessage.getSender().getAgentName() + "]");

    if (potentialInOutAcquaintances.isAPotentialAcquaintance(sender, interfaceType))
      potentialInOutAcquaintances.removePotentialInOutAcquaintance(sender, interfaceType);
    if (interfaceType.getType().equals("IN"))
      reorganizationManager.getRequestManager().requestedInAgentAnswered(position);
    else
      reorganizationManager.getRequestManager().requestedOutAgentAnswered();
  }
  
}
