package epe.reorganization.messageProcessors.information;

	import epe.gui.GUI;
	import epe.agents.Agent;
	import epe.communication.Message;
import epe.communication.messages.information.GoalReachedMessage;
	import epe.reorganization.ReorganizationManager;
	import epe.reorganization.bestOfWorseManagement.WaitForProposalsTimerManager;

public class GoalReachedMessageProcessor {
  
	  protected ReorganizationManager reorganizationManager;
	  protected Agent ownerAgent;
	  protected GUI gui;
	  protected WaitForProposalsTimerManager waitForProposalsTimerManager;

  public GoalReachedMessageProcessor(
  				 ReorganizationManager reorganizationManager,
           Agent ownerAgent, 
           GUI gui,
					 WaitForProposalsTimerManager waitForProposalsTimerManager) {
    this.reorganizationManager = reorganizationManager;                                           
    this.ownerAgent = ownerAgent;
    this.gui = gui;
    this.waitForProposalsTimerManager = waitForProposalsTimerManager;
  }

  public void processGoalReachedMessage(Message receivedMessage) {
  	Agent sender = receivedMessage.getSender();
  	GoalReachedMessage castMessage = (GoalReachedMessage)receivedMessage; 
  	boolean isGoalReached = castMessage.getGoalReachedTruthValue();
  	Agent origin = castMessage.getOrigin();
  	gui.println("Processing message GoalReached[" + isGoalReached + "] from : "
  			+ receivedMessage.getSender().getAgentName() + "] [origin : " + 
				origin.getAgentName() + "].");

  	  	// ###DEBUG : test :goalreachedMessage => always propagate
//  	if (ownerAgent.getAcquaintancesManager().isAnInOutAcquaintance(sender, "OUT")) {
//			reorganizationManager.setGoalReached(isGoalReached);
//			// Propagation
//			reorganizationManager.goalReachedNotification(isGoalReached);
//  	}
  	
  	// Test to see if this agent is not the original sender of the message
  	if (!ownerAgent.equals(origin)) {
	  	// Test to see if this situation has not already been processed
	  	if (((reorganizationManager.isGoalReached()) && !isGoalReached)
	  		 || ((!reorganizationManager.isGoalReached()) && isGoalReached)) {
	  		// Receiving from an output Acquaintance
	  		if (ownerAgent.getAcquaintancesManager().isAnInOutAcquaintance(sender, "OUT")) {
	  			if (isGoalReached) {
	  				reorganizationManager.setGoalReached(isGoalReached);
	  				// Propagation
	  				reorganizationManager.goalReachedNotification(isGoalReached, origin);
	  			}
	  			else {
	  				// First check if personalGoal is not reached
	  				if (!reorganizationManager.isPersonalGoalReached()) {
	  					reorganizationManager.setGoalReached(isGoalReached);
		  				// Propagation
		  				reorganizationManager.goalReachedNotification(isGoalReached, origin);
	  				}
	  				// else : personalGoalReached (do not take into account this message => crossing)
	  			}
	  		}
	  		// else : Receving from an Input Acquaintance
	  	}
	  	// else : no new info
  	}
  	// else : message is looping
	  	
  }
  
}
