package epe.reorganization.messageProcessors.information;

	import java.util.Vector;
	
	import epe.gui.GUI;
	import epe.gui.SystemPrinter;
	import epe.agents.Agent;
	import epe.agents.acquaintances.Acquaintance;
	import epe.agents.acquaintances.Acquaintances;
	import epe.agents.agentInterface.AgentInterface;
	import epe.communication.Message;
	import epe.communication.messages.information.LinkMultiplicityChangedMessage;
	import epe.reorganization.ReorganizationManager;

public class LinkMultiplicityChangedMessageProcessor {
  
	  protected ReorganizationManager reorganizationManager;
	  protected Agent ownerAgent;
	  protected GUI gui;

  public LinkMultiplicityChangedMessageProcessor(ReorganizationManager reorganizationManager,
				                                         Agent ownerAgent,
				                                         GUI gui) {
    this.reorganizationManager = reorganizationManager;                                           
    this.ownerAgent = ownerAgent;
    this.gui = gui;
  }

  public void processLinkMultiplicityChangedMessage(Message receivedMessage) {
    Agent sender = receivedMessage.getSender();
    LinkMultiplicityChangedMessage castMessage 
    	= (LinkMultiplicityChangedMessage)receivedMessage;
    AgentInterface interfaceType = castMessage.getInterfaceType();
    int position = interfaceType.getPosition();
    String multiplicity = castMessage.getLinkMultiplicity(); 
    gui.println("Processing message LinkMultiplicityChanged : ["
                + interfaceType.getType() + ":"
                + position + ":"
                + interfaceType.getDataType() + ":"
    						+ multiplicity
    						+ "] from ["
                + castMessage.getSender().getAgentName() + "]");
    AgentInterface myType;
    Acquaintance acq;
    Vector<Object> positions;
    Acquaintances acquaintances = ownerAgent.getAcquaintancesManager().getAcquaintances();
    if (interfaceType.equals(new AgentInterface("IN"))) {
      myType = new AgentInterface("OUT");
    }
    else if (interfaceType.equals(new AgentInterface("OUT"))) {
      myType = new AgentInterface("IN");
    }
    else {
      SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
      ownerAgent.errorHappened();
      gui.println(ownerAgent.getAgentName()
      + " : ERROR(while processing DataTypeChanged) : unknown case",
      java.awt.Color.red);
      myType = null;
    }
    if (myType != null) {
      positions = acquaintances .findAcquaintance(sender, myType.getType());
      if (positions.size()!=1) {
        gui.println("Warning : processing LinkMultiplicityChanged : "
                    + "don't know which agent to changeMultiplicity "
        						+ "(link may have been canceled and messages crossed).", java.awt.Color.red);
      }
      else {
        int rang = ((Integer)positions.elementAt(0)).intValue();
        acq = acquaintances.getAcquaintance(rang);
	      acq.setLinkMultiplicity(multiplicity);
	      gui.println("Acquaintance ["
	                  + acq.getAgent().getAgentName() + ":"
	                  + acq.getInterfaceType() + ":"
	                  + acq.getInterfacePosition() + ":"
	      						+ acq.getDataType() + ":"
	      						+ acq.getLinkMultiplicity()+ "]"
	                  + "  : LinkMultiplicity changed : "
	                  + " changes accepted and modification were done", java.awt.Color.blue);
      }
    }
  }
  
}
