package epe.reorganization.messageProcessors.information;

	import epe.gui.GUI;
	import epe.agents.Agent;
	import epe.communication.Message;
import epe.communication.messages.information.PotentialOutputMessage;
	import epe.reorganization.ReorganizationManager;

public class PotentialOutputMessageProcessor {
  
	  protected ReorganizationManager reorganizationManager;
	  protected Agent ownerAgent;
	  protected GUI gui;

  public PotentialOutputMessageProcessor(ReorganizationManager reorganizationManager,
                                         Agent ownerAgent, 
                                         GUI gui) {
    this.reorganizationManager = reorganizationManager;                                           
    this.ownerAgent = ownerAgent;
    this.gui = gui;
  }

  public void processPotentialOutputMessage(Message receivedMessage) {
    Agent sender = receivedMessage.getSender();
    PotentialOutputMessage castMessage
    	= (PotentialOutputMessage)receivedMessage;
    int potentialValue = castMessage.getPotentialValue();
    gui.println("Processing message PotentialOutput : ["
                + potentialValue
                + "] from ["
                + castMessage.getSender().getAgentName() + "]");
    boolean messageComputed = false;
    if (ownerAgent.getAcquaintancesManager().possessingIN(1)) {
    	Agent IN1Agent = ownerAgent.getAcquaintancesManager().getAgentIN1();
    	// ###DEBUG temporary : test potenialOutputMessage
    	gui.println("IN1Agent = " + IN1Agent.getAgentName(),java.awt.Color.red);
    	if (sender.equals(IN1Agent)) {
    		reorganizationManager.setPotentialInput(1, potentialValue);
    		messageComputed = true;
    	}
    }
    if (ownerAgent.getAcquaintancesManager().possessingIN(2)) {
    	Agent IN2Agent = ownerAgent.getAcquaintancesManager().getAgentIN2();
    	// ###DEBUG temporary : test potenialOutputMessage
    	gui.println("IN2Agent = " + IN2Agent.getAgentName(),java.awt.Color.red);
    	if (sender.equals(IN2Agent)) {
    		reorganizationManager.setPotentialInput(2, potentialValue);
    		messageComputed = true;
    	}
    }
    // Note on propagation : this is done automatically by ReorganizationManager
    // when it receives an update on potentialOutput
    
    if (!messageComputed) {
//			SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
//			ownerAgent.errorHappened();
			gui.println(ownerAgent.getAgentName() +
									" : WARNING(while processing PotentialOupoutMessage) : " +
									"sender is not an Acquainance " +
									"(2 messages may have crossed)." ,java.awt.Color.red);
		}
  }
  
}
