package epe.reorganization.messageProcessors.ncs;

	import epe.gui.GUI;
	import epe.agents.Agent;
	import epe.communication.Message;
	import epe.communication.messages.ncs.NCSInformedInadequateDataMessage;
	import epe.communication.messages.ncs.NCSInformedNeedInMessage;
	import epe.reorganization.ReorganizationManager;
	import epe.reorganization.ReorganizationMessageProcessor;
import epe.reorganization.bestOfWorseManagement.WaitForProposalsTimerManager;

public class NCSInformedInadequateDataMessageProcessor {

	  protected Agent ownerAgent;
	  protected ReorganizationManager reorganizationManager;
	  protected ReorganizationMessageProcessor owner;
	  protected GUI gui;
	  protected WaitForProposalsTimerManager waitForProposalsTimerManager;
  

  public NCSInformedInadequateDataMessageProcessor(
  				 ReorganizationManager reorganizationManager,
           ReorganizationMessageProcessor owner,
           Agent ownerAgent, 
           GUI gui,
					 WaitForProposalsTimerManager waitForProposalsTimerManager) {
    this.reorganizationManager = reorganizationManager;
    this.owner = owner;
    this.ownerAgent = ownerAgent;
    this.gui = gui;
    this.waitForProposalsTimerManager = waitForProposalsTimerManager;
  }

  public void processNCSInformedInadequateDataMessage(Message receivedMessage) {
  	NCSInformedInadequateDataMessage castMessage 
    	= (NCSInformedInadequateDataMessage)receivedMessage;
    String information = castMessage.getInformation();

    // New Reorganization Phase
    int currentPhase = reorganizationManager.getCurrentReorganizationPhase() + 1;
    reorganizationManager
    	.initializeHigherLowerReorganizationIfNeeded(castMessage.getInformation(), currentPhase);
    
    for (int i = 1; i <= ownerAgent.getNumberOfINs(); i++) {
      gui.println(information + " value needed : sending NCSInformedNeedIn[" 
      						+ information +"][IN" + i 
                  + "][Threshold = "
                  + reorganizationManager.getInputThreshold(i)
                  + "] to all acquaintances."
                  , java.awt.Color.orange);
      NCSInformedNeedInMessage message
      	= new NCSInformedNeedInMessage(ownerAgent,
      				 												 information,
	    																 reorganizationManager.dataTypeNeeded("IN", i), 
	                                     i,
	                                     reorganizationManager.getInputThreshold(i),
										 									 reorganizationManager.getCurrentReorganizationPhase());
      owner.sendMessageToAllAcquaintances(message);
      
      // Launch waitingForProposalsTimer
      waitForProposalsTimerManager.waitForProposals(i);
      
      reorganizationManager.ncsFired();
      ownerAgent.notifyNcsListeners();
    }
  }
  
}
