package epe.reorganization.messageProcessors.ncs;

	import epe.agents.Agent;
	import epe.gui.GUI;
	import epe.communication.Message;
	import epe.reorganization.ReorganizationManager;
	import epe.reorganization.ReorganizationMessageProcessor;
	import epe.agents.agentInterface.AgentInterface;
	import epe.communication.messages.ncs.NCSNoPotentialOutputMessage;

public class NCSNoPotentialOutputMessageProcessor {
  
		protected ReorganizationManager reorganizationManager;
		protected ReorganizationMessageProcessor owner;
		protected Agent ownerAgent;
		protected GUI gui;

  public NCSNoPotentialOutputMessageProcessor(ReorganizationManager reorganizationManager,
											  											ReorganizationMessageProcessor owner, 
											  											Agent ownerAgent,
											  											GUI gui) {
  	this.reorganizationManager = reorganizationManager;
  	this.owner = owner;
  	this.ownerAgent = ownerAgent;
  	this.gui = gui;
  }

  public void processNCSNoPotentialOutputMessage(Message receivedMessage) {
  	Agent sender = receivedMessage.getSender();
  	NCSNoPotentialOutputMessage castMessage
  		= (NCSNoPotentialOutputMessage)receivedMessage;
  	gui.println("Processing message NCSNoPotentialOutput from [" +
  							castMessage.getSender().getAgentName() + "]");
  	boolean senderKnown = false;
  	if (ownerAgent.getAcquaintancesManager().possessingIN(1)) {
  		Agent IN1Agent = ownerAgent.getAcquaintancesManager().getAgentIN1();
//  		// ###DEBUG temporary : test NCSNoPotenialOutputMessage
//  		gui.println("IN1Agent = " + IN1Agent.getAgentName(),java.awt.Color.red);
  		// Test if the sender is the right IN aqc
  		// and if this is a new information (prevents looping messages)
  		if (sender.equals(IN1Agent)) {
  			senderKnown = true;
	  		if (reorganizationManager.possessPotentialInput(1)) {
	  			reorganizationManager.setPossessPotentialInput(1, false);
	  			// ###DEBUG : testing noPotentialInput
	  			gui.println("NoPotentialInput[IN1] anymore.", java.awt.Color.red);
	  			if (reorganizationManager.possessPotentialOutput()) {
	  				reorganizationManager.setPossessPotentialOutput(false);
		  			// ###DEBUG : testing noPotentialOutput
		  			gui.println("NoPotentialOutput anymore.", java.awt.Color.red);
		  			propagate(receivedMessage);
	  			}
	  		}
  		}
  	}
  	if (ownerAgent.getAcquaintancesManager().possessingIN(2)) {
  		Agent IN2Agent = ownerAgent.getAcquaintancesManager().getAgentIN2();
//  		// ###DEBUG temporary : test NCSNoPotenialOutputMessage
//  		gui.println("IN2Agent = " + IN2Agent.getAgentName(),java.awt.Color.red);
  		if (sender.equals(IN2Agent)) {
  			senderKnown = true;
 				if (reorganizationManager.possessPotentialInput(1)) {
	  			reorganizationManager.setPossessPotentialInput(1, false);
	  			// ###DEBUG : testing noPotentialInput
	  			gui.println("NoPotentialInput[IN2] anymore.", java.awt.Color.red);
	  			if (reorganizationManager.possessPotentialOutput()) {
	  				reorganizationManager.setPossessPotentialOutput(false);
		  			// ###DEBUG : testing noPotentialOutput
		  			gui.println("NoPotentialOutput anymore.", java.awt.Color.red);
		  			propagate(receivedMessage);
	  			}
 				}
  		}
  	}
  	
  	if (!senderKnown) {
//			SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
//			ownerAgent.errorHappened();
  		gui.println(ownerAgent.getAgentName() +
  				" : WARNING(while processing NCSNoPotentialOutputMessage) : " +
  				"sender is not an Acquainance " +
  				"(2 messages may have crossed)." ,java.awt.Color.red);
  	}
  }

  
  protected void propagate(Message receivedMessage) {
  	// propagate
  	if (ownerAgent.getAcquaintancesManager().possessingOUT()) {
  		gui.println("Propagating NoPotentialOutput.", java.awt.Color.red);
  		owner.targetedPropagateNCS(receivedMessage, new AgentInterface("OUT", 1));
  	}
  	else {
  		gui.println("No need to propagate NoPotentialOutput : no OUT.", java.awt.Color.red);
  	}
  }
  
}
