package epe.reorganization.potentialInOutAcquaintances;

	import epe.gui.SystemPrinter;
	import java.util.Vector;
	import epe.gui.GUI;
	import epe.reorganization.potentialInOutAcquaintances.lastInOutAcquaintances
						.LastInOutAcquaintances;
	import epe.agents.Agent;
	import epe.agents.agentInterface.AgentInterface;

public class PotentialInOutAcquaintances extends Vector<Object> {

    private static final long serialVersionUID = 1L;
    protected GUI gui;
	  protected Agent owner;
	  protected LastInOutAcquaintances lastInOutAcquaintances;

  public PotentialInOutAcquaintances(GUI gui, Agent owner) {
    this.gui = gui;
    this.owner = owner;
    lastInOutAcquaintances = new LastInOutAcquaintances(gui, owner);
  }

  public void reInitializePotentialAcq() {
    clear();
    //gui.println("PotentialAcquaintances Reinitialized.", java.awt.Color.cyan);
  }
  
  public void addPotentialInOutAcquaintance(PotentialInOutAcquaintance acq) {
    if ((!knowingPotentialInOutAcquaintance(acq))&&(!(acq.getAgent().equals(owner))))
      addElement(acq);
    //else
      //gui.println("PotentialAcquaintancesManager : potential acquaintance not added
      //                                           : already known.");
  }

  public PotentialInOutAcquaintance getPotentialInOutAcquaintance(int pos) {
    return ((PotentialInOutAcquaintance)elementAt(pos));
  }

  public PotentialInOutAcquaintance getPotentialInOutAcquaintance(Agent agent, 
                                                                  AgentInterface interfaceType) {
    for (int i=0; i<size(); i++) {
      PotentialInOutAcquaintance acq = getPotentialInOutAcquaintance(i);
      if ((acq.getInterface().equals(interfaceType))
         &(acq.getAgent().equals(agent)))
        return acq;
    }
    // Debug : si potentialAcq non pr?sente
    SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
    owner.errorHappened();
    SystemPrinter.printSystem(owner.getAgentName() 
                       + " : ERROR : PotentialInOutAcquaintances :" 
                       + " requested PotentialAcquaintance not found : ["
                       + agent.getAgentName() + " : "
                       + interfaceType.getType() + "]");
    gui.println(owner.getAgentName() 
                  + " : ERROR : PotentialInOutAcquaintances :" 
                  + " requested PotentialAcquaintance not found : ["
                  + agent.getAgentName() + " : "
                  + interfaceType.getType() + "]", java.awt.Color.red);
    gui.print("PotentialAcquaintances list : ", java.awt.Color.red);
    for (int i=0; i<size(); i++) {
      PotentialInOutAcquaintance acq = getPotentialInOutAcquaintance(i);
      gui.print("[" + acq.getAgent().getAgentName() + " : "
                       + acq.getInterfaceType() + "] ", java.awt.Color.red);
    }
    gui.println("");
    gui.println("Examining potentialAcq(end) : Size: " + size(), java.awt.Color.red);
    return null;
  }

  public PotentialInOutAcquaintance getRequestedPotentialInOutAcquaintance(
  																		Agent agent, AgentInterface interfaceType) {
    for (int i=0; i<size(); i++) {
      PotentialInOutAcquaintance acq = getPotentialInOutAcquaintance(i);
      if ((acq.getInterface().equals(interfaceType))
         && (acq.getAgent().equals(agent))
				 && (acq.isRequested()))
        return acq;
    }
    // Debug : si potentialAcq non pr?sente
    SystemPrinter.printSystem("ERROR : " + owner.getAgentName());
    owner.errorHappened();
    SystemPrinter.printSystem(owner.getAgentName() 
                       + " : ERROR : PotentialInOutAcquaintances :" 
                       + " requested PotentialAcquaintance not found : ["
                       + agent.getAgentName() + " : "
                       + interfaceType.getType() + "]");
    gui.println(owner.getAgentName() 
                  + " : ERROR : PotentialInOutAcquaintances :" 
                  + " requested PotentialAcquaintance not found : ["
                  + agent.getAgentName() + " : "
                  + interfaceType.getType() + "]", java.awt.Color.red);
    gui.print("PotentialAcquaintances list : ", java.awt.Color.red);
    for (int i=0; i<size(); i++) {
      PotentialInOutAcquaintance acq = getPotentialInOutAcquaintance(i);
      gui.print("[" + acq.getAgent().getAgentName() + " : "
                       + acq.getInterfaceType() + "] ", java.awt.Color.red);
    }
    gui.println("");
    gui.println("Examining potentialAcq(end) : Size: " + size(), java.awt.Color.red);
    return null;
  }
  
  public boolean knowingPotentialInOutAcquaintances(AgentInterface type) {
    for (int i=0; i<size(); i++) {
      PotentialInOutAcquaintance acq = getPotentialInOutAcquaintance(i);
      if (acq.getInterface().equals(type))
        return(true);
    }
    return (false);
  }

   public boolean knowingPotentialInOutAcquaintance(PotentialInOutAcquaintance acq) {
    for (int i=0; i<size(); i++) {
      PotentialInOutAcquaintance acq2 = getPotentialInOutAcquaintance(i);
      if (acq.equals(acq2))
        return(true);
    }
    return (false);
  }
  
  public boolean isAlreadyRequestedAsIN(Agent agent) {
    for (int i=0; i<size(); i++) {
      PotentialInOutAcquaintance acq = getPotentialInOutAcquaintance(i);
      if ((acq.getAgent().equals(agent))
        &&(acq.getInterface().getType().equals("IN"))
        &&(acq.isRequested()))
        return(true);
    }
    return (false);
    
  }
  
  public void setRequested(Agent agent, AgentInterface interfaceType, boolean truthValue) {
    gui.println(owner.getAgentName() + 
                " : PotentialInOutAcquaintances : setting requested :[" +
                agent.getAgentName() + ":" +
                interfaceType.getType() + 
    						interfaceType.getPosition() + "]",
                java.awt.Color.blue);
    getPotentialInOutAcquaintance(agent, interfaceType).setRequested(truthValue);
  }

  public void setNewDataType(Agent agent, AgentInterface interfaceType, String dataType) {
    if (getPotentialInOutAcquaintance(agent, interfaceType).setDataType(dataType))
      gui.println(owner.getAgentName() 
                + " : PotentialInOutAcquaintances : setting new DataType :["
                + agent.getAgentName() + ":"
                + interfaceType.getType() + "]",
                java.awt.Color.blue);
  }
  
  public boolean requestingCooperationFromSomeone(AgentInterface interfaceType) {
    
    for (int i=0; i<size(); i++) {
      PotentialInOutAcquaintance acq = getPotentialInOutAcquaintance(i);
      if ((acq.getInterface().equals(interfaceType))
         &(acq.isRequested()))
        return(true);
    }
    return (false);
  }

  public boolean requestingCooperationFrom(Agent agent, AgentInterface interfaceType,
  																				 int proposedInNumber) {
    for (int i=0; i<size(); i++) {
      PotentialInOutAcquaintance acq = getPotentialInOutAcquaintance(i);
      if ((acq.getAgent().equals(agent))
         && (acq.getInterface().equals(interfaceType))
         && (acq.isRequested())
				 && ((acq.getProposedINnumber() == proposedInNumber)
				 		|| (acq.getProposedINnumber() == -1)))
        return(true);
    }
    return (false);
  }
  
  public boolean requestingCooperationFrom(Agent agent) {
    for (int i=0; i<size(); i++) {
      PotentialInOutAcquaintance acq = getPotentialInOutAcquaintance(i);
      if ((acq.getAgent().equals(agent))
         &(acq.isRequested()))
        return(true);
    }
    return (false);
  }
  
  public void removePotentialInOutAcquaintances(AgentInterface interfaceType) {
    for (int i=0; i<size(); i++) {
      PotentialInOutAcquaintance acq = getPotentialInOutAcquaintance(i);
      if (acq.getInterfaceType().equals(interfaceType))
        removeElement(acq);
    }
    gui.println(owner.getAgentName() + " : removed potentialAcqs : " + 
      "all type [" + interfaceType.getType() + "]", java.awt.Color.blue);
  }

  public boolean isAPotentialAcquaintance(Agent agent, AgentInterface interfaceType) {
    boolean found = false;
    int i = 0;
    while (i<size() & !found) {
      PotentialInOutAcquaintance acq = getPotentialInOutAcquaintance(i);
      if ((acq.getAgent().equals(agent))&(acq.getInterface().equals(interfaceType))) 
        found = true;
      i++;
    }
    return found;
  }
  
  public void removePotentialInOutAcquaintance(Agent agent, AgentInterface interfaceType) {
    boolean removed = false;
    for (int i=0; i<size(); i++) {
      PotentialInOutAcquaintance acq = getPotentialInOutAcquaintance(i);
      if ((acq.getAgent().equals(agent))&(acq.getInterface().equals(interfaceType))) {
        removeElement(acq);
        removed = true;
        gui.println(owner.getAgentName() + " : removed potentialAcq : " + 
                "[" + agent.getAgentName() + "]", java.awt.Color.blue);
      }
    }
    if (!removed) {
      owner.errorHappened();
      SystemPrinter.printSystem(owner.getAgentName() + " : ERROR : potentialAcqs problem");
      gui.println(owner.getAgentName() + " : WARNING : could not remove potentialAcq : " + 
                "[" + agent.getAgentName() + "]"
                + "[" + interfaceType.getType() + interfaceType.getPosition() + ":"
                + interfaceType.getDataType() +"]."
                , java.awt.Color.red);
      showAllPotentialAcquaintances();
    }
    
  }

  public void showAllPotentialAcquaintances() {
    PotentialInOutAcquaintance acq;
    if (size() == 0)
      gui.println("[  ]", java.awt.Color.cyan);
    for (int i=0; i<size(); i++) {
      acq = getPotentialInOutAcquaintance(i);
      gui.println("	[" + acq.getAgent().getAgentName() + 
                " / " + acq.getInterfaceType() + 
                acq.getInterface().getPosition() +
                " / " + acq.getDataType() +
                " / " + acq.getRequestedState() +
      					" / propIN" + acq.getProposedINnumber() +
                " / prej=" + acq.getPrejudice() +
      					" / " + acq.getMultiplicity() +
      					" / isAnInputThresholdReceiverFromMe = " + acq.isAnInputThresholdReceiverFromMe() +
      					" / inGoalReachedState = " + acq.isInGoalReachedState() +
      					"] ", java.awt.Color.cyan);
    }
  }

  // Concerning the management of the LastInOutAcquaintances
  public void addLastInOutAcquaintance(Agent agentToAdd,
                                       String interfaceType,
                                       int position,
                                       String dataType) {
    lastInOutAcquaintances.addLastInOutAcquaintance(agentToAdd,
                                                    interfaceType,
                                                    position,
                                                    dataType);
  }
  
  public void removeLastInOutAcquaintance(PotentialInOutAcquaintance potentialAcq) {
    lastInOutAcquaintances.removeLastInOutAcquaintance(potentialAcq);
  }
  
  public boolean isLastInOutAcquaintance(PotentialInOutAcquaintance potentialAcq) {
    return (lastInOutAcquaintances.isLastInOutAcquaintance(potentialAcq));
  }
  
  public int getNumberOfRejects(PotentialInOutAcquaintance potentialAcq) {
    return (lastInOutAcquaintances.getNumberOfRejects(potentialAcq));
  }
  
  public void increaseNumberOfRejects(PotentialInOutAcquaintance potentialAcq) {
    lastInOutAcquaintances.increaseNumberOfRejects(potentialAcq);
  }
  
  public void resetNumberOfRejects(PotentialInOutAcquaintance potentialAcq) {
    lastInOutAcquaintances.resetNumberOfRejects(potentialAcq);
  }
  
  public void showAllLastAcquaintances() {
    lastInOutAcquaintances.showAllLastAcquaintances();
  }
}