package epe.reorganization.specificManagers;

	import epe.gui.SystemPrinter;
	import epe.agents.Agent;
	import epe.agents.acquaintances.specificManagers.AgentAdditionAcquaintancesManager;
	import epe.agents.agentInterface.AgentInterface;

public class AgentAdditionReorganizationManager 
			 extends epe.reorganization.ReorganizationManager {
  
	  protected boolean needIN1 = false;
	  protected boolean needIN2 = false;
	  protected boolean needOUT = false;
	  protected boolean requestedIN1 = false;
	  protected boolean requestedIN2 = false;
	  protected boolean requestedOUT = false;

  public AgentAdditionReorganizationManager(Agent ownerAgent) {
    super(ownerAgent);
  }

  public void checkInOut() {
    AgentAdditionAcquaintancesManager acquaintancesManager;
    acquaintancesManager = (AgentAdditionAcquaintancesManager)(ownerAgent.getAcquaintancesManager());

    if (!acquaintancesManager.possessingIN1())
      needIN1 = true;
    else
      needIN1 = false;
    if (!acquaintancesManager.possessingIN2())
      needIN2 = true;
    else
      needIN2 = false;
    if (!acquaintancesManager.possessingOUT())
      needOUT = true;
    else
      needOUT = false;
  }

  public int numberOfINs() {
    return 2 ;
  }
  
  public boolean needIN(int position) {
    if (position == 1)
      return needIN1;
    else if (position == 2)
      return needIN2;
    else {
      SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
      ownerAgent.errorHappened();
      gui.println("ERROR : needIN called with wrong argument position : "
                  + position, java.awt.Color.red); 
     return false;
    }
  }
  
  public boolean needIN() {
    return (needIN1 | needIN2);
  }

  public boolean needOUT() {
    return (needOUT);
  }

  protected void setNeedIN(int position, boolean truthValue) {
   if (position == 1)
     needIN1 = truthValue;
   else if (position == 2)
     needIN2 = truthValue;
   else {
    SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
    ownerAgent.errorHappened();
    gui.println("ERROR : setNeedIN called with wrong argument position : "
                + position, java.awt.Color.red);  
   }
  }

  protected void setNeedOUT(boolean truthValue) {
    needOUT = truthValue;
  }
  
  public String dataTypeNeeded(String interfaceType, int position) {
    return "INTEGER";
  }
 
  protected String dataTypeNeededOriginally(String interfaceType, int position) {
    return dataTypeNeeded(interfaceType, position);
  }
  
  public boolean isDataRelevant(String interfaceType, int position, String dataType) {
    return ((dataType.equals("GENERIC"))
           |(dataType.equals(dataTypeNeeded(interfaceType, position))));
  }
  
  public boolean isRelevant(AgentInterface interfaceTypeAsked, int position) {
    // The agent judges if it has the competences to answer the request
    String dataTypeAsked = interfaceTypeAsked.getDataType();
    if (dataTypeAsked.equals("GENERIC"))
      return true;
    return dataTypeAsked.equals(dataTypeNeeded("IN", position));
  }

  public boolean isOriginallyRelevant(AgentInterface interfaceTypeAsked, int position) {
    return isRelevant(interfaceTypeAsked, position);
  }
  
  public void checkDataTypes() {
   // Not a GENERIC agent type, do nothing 
  }
  
  public void setSpecificPotentialOutput() {
    setPotentialOutput(getPotentialInput(1) + getPotentialInput(2));
  }
  
  public int calculatePotentialOutput(int IN1, int IN2) {
  	return (IN1 + IN2);
  }

}