package epe.reorganization.specificManagers;

	import epe.gui.SystemPrinter;
	import epe.agents.Agent;
	import epe.agents.acquaintances.specificManagers
						.AgentConstantAcquaintancesManager;
	import epe.agents.agentInterface.AgentInterface;

public class AgentConstantReorganizationManager 
       extends epe.reorganization.ReorganizationManager {

  	protected boolean needOUT = false;

  public AgentConstantReorganizationManager(Agent ownerAgent) {
    super(ownerAgent);
  }

  public void checkInOut() {
    AgentConstantAcquaintancesManager acquaintancesManager;
    acquaintancesManager = (AgentConstantAcquaintancesManager)(ownerAgent.getAcquaintancesManager());
    if (!acquaintancesManager.possessingOUT())
      needOUT = true;
    else 
      needOUT = false;
  }
  
  public int numberOfINs() {
    return 0 ;
  }
  
  public boolean needIN(int position) {
    return false;
  }
  
  public boolean needIN() {
    return false;
  }

  public boolean needOUT() {
    return (needOUT);
  }

  protected void setNeedIN(int position, boolean truthValue) {
    SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
    ownerAgent.errorHappened();
    gui.println("ERROR : setNeedIN should not be called", java.awt.Color.red);  
  }

  protected void setNeedOUT(boolean truthValue) {
    needOUT = truthValue;
  }
  
  public String dataTypeNeeded(String interfaceType, int position) {
    return "INTEGER";
  }
  
  protected String dataTypeNeededOriginally(String interfaceType, int position) {
    return dataTypeNeeded(interfaceType, position);
  }
  
  public boolean isDataRelevant(String interfaceType, int position, String dataType) {
    return ((dataType.equals("GENERIC"))
           |(dataType.equals(dataTypeNeeded(interfaceType, position))));
  }

  public boolean isRelevant(AgentInterface interfaceTypeAsked, int position) {
    // L'agent juge s'il a les capacit?s pour r?pondre ? la demande
    String typeAsked = interfaceTypeAsked.getType();
    if (typeAsked.equals("OUT"))
      return false;
    String dataTypeAsked = interfaceTypeAsked.getDataType();
    if (dataTypeAsked.equals("GENERIC"))
      return true;
    return dataTypeAsked.equals(dataTypeNeeded("OUT", 1));
  }

  public boolean isOriginallyRelevant(AgentInterface interfaceTypeAsked, int position) {
    return isRelevant(interfaceTypeAsked, position);
  }
  
  public void checkDataTypes() {
   // Not a GENERIC agent type, do nothing 
  }
  
  public void setSpecificPotentialOutput() {
  }

  public int calculatePotentialOutput(int IN1, int IN2) {
  	// constant => never needed
  	return (getPotentialOutput());
  }

}