package epe.reorganization.specificManagers.environment;

	import epe.gui.SystemPrinter;
	import epe.agents.Agent;
import epe.agents.acquaintances.specificManagers.environment.AgentEnvironmentAcquaintancesManager;
	import epe.agents.agentInterface.AgentInterface;

public class AgentEnvironmentReorganizationManager 
       extends epe.reorganization.ReorganizationManager {
  
	  protected boolean needIN = false;
	  protected boolean needOUT = false;
	  protected boolean requestedIN = false;
	  protected boolean requestedOUT = false;

  public AgentEnvironmentReorganizationManager(Agent ownerAgent) {
    super(ownerAgent);
  }

  public void checkInOut() {
    AgentEnvironmentAcquaintancesManager acquaintancesManager;
    acquaintancesManager = (AgentEnvironmentAcquaintancesManager)(ownerAgent.getAcquaintancesManager());

    if (!acquaintancesManager.possessingIN())
      needIN = true;
    else
      needIN = false;
    if (!acquaintancesManager.possessingOUT())
      needOUT = true;
    else
      needOUT = false;
  }

  public int numberOfINs() {
    return 1 ;
  }
  
  public boolean needIN(int position) {
    if (position == 1)
      return needIN;
    else if (position == 2)
      return needIN;
    else {
      SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
      ownerAgent.errorHappened();
      gui.println("ERROR : needIN called with wrong argument position : "
                  + position, java.awt.Color.red); 
     return false;
    }
  }
  
  public boolean needIN() {
    return (needIN);
  }

  public boolean needOUT() {
    return (needOUT);
  }

  protected void setNeedIN(int position, boolean truthValue) {
   if (position == 1)
     needIN = truthValue;
   else {
    SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
    ownerAgent.errorHappened();
    gui.println("ERROR : setNeedIN called with wrong argument position : "
                + position, java.awt.Color.red);  
   }
  }

  protected void setNeedOUT(boolean truthValue) {
    needOUT = truthValue;
  }
  
  public String dataTypeNeeded(String interfaceType, int position) {
    return "INTEGER";
  }
 
   protected String dataTypeNeededOriginally(String interfaceType, int position) {
    return dataTypeNeeded(interfaceType, position);
  }
  
   public boolean isDataRelevant(String interfaceType, int position, String dataType) {
    return ((dataType.equals("GENERIC"))
           |(dataType.equals(dataTypeNeeded(interfaceType, position))));
  }
  
   public boolean isRelevant(AgentInterface interfaceTypeAsked, int position) {
    // L'agent juge s'il a les capacit?s pour r?pondre ? la demande
    String dataTypeAsked = interfaceTypeAsked.getDataType();
    if (dataTypeAsked.equals("GENERIC"))
      return true;
    return dataTypeAsked.equals(dataTypeNeeded("IN", position));
  }

   public boolean isOriginallyRelevant(AgentInterface interfaceTypeAsked, int position) {
    return isRelevant(interfaceTypeAsked, position);
  }
  
   public void checkDataTypes() {
   // Not a GENERIC agent type, do nothing 
  }

   public void setSpecificPotentialOutput() {
   }

   public int calculatePotentialOutput(int IN1, int IN2) {
   	// Environment => never needed
   	return (getPotentialOutput());
   }
   
}