package epe.reorganization.specificManagers.interfaceAgents;

	import epe.gui.SystemPrinter;
	import epe.agents.Agent;
	import epe.agents.acquaintances.specificManagers.interfaceAgents
						.AgentOutWithoutControlAcquaintancesManager;
	import epe.agents.agentInterface.AgentInterface;

public class AgentOutWithoutControlReorganizationManager 
       extends epe.reorganization.ReorganizationManager {

  	protected boolean needIN1 = false;
  
  public AgentOutWithoutControlReorganizationManager(Agent ownerAgent) {
    super(ownerAgent);
  }

  public void checkInOut() {
    AgentOutWithoutControlAcquaintancesManager acquaintancesManager;
    acquaintancesManager = (AgentOutWithoutControlAcquaintancesManager)
                           (ownerAgent.getAcquaintancesManager());

    if (!acquaintancesManager.possessingIN1())
      needIN1 = true;
    else
      needIN1 = false;
  }

  public void detectUselessnessNCSs() {
    connectedToOutputFlag = true;
  }
  
  public int numberOfINs() {
    return 1 ;
  }
  
  public boolean needIN(int position) {
    if (position == 1)
      return needIN1;
    else {
      SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
      ownerAgent.errorHappened();
      gui.println("ERROR : needIN called with wrong argument position : "
                  + position, java.awt.Color.red); 
      return false;
    }
  }
  
  public boolean needIN() {
    return (needIN1);
  }
  
  public boolean needOUT() {
    return false;
  }

  protected void setNeedIN(int position, boolean truthValue) {
   if (position == 1)
     needIN1 = truthValue;
   else {
    SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
    ownerAgent.errorHappened();
    gui.println("ERROR : setNeedIN called with wrong argument position : "
                + position, java.awt.Color.red);  
   }
  }

  protected void setNeedOUT(boolean truthValue) {
    SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
    ownerAgent.errorHappened();
    gui.println("ERROR : setNeedOUT should not be called", java.awt.Color.red);  
  }
  
  public String dataTypeNeeded(String interfaceType, int position) {
    if (interfaceType.equals("IN")) {
      if (position == 1)
        return "INTEGER";
      else {
        SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
        ownerAgent.errorHappened();
        gui.println("ERROR : dataTypeNeeded called with wrong argument position : "
                    + position, java.awt.Color.red); 
        return "";
      }
    }
    else {
      SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
      ownerAgent.errorHappened();
      gui.println("ERROR : dataTypeNeeded called with wrong argument interfaceType : ["
                  + interfaceType + "]", java.awt.Color.red); 
      return "";
    }
  }
   
  protected String dataTypeNeededOriginally(String interfaceType, int position) {
    return dataTypeNeeded(interfaceType, position);
  }

  public boolean isDataRelevant(String interfaceType, int position, String dataType) {
    if (dataType.equals("GENERIC"))
      return true;
    else if (interfaceType.equals("IN"))
      return (dataType.equals(dataTypeNeeded("IN", position)));
    else {
      SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
      ownerAgent.errorHappened();
      gui.println("ERROR : isDataRelevant called with wrong argument interfaceType : ["
                  + interfaceType + "]", java.awt.Color.red); 
      return false;
    }
  }
  
  public boolean isRelevant(AgentInterface interfaceTypeAsked, int position) {
    // L'agent juge s'il a les capacit?s pour r?pondre ? la demande
    String typeAsked = interfaceTypeAsked.getType();
    if (typeAsked.equals("IN"))
      return false;
    else if (typeAsked.equals("OUT")) {
      String dataTypeAsked = interfaceTypeAsked.getDataType();
      if (dataTypeAsked.equals("GENERIC"))
        return true;
      else 
        return (dataTypeAsked.equals(dataTypeNeeded("IN", position)));
    }
    else {
      SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
      ownerAgent.errorHappened();
      gui.println("ERROR : isRelevant called with wrong argument interfaceTypeAsked : ["
                  + interfaceTypeAsked.getType() + "]", java.awt.Color.red); 
      return false;
    }
  }

  public boolean isOriginallyRelevant(AgentInterface interfaceTypeAsked, int position) {
    return isRelevant(interfaceTypeAsked, position);
  }
  
  public void checkDataTypes() {
   // Not a GENERIC agent type, do nothing 
  }
  
  public void setSpecificPotentialOutput() {
  	potentialOutput = getPotentialInput(1);
		setPossessPotentialOutput(true);
  }

  public int calculatePotentialOutput(int IN1, int IN2) {
  	// agent OUT => never used
  	return (IN1);
  }
  
}