package epe.reorganization.thresholdAcquaintances;

import java.util.Vector;

	import epe.gui.GUI;
	import epe.gui.SystemPrinter;
	import epe.agents.Agent;
	import epe.agents.agentInterface.AgentInterface;
	import epe.reorganization.ReorganizationManager;

public class ThresholdAcquaintances extends Vector<Object> {
    
    private static final long serialVersionUID = 1L;
    protected GUI gui;
	  protected Agent ownerAgent;
	  protected ReorganizationManager reorganizationManager;

  public ThresholdAcquaintances(GUI gui, Agent ownerAgent, 
																ReorganizationManager reorganizationManager) {
    this.gui = gui;
    this.ownerAgent = ownerAgent;
    this.reorganizationManager = reorganizationManager;
  }

  public void reInitializeThresholdAcq() {
    clear();
  }
  
  public void addThresholdAcquaintance(ThresholdAcquaintance acq) {
      addElement(acq);
  }

  public void addThresholdAcquaintance(Agent agent, AgentInterface agentInterface) {
      addElement(new ThresholdAcquaintance(agent, agentInterface));
  }
  
  public ThresholdAcquaintance getThresholdAcquaintance(int pos) {
    return ((ThresholdAcquaintance)elementAt(pos));
  }

  public ThresholdAcquaintance getThresholdAcquaintance(AgentInterface interfaceType) {
    for (int i=0; i<size(); i++) {
      ThresholdAcquaintance acq = getThresholdAcquaintance(i);
      if (acq.getInterface().equals(interfaceType))
        return acq;
    }
    // Debug : if thresholdAcq not present
    SystemPrinter.printSystem("ERROR : " + ownerAgent.getAgentName());
    ownerAgent.errorHappened();
    SystemPrinter.printSystem(ownerAgent.getAgentName() 
                       + " : ERROR : ThresholdAcquaintances :" 
                       + " requested ThresholdAcquaintance not found : ["
                       + interfaceType.getType() + "]");
    gui.println(ownerAgent.getAgentName() 
                  + " : ERROR : ThresholdAcquaintances :" 
                  + " requested ThresholdAcquaintance not found : ["
                  + interfaceType.getType() + "]", java.awt.Color.red);
    gui.print("ThresholdAcquaintances list : ", java.awt.Color.red);
    for (int i=0; i<size(); i++) {
      ThresholdAcquaintance acq = getThresholdAcquaintance(i);
      gui.print("[" + acq.getAgent().getAgentName() + " : "
                       + acq.getInterfaceType() + "] ", java.awt.Color.red);
    }
    gui.println("");
    gui.println("Examining ThresholdAcq(end) : Size: " + size(), java.awt.Color.red);
    return null;
  }
  
  public boolean isAThresholdAcquaintance(Agent agent, AgentInterface interfaceType) {
    boolean found = false;
    int i = 0;
    while (i<size() & !found) {
      ThresholdAcquaintance acq = getThresholdAcquaintance(i);
      if ((acq.getAgent().equals(agent))&(acq.getInterface().equals(interfaceType))) 
        found = true;
      i++;
    }
    return found;
  }
  
  public void initializeThresholdAcquaintances(int numberOfINs) {
  	reInitializeThresholdAcq();
	  for (int i=1; i<=numberOfINs; i++) {
	  	reorganizationManager.setThresholdAcq(ownerAgent.getAcquaintancesManager().getAgentIN(i), 
	  																				new AgentInterface("IN", i));
	  }
	  Vector<Object> positions = ownerAgent.getAcquaintancesManager()
								      					 .getAcquaintances()
								       					 .findAcquaintance(new AgentInterface("OUT", 1));
	  for (int i=0; i<positions.size(); i++) {
	  	int pos = ((Integer)positions.elementAt(i)).intValue();
      reorganizationManager.setThresholdAcq(ownerAgent.getAcquaintancesManager()
  												 														.getAcquaintances()
      																								.getAcquaintance(pos)
      																								.getAgent(), 
    																				new AgentInterface("OUT", 1));
	  }
  }
  
  public void showAllThresholdAcquaintances() {
    ThresholdAcquaintance acq;
    if (size() == 0)
      gui.println("	  [  ]", java.awt.Color.blue);
    for (int i=0; i<size(); i++) {
      acq = getThresholdAcquaintance(i);
      gui.println("	   [" + acq.getInterfaceType() + 
                acq.getInterface().getPosition() + " / " + 
      					acq.getAgent().getAgentName() + " / " + 
                acq.getDataType() + "]",
      					java.awt.Color.blue);
    }
  }
}