/*
 * Waiters.java
 *
 * Created on 24 avril 2000, 15:37
 */
 
package epe.synchronization.waiters;

import java.util.Vector;

import epe.agents.Agent;

/** 
 *
 * @author  Jean-Pierre Georg?
 * @version 
 */
public class Waiters extends Vector<Object> {
  
  private static final long serialVersionUID = 1L;

  /** Creates new Waiters */
  public Waiters() {
  }
  
  public void addWaiter(Waiter waiter) {
    addElement(waiter);
  }
  
  public void removeWaiter(Waiter waiter) {
    removeElement(waiter);
  }
  
  public void removeWaiter(Agent agent) {
    int i = 0;
    while (i < size()) {
      Waiter waiter = (Waiter)elementAt(i);
      if (waiter.getAgent().equals(agent)) {
        removeElementAt(i);
      }
      else
        i++;
    }
  }
  
  public void  setReady(Agent sender) {
    boolean setReady = false;
    int i = 0;
    while (!setReady &&  i < size()) {
      Waiter waiter = (Waiter)elementAt(i);
      if (waiter.getAgent().equals(sender)
          && !waiter.isReady()) {
        setReady = true;
        waiter.setReady();
      }
      i++;
    }
  }
  
  public void  setNotReady(Agent sender) {
    for (int i=0; i < size(); i++) {
      Waiter waiter = (Waiter)elementAt(i);
      if (waiter.getAgent().equals(sender))
        waiter.setNotReady();
    }
  }
  
  public void  setNotReady(Waiter readyWaiter) {
    for (int i=0; i < size(); i++) {
      Waiter waiter = (Waiter)elementAt(i);
      if (waiter.equals(readyWaiter))
        waiter.setNotReady();
    }
  }
  
  public void setAllNotReady() {
    for (int i=0; i < size(); i++) {
      Waiter waiter = (Waiter)elementAt(i);
      waiter.setNotReady();
    }
  }
  
}